commit fe532923101586e316b300d419a337d357cd93da
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 20:47:58 2019 -0500

    [CI] Peg CircleCI badge link to master branch

    [skip ci]

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9569819e24f72926a5b26e4c8a86d815c0132745
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 20:43:43 2019 -0500

    [ci] Peg build status badges to master branch

    [skip ci]

 README.md | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 1e29906a77c275c34a440a416654a514810485e1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 20:38:15 2019 -0500

    Switch README / README.md

    [skip ci]

 README    | 19 +------------------
 README.md | 19 ++++++++++++++++++-
 2 files changed, 19 insertions(+), 19 deletions(-)

commit 9a1df82e3f13fbd4488ee9955814bbb5d0957074
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 14:15:18 2019 -0500

    [uniscribe] Whitelist function type cast

 src/hb-uniscribe.cc | 3 +++
 1 file changed, 3 insertions(+)

commit 6e1c3eaf7005d06c89f0807f693aadd835aa0468
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 14:12:41 2019 -0500

    Fix sign comparison error

 src/hb-open-file.hh | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 9db7a7da6339eacbb6c699fa1939bbd7e9e148f5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 14:09:59 2019 -0500

    Fix warning

    c:\projects\harfbuzz\src\hb-ot-color-cbdt-table.hh(59): warning C4146:
    unary minus operator applied to unsigned type, result still unsigned
    [C:\projects\harfbuzz\build\harfbuzz.vcxproj]

 src/hb-ot-color-cbdt-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 51b584880e550545ced3aa8ba4ccad3cf79bb53e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 14:09:45 2019 -0500

    [pragma] Silence MSVC unknown-pragma warning

 src/hb.hh | 3 +++
 1 file changed, 3 insertions(+)

commit 60022ecced202760daa7f75516bba6a4689a49de
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Jan 26 14:04:51 2019 +0100

    Fix -Wcast-function-type warnings in util/ with gcc 4.8

 src/hb.hh       | 1 +
 util/options.hh | 5 ++++-
 2 files changed, 5 insertions(+), 1 deletion(-)

commit a9321cb5f88cae1dafbd623b8bf7c68a82a3c211
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 16:11:45 2019 +0100

    Fix mac test

 test/shaping/data/in-house/tests/macos.tests | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f39809752909f193a9c60f4357a88ea1c3ce1162
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 16:08:25 2019 +0100

    More static constexpr

 src/hb-machinery.hh  | 10 +++++-----
 src/hb-set-digest.hh | 14 +++++++-------
 2 files changed, 12 insertions(+), 12 deletions(-)

commit 06358ae9746ae72c0917e8a5f294d14fd695f380
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 15:11:47 2019 +0100

    [AAT] Add test for recent Ligature stack fix, using Zapfino on Mac

 test/shaping/data/in-house/tests/macos.tests | 2 ++
 1 file changed, 2 insertions(+)

commit e970de48bcbdccd29350f331288c0a98f7846c16
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 18:16:17 2019 +0100

    [AAT] Minor sign

 src/hb-aat-layout-morx-table.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a371a28cda23805cbea22867e0a3ed53ecb811ed
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 18:12:25 2019 +0100

    [AAT] Use a ring buffer for ligature stack

    I think Apple does very similarly, but probably with a stack size
    of 16.
    We do it with a stack size that is currently set to 64.

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1531

 src/hb-aat-layout-morx-table.hh | 15 ++++++---------
 1 file changed, 6 insertions(+), 9 deletions(-)

commit 7886b1578fceee368ae5afe206ff98f50e1c42e3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 18:06:17 2019 +0100

    Whitespace

 src/hb-aat-layout-morx-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b976940243bf1f174bd6abb85955789ef2631d24
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 18:01:07 2019 +0100

    [AAT] Handle transition errors during machine operation

    Before we used to give up.  Now, just ignore error and continue
    processing.

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1531

 src/hb-aat-layout-common.hh     |  3 +--
 src/hb-aat-layout-kerx-table.hh | 21 +++++++--------------
 src/hb-aat-layout-morx-table.hh | 34 +++++++++++++---------------------
 3 files changed, 21 insertions(+), 37 deletions(-)

commit e234bb6a428cd6c8ddf57eb078cd51b9d1f25ba8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 17:23:11 2019 +0100

    [AAT] Ignore machine errors and continue

 src/hb-aat-layout-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1ec90514f69efc329691186466f62373efa863b1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 17:21:41 2019 +0100

    [AAT] Minor

 src/hb-aat-layout-common.hh     | 12 ++++----
 src/hb-aat-layout-kerx-table.hh | 38 +++++++++++------------
 src/hb-aat-layout-morx-table.hh | 68
 ++++++++++++++++++++---------------------
 3 files changed, 59 insertions(+), 59 deletions(-)

commit 299eca0c3b28c99add006420bc667431d874fb2e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 17:17:00 2019 +0100

    [AAT] Handle out-of-bounds classes

 src/hb-aat-layout-common.hh | 13 ++++++-------
 1 file changed, 6 insertions(+), 7 deletions(-)

commit c4623db4a3f963394db940449007fa3312460993
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 17:10:12 2019 +0100

    [AAT] Minor

 src/hb-aat-layout-common.hh | 11 ++++-------
 1 file changed, 4 insertions(+), 7 deletions(-)

commit c4e36f97b6df1eb5fba588b09ae1630bb5c49589
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 17:06:16 2019 +0100

    [AAT] Minor

 src/hb-aat-layout-common.hh | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit f60282c5bff4a317ba3180e3519274963c6e8849
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 16:29:09 2019 +0100

    More pragma control

    Fixes https://bugs.chromium.org/p/chromium/issues/detail?id=924848

 src/hb.hh | 16 +++++++++++++++-
 1 file changed, 15 insertions(+), 1 deletion(-)

commit fd0889f903ac1ba2da06e77eed8424395ea85a90
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 16:12:52 2019 +0100

    Comment

 src/hb-ot-shape.cc | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 00f06d1aa61e9a6d01b5943ce55ba2b0c40237ee
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 16:11:05 2019 +0100

    Fix test

 test/shaping/data/in-house/tests/cluster.tests | 1 -
 test/shaping/data/in-house/tests/emoji.tests   | 3 ++-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 9f314177336f9551756944e0e555614c9189c7a5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 16:08:33 2019 +0100

    Form cluster for Emoji sub-region tag sequences

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1556

 src/hb-ot-shape.cc                                       |  13
 +++++++++++++
 .../fonts/8d9c4b193808b8bde94389ba7831c1fc6f9e794e.ttf   | Bin 0 ->
 1548 bytes
 test/shaping/data/in-house/tests/cluster.tests           |   1 +
 3 files changed, 14 insertions(+)

commit 5034f8f2ab8f53eb0395e6f6ce2f8da69a08460d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 12:50:38 2019 +0100

    Fix macos tests with previous commit

 test/shaping/data/in-house/tests/macos.tests | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 3ecda71041a7239ca37ec7b888809efe8f595a19
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 12:08:23 2019 +0100

    Adjust mark offsets when zeroing from fallback mark positioning code

    Adjust tests.

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1532

 src/hb-ot-shape-fallback.cc                        | 31
 +++++++++++++++-------
 src/hb-ot-shape-fallback.hh                        |  3 ++-
 src/hb-ot-shape.cc                                 |  3 ++-
 .../in-house/tests/arabic-fallback-shaping.tests   |  2 +-
 test/shaping/data/in-house/tests/cluster.tests     |  2 +-
 .../data/in-house/tests/fallback-positioning.tests |  4 +--
 6 files changed, 30 insertions(+), 15 deletions(-)

commit 36fb2b4da9718a86978fa07c99ba4345f7ca9b4b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jan 23 20:53:57 2019 +0100

    [AAT] In InsertionChain, set mark to previous-position if inserting

    Fixes MORX-31

 src/hb-aat-layout-morx-table.hh | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit cbe0ed117ac86179183c389977d15981d26524f7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jan 23 20:45:18 2019 +0100

    [AAT] Re-enable tests MORX-31 and MORX-41

 test/shaping/data/text-rendering-tests/DISABLED         | 3 ---
 test/shaping/data/text-rendering-tests/Makefile.sources | 2 ++
 2 files changed, 2 insertions(+), 3 deletions(-)

commit baf4d6a68a031bf65e17ccd5dac15fe7d0df33b6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jan 23 20:36:07 2019 +0100

    [AAT] Remove mark_set from InsertionChain

 src/hb-aat-layout-morx-table.hh | 7 +------
 1 file changed, 1 insertion(+), 6 deletions(-)

commit 410731d3fb678365c07a4d1745b72b6bb3142b70
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jan 23 20:30:48 2019 +0100

    [test/text-rendering-tests] Update from upstream

 test/shaping/data/text-rendering-tests/extract-tests.py    | 2 +-
 test/shaping/data/text-rendering-tests/tests/MORX-14.tests | 2 +-
 test/shaping/data/text-rendering-tests/tests/MORX-32.tests | 8 ++++----
 test/shaping/data/text-rendering-tests/tests/MORX-41.tests | 4 ++--
 4 files changed, 8 insertions(+), 8 deletions(-)

commit 0b2fa342de88bbe609b2147444e56c94680cbd38
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 16:36:00 2019 +0100

    More of previous

 src/hb-subset-cff1.cc | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit a5e5dd8b42b40c3647e06e6bb62580af77bed42b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 16:30:07 2019 +0100

    Fix sign-compare error resulted from promoting unsigned integers to
    signed larger ints

    Clang and gcc know not to warn in these cases, but not nonmainstream
    compilers

 src/hb-subset-cff2.cc | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 32379bbf10726bb7ed2e507d0a6b5917c350e056
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:55:29 2019 +0100

    Cast HB_UNTAG results to uint8_t

 src/hb-common.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 83d4aa5ca9a39dbe66db9b81b34f5b568503bd7e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:52:23 2019 +0100

    More -Wcast-error fix

 src/hb-dsalgs.hh | 3 +++
 1 file changed, 3 insertions(+)

commit 447323b85a7b68bd41561a87c91431cd05227b97
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:45:40 2019 +0100

    Better fix for -Wcast-align errors

 src/hb-font.cc          | 33 +++++++++------------------------
 src/hb-ft.cc            | 14 ++++----------
 src/hb-machinery.hh     | 16 ++++++++++++++++
 src/hb-ot-cmap-table.hh |  7 ++-----
 src/hb-ot-font.cc       | 14 ++++----------
 5 files changed, 35 insertions(+), 49 deletions(-)

commit 81ec543d800c4a94b5e608fd87e84d33d7dae8ac
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:43:12 2019 +0100

    More -Wcast-error fixes

 src/hb-font.cc    | 8 ++++----
 src/hb-ft.cc      | 2 +-
 src/hb-ot-font.cc | 4 ++--
 3 files changed, 7 insertions(+), 7 deletions(-)

commit 90772725493108c79487a67620f0240e5d68f4ee
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:40:18 2019 +0100

    pragma GCC diagnostic error   "-Wsign-compare"

 src/hb.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8d05bf7dc0094e75be07ca1f7ef852a1e45d0687
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:34:05 2019 +0100

    Fix cast-align error

    If compiler doesn't inline StructAtOffset, this was an error since we
    only disable cast-align at call-site.  So, move the cast out.

    ../src/hb-machinery.hh: In instantiation of 'const Type&
    StructAtOffset(const void*, unsigned int) [with Type = unsigned int]':
    ../src/hb-font.cc:146:85:   required from here
    ../src/hb-machinery.hh:63:12: error: cast from 'const char*' to
    'const unsigned int*' increases required alignment of target type
    [-Werror=cast-align]
     { return * reinterpret_cast<const Type*> ((const char *) P +
     offset); }
                ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ../src/hb-machinery.hh: In instantiation of 'Type&
    StructAtOffset(void*, unsigned int) [with Type = unsigned int]':
    ../src/hb-font.cc:147:79:   required from here
    ../src/hb-machinery.hh:66:12: error: cast from 'char*' to 'unsigned
    int*' increases required alignment of target type [-Werror=cast-align]
     { return * reinterpret_cast<Type*> ((char *) P + offset); }
                ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 src/hb-font.cc          | 8 ++++----
 src/hb-ft.cc            | 6 +++---
 src/hb-ot-cmap-table.hh | 4 ++--
 src/hb-ot-font.cc       | 4 ++--
 4 files changed, 11 insertions(+), 11 deletions(-)

commit b270cee6c5800c019aafb55e9ca9d7e92a92d3ec
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:29:05 2019 +0100

    [CI] Remove gcc 4.2 bots

    We don't support that version anymore.

 .circleci/config.yml | 25 -------------------------
 1 file changed, 25 deletions(-)

commit 70a52d6bd8c45630ca90e945fc4d716fe9114010
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:15:23 2019 +0100

    Convert all other enum class consts to static constexpr

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1553

 src/hb-cff-interp-common.hh |  2 +-
 src/hb-iter.hh              |  2 +-
 src/hb-machinery.hh         | 12 ++++++------
 src/hb-open-type.hh         |  8 ++++----
 src/hb-set-digest.hh        |  4 ++--
 src/hb-set.hh               | 10 +++++-----
 src/hb-vector.hh            |  2 +-
 7 files changed, 20 insertions(+), 20 deletions(-)

commit 5d4b0377b99ddc4112b8ffb2b787eac0b383081c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:11:24 2019 +0100

    Convert unsigned enum class consts to static constexpr

    Part of https://github.com/harfbuzz/harfbuzz/issues/1553

 src/hb-aat-layout-common.hh     | 6 +++---
 src/hb-aat-layout-kerx-table.hh | 2 +-
 src/hb-buffer.hh                | 2 +-
 src/hb-open-type.hh             | 2 +-
 src/hb-ot-kern-table.hh         | 4 ++--
 src/hb-ot-layout-common.hh      | 2 +-
 src/hb-ot-layout.cc             | 4 ++--
 7 files changed, 11 insertions(+), 11 deletions(-)

commit ef00654962204ae706b276871e2b6758fbbf69e0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:08:57 2019 +0100

    Convert tag enum class consts to static constexpr

    Part of https://github.com/harfbuzz/harfbuzz/issues/1553

 src/hb-aat-fdsc-table.hh        |  2 +-
 src/hb-aat-layout-ankr-table.hh |  2 +-
 src/hb-aat-layout-bsln-table.hh |  2 +-
 src/hb-aat-layout-feat-table.hh |  2 +-
 src/hb-aat-layout-just-table.hh |  2 +-
 src/hb-aat-layout-kerx-table.hh |  2 +-
 src/hb-aat-layout-lcar-table.hh |  2 +-
 src/hb-aat-layout-morx-table.hh |  6 +++---
 src/hb-aat-layout-trak-table.hh |  2 +-
 src/hb-aat-ltag-table.hh        |  2 +-
 src/hb-ot-cff1-table.hh         |  2 +-
 src/hb-ot-cff2-table.hh         |  2 +-
 src/hb-ot-cmap-table.hh         |  2 +-
 src/hb-ot-color-cbdt-table.hh   |  4 ++--
 src/hb-ot-color-colr-table.hh   |  2 +-
 src/hb-ot-color-cpal-table.hh   |  2 +-
 src/hb-ot-color-sbix-table.hh   |  2 +-
 src/hb-ot-color-svg-table.hh    |  2 +-
 src/hb-ot-gasp-table.hh         |  2 +-
 src/hb-ot-glyf-table.hh         |  4 ++--
 src/hb-ot-hdmx-table.hh         |  2 +-
 src/hb-ot-head-table.hh         |  2 +-
 src/hb-ot-hhea-table.hh         |  4 ++--
 src/hb-ot-hmtx-table.hh         | 12 ++++++------
 src/hb-ot-kern-table.hh         |  6 +++---
 src/hb-ot-layout-base-table.hh  |  2 +-
 src/hb-ot-layout-gdef-table.hh  |  2 +-
 src/hb-ot-layout-gpos-table.hh  |  2 +-
 src/hb-ot-layout-gsub-table.hh  |  2 +-
 src/hb-ot-layout-jstf-table.hh  |  2 +-
 src/hb-ot-math-table.hh         |  2 +-
 src/hb-ot-maxp-table.hh         |  2 +-
 src/hb-ot-name-table.hh         |  2 +-
 src/hb-ot-os2-table.hh          |  2 +-
 src/hb-ot-post-table.hh         |  2 +-
 src/hb-ot-stat-table.hh         |  2 +-
 src/hb-ot-var-avar-table.hh     |  2 +-
 src/hb-ot-var-fvar-table.hh     |  2 +-
 src/hb-ot-var-hvar-table.hh     |  8 ++++----
 src/hb-ot-var-mvar-table.hh     |  2 +-
 src/hb-ot-vorg-table.hh         |  2 +-
 41 files changed, 56 insertions(+), 56 deletions(-)

commit 39e1b6d03f71ccb8f18d64dfbff64acfaf02970b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:07:43 2019 +0100

    Convert boolean enum class consts to static constexpr

    Part of https://github.com/harfbuzz/harfbuzz/issues/1553

 src/hb-aat-layout-common.hh     |  4 ++--
 src/hb-aat-layout-kerx-table.hh |  4 ++--
 src/hb-aat-layout-morx-table.hh |  8 ++++----
 src/hb-dsalgs.hh                | 16 ++++++++--------
 src/hb-ot-kern-table.hh         |  4 ++--
 src/hb-ot-layout.cc             |  4 ++--
 6 files changed, 20 insertions(+), 20 deletions(-)

commit 271cb7c1c0f49c7af786daa5d5310b9f08142148
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:05:35 2019 +0100

    Make some enum constants unsigned

 src/hb-aat-layout-common.hh | 6 +++---
 src/hb-buffer.hh            | 2 +-
 src/hb-ot-layout.cc         | 8 ++++----
 3 files changed, 8 insertions(+), 8 deletions(-)

commit 3d9a6e62662fb769e0f785fa7a43df806988d2a2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:02:06 2019 +0100

    Whitespace

 src/hb-ot-layout-gsubgpos.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c81f02fd06fcbc4426c9e3255833f8d7057cc97a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:00:44 2019 +0100

    pragma GCC diagnostic error   "-Wvla"

 src/hb.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ff98109455bfbf92f7633262bc570b05d15d5d01
Author: Alfie John <alfie@alfie.wtf>
Date:   Tue Jan 22 19:58:36 2019 +1100

    Fix grammar

 docs/usermanual-clusters.xml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e9c0f5e714cc62bcf6349b86b13e1c031f9bb764
Author: Alfie John <alfie@alfie.wtf>
Date:   Tue Jan 22 00:03:02 2019 +0000

    Grammar fix

 docs/usermanual-clusters.xml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 789396ed6bf2c76c1bb955e80efb43f75e3c61d2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 20 20:09:10 2019 -0500

    Remove wrongly added files

 test/api/test-ot-extents-cff                        | Bin 8574336 ->
 0 bytes
 .../test-ot-extents-cff.dSYM/Contents/Info.plist    |  20
 --------------------
 .../Contents/Resources/DWARF/test-ot-extents-cff    | Bin 7650053 ->
 0 bytes
 3 files changed, 20 deletions(-)

commit 380c3cffb9353083913a3bb505c2c62367613096
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 20 19:51:08 2019 -0500

    Use enum for class constant

 src/hb-cff-interp-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6d042a18e7079e07a2b2f465a6a56483a42ef189
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 20 19:49:59 2019 -0500

    [CFF] Use enum for tableTag

 src/hb-ot-cff1-table.hh | 2 +-
 src/hb-ot-cff2-table.hh | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit c1cbbb94595641f0609cc8d2dbe8415540c10f77
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 20 19:47:52 2019 -0500

    Use static constexpr for large class constants

 src/hb-map.hh | 2 +-
 src/hb-set.hh | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 30ae62779f1a68c5657ab27bc7e77496ba8a906c
Author: Khaled Hosny <khaledhosny@eglug.org>
Date:   Mon Jan 21 16:44:48 2019 +0200

    Regular spaces will do

 docs/usermanual-getting-started.xml | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit ed62551d67ac5bb8dbfaf3fa5eb51013157b214a
Author: Alfie John <alfie@alfie.wtf>
Date:   Mon Jan 21 05:00:01 2019 +0000

    Adding leading space for code example

 docs/usermanual-getting-started.xml | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 3e332544db35ca08de767ecab01b489a9905c559
Author: Alfie John <alfie@alfie.wtf>
Date:   Mon Jan 21 04:54:27 2019 +0000

    Fix description of example

 docs/usermanual-getting-started.xml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2144ca9f01d01b6de386d17ada73a288372ee553
Author: Alfie John <alfie@alfie.wtf>
Date:   Mon Jan 21 04:47:05 2019 +0000

    Added option to build docs to docs

 docs/usermanual-install-harfbuzz.xml | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit 043b610fa698ed247347dfaa042f032f3fd3f572
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Jan 19 09:20:46 2019 -0500

    Fix sign compare warnings

    ../../third_party/harfbuzz-ng/src/src/hb-map.hh(56,45):  warning:
    comparison of integers of different signs: 'const hb_codepoint_t'
    (aka 'const unsigned int') and 'hb_map_t::(anonymous enum
    at ../../third_party/harfbuzz-ng/src/src/hb-map.hh:169:3)'
    [-Wsign-compare]
        bool is_unused () const    { return key == INVALID; }

 src/hb-map.hh | 2 +-
 src/hb-set.hh | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit ce317d032061d81c520180a338172ce38b427135
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Jan 19 09:18:03 2019 -0500

    Fix warning

    warning: '_WIN64' is not defined, evaluates to 0 [-Wundef]

 src/hb-dsalgs.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 0c2bd1b160fda4e77919889ac80f9460967fa251
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Jan 19 16:30:07 2019 +0330

    [dwrite] Fix delete-non-virtual-dtor warning (#1550)

 src/hb-directwrite.cc | 4 ++++
 1 file changed, 4 insertions(+)

commit 89bcfb204c736f5962d377896af2c1350f179882
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 14:59:18 2019 -0500

    Remove TRACE_COLLECT_GLYPHS

 src/hb-debug.hh                | 13 -------------
 src/hb-ot-layout-gpos-table.hh | 26 ++++----------------------
 src/hb-ot-layout-gsub-table.hh | 21 +++------------------
 src/hb-ot-layout-gsubgpos.hh   | 12 +-----------
 4 files changed, 8 insertions(+), 64 deletions(-)

commit f13b6786f0aefd2060ca976f7e42db7387b49450
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 14:53:54 2019 -0500

    [pragma] Only add if GCC or clang

 src/hb.hh | 3 +++
 1 file changed, 3 insertions(+)

commit c2ea7a9da463c567d321233b23813c59762841bb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 13:45:33 2019 -0500

    [directwrite] More fix

 src/hb-directwrite.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 9714d3ec5c45b2fe460fa6b21bdb3487c62029d3
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Jan 18 21:55:21 2019 +0330

    [dwrite] Try to fix delete-non-virtual-dtor warnings

    Fixes #1548 hopefully

 src/hb-directwrite.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 0772c06f96c3f5a319485c390416531b8125251b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 12:53:06 2019 -0500

    Remove tracing from closure

 src/hb-debug.hh                | 13 -------------
 src/hb-ot-layout-gsub-table.hh | 15 ++-------------
 src/hb-ot-layout-gsubgpos.hh   | 14 +-------------
 3 files changed, 3 insertions(+), 39 deletions(-)

commit d9f6be3a61edfe9e1bce01ea9b11e2bcb16f9618
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 12:48:01 2019 -0500

    Fix -Wundef errors with __GNUC__

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1549

 src/hb-common.h |  4 ++--
 src/hb.hh       | 10 +++++-----
 2 files changed, 7 insertions(+), 7 deletions(-)

commit 28917e58f973e5875d3ef3004c16e1ee1a5a973c
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Jan 18 09:43:51 2019 -0800

    init interp_env_t::hintmask_size

    fixes issue #1547

 src/hb-cff-interp-cs-common.hh                      |   1 +
 test/api/test-ot-extents-cff                        | Bin 0 ->
 8574336 bytes
 .../test-ot-extents-cff.dSYM/Contents/Info.plist    |  20
 ++++++++++++++++++++
 .../Contents/Resources/DWARF/test-ot-extents-cff    | Bin 0 ->
 7650053 bytes
 4 files changed, 21 insertions(+)

commit 9b4e51b2e44d7dea026b1f9201d2f83277bab1cf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 12:23:02 2019 -0500

    [pragma] Enable error -Wdelete-non-virtual-dtor

    Currently fails directwrite backend.

 src/hb.hh | 1 +
 1 file changed, 1 insertion(+)

commit e65272281c71d416f0ff886a55536597665b9dc3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 12:22:07 2019 -0500

    [directwrite] Fix error

    hb-directwrite.cc: In constructor 'TextAnalysis::TextAnalysis(const
    wchar_t*, uint32_t, const wchar_t*, DWRITE_READING_DIRECTION)':
    hb-directwrite.cc:489:18: error: 'TextAnalysis::mText' will be
    initialized after [-Werror=reorder]
       const wchar_t* mText;
                      ^~~~~
    hb-directwrite.cc:488:12: error:   'uint32_t
    TextAnalysis::mTextLength' [-Werror=reorder]
       uint32_t mTextLength;
                ^~~~~~~~~~~
    hb-directwrite.cc:282:3: error:   when initialized here
    [-Werror=reorder]
       TextAnalysis (const wchar_t* text, uint32_t textLength,
       ^~~~~~~~~~~~
    hb-directwrite.cc: In function 'hb_bool_t
    _hb_directwrite_shape_full(hb_shape_plan_t*, hb_font_t*, hb_buffer_t*,
    const hb_feature_t*, unsigned int, float)':

 src/hb-directwrite.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b900f78088abb87ebec263474b2802593afa0264
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 10:08:23 2019 -0500

    [pragma] More cast-align whitelist

 src/hb-font.cc          | 20 +++++++++++++++-----
 src/hb-ft.cc            |  6 ++++++
 src/hb-ot-cmap-table.hh |  3 +++
 src/hb-ot-font.cc       |  6 ++++++
 4 files changed, 30 insertions(+), 5 deletions(-)

commit 0d8b931bbeee9743d2e3bd37dd2fa9dffb807eaa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 10:03:43 2019 -0500

    [pragma] Allow cast-align in hb-font.cc

    ../src/hb-machinery.hh: In instantiation of 'const Type&
    StructAtOffset(const void*, unsigned int) [with Type = unsigned int]':
    ../src/hb-font.cc:144:85:   required from here
    ../src/hb-machinery.hh:63:12: error: cast from 'const char*' to
    'const unsigned int*' increases required alignment of target type
    [-Werror=cast-align]
     { return * reinterpret_cast<const Type*> ((const char *) P +
     offset); }
                ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ../src/hb-machinery.hh: In instantiation of 'Type&
    StructAtOffset(void*, unsigned int) [with Type = unsigned int]':
    ../src/hb-font.cc:145:79:   required from here
    ../src/hb-machinery.hh:66:12: error: cast from 'char*' to 'unsigned
    int*' increases required alignment of target type [-Werror=cast-align]
     { return * reinterpret_cast<Type*> ((char *) P + offset); }
                ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ../src/hb-machinery.hh: In instantiation of 'Type&
    StructAtOffset(void*, unsigned int) [with Type = int]':

 src/hb-font.cc | 5 +++++
 1 file changed, 5 insertions(+)

commit a25174a56b8fc334a050aa63be3654f53a7d8893
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 09:59:36 2019 -0500

    [pragma] GCC diagnostic error   "-Wreorder"

 src/hb.hh | 1 +
 1 file changed, 1 insertion(+)

commit 4660090569efbf64d3acc99ef6fa33e01abc9701
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 09:53:16 2019 -0500

    [pragma] GCC diagnostic warning "-Wmaybe-uninitialized"

 src/hb.hh | 1 +
 1 file changed, 1 insertion(+)

commit 7a634d7d5b859eb1121acd0b17c727c541a7f540
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 09:49:14 2019 -0500

    [pragma] Massage more

 src/hb.hh | 106
 ++++++++++++++++++++++++++++++++------------------------------
 1 file changed, 55 insertions(+), 51 deletions(-)

commit 16e5ba85b1822ff9d2b2f85f45ddd44f1a05f4b1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 09:46:17 2019 -0500

    [pragma] More

 src/hb.hh | 17 ++++++++++++++++-
 1 file changed, 16 insertions(+), 1 deletion(-)

commit 2bd530d59883cce437a5093323625f94b9618d89
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 09:28:22 2019 -0500

    [pragma] Reorg again

    https://github.com/harfbuzz/harfbuzz/issues/1546

 src/hb.hh | 91
 ++++++++++++++++++++++++++++++++-------------------------------
 1 file changed, 46 insertions(+), 45 deletions(-)

commit c04272fac81cac48b6310182d58d54569117f298
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 18 08:49:45 2019 -0500

    [pragma] GCC diagnostic ignored "-Wunknown-warning-option"

    Try at fixing https://github.com/harfbuzz/harfbuzz/issues/1546

 src/hb.hh | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 4d3c8f9685b1744077ab264ffc0e0457d63c4b9a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 19:58:54 2019 -0500

    [uniscribe] More warnings

 src/hb-uniscribe.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 6a5d2b21d8457001a59537e85596461feba3dbd5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 19:57:17 2019 -0500

    [uniscribe] Fix warnings

 src/hb-uniscribe.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 5b13e458c34d16fef6540a9389225e0597a99df5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 19:52:32 2019 -0500

    Fix build

 src/hb-directwrite.cc | 1 -
 1 file changed, 1 deletion(-)

commit a77bd6bb8960ecff35aac07f221653c65d08e58e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 19:33:41 2019 -0500

    [pragma] GCC diagnostic ignored "-Wclass-memaccess"

 src/hb.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e1302842d9c589ccbed90d29c953fea503d3901f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 19:12:07 2019 -0500

    [ci] Remove unnecessary warning declarations

    clang -Weverything still left to be ported to pragmas

 .circleci/config.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 436c7b294ab12ae338aaa879fe4280caae6c6155
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 19:03:33 2019 -0500

    [pragma] ignored -Wunsafe-loop-optimizations // TODO fix

 src/hb.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit e3b3181e9ddd8b76428d7eaca64a3e03a99fcdd5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 19:02:06 2019 -0500

    [pragma] error -Wclass-memaccess

 src/hb.hh | 1 +
 1 file changed, 1 insertion(+)

commit 1a6b97a491f2ba4f84e52c89517b7a02faa70cc3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 18:55:03 2019 -0500

    [pragma] More

 src/hb.hh | 11 ++++++++++-
 1 file changed, 10 insertions(+), 1 deletion(-)

commit 06e8091661352873c4d6040fd06a940136497e6f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 18:47:32 2019 -0500

    [pragma] More

 src/hb.hh | 18 +++++++++++++++++-
 1 file changed, 17 insertions(+), 1 deletion(-)

commit 1077e40bf12f998976df4bf509c69df9f9e2a590
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 18:36:10 2019 -0500

    [pragma] Flesh out more

 src/hb.hh | 22 +++++++++++++++++-----
 1 file changed, 17 insertions(+), 5 deletions(-)

commit 7e6bd510fc695c423a7fa6b25c15805482f7d185
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 18:24:18 2019 -0500

    Use NNOffsetTo<> in rest of places

 src/hb-aat-layout-common.hh     |  8 ++++----
 src/hb-aat-layout-kerx-table.hh | 22 +++++++++++-----------
 src/hb-aat-layout-morx-table.hh | 10 +++++-----
 3 files changed, 20 insertions(+), 20 deletions(-)

commit b1152d5e66d7463a30af8ca2a485f75e0c8e6ffd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 18:17:04 2019 -0500

    Use NNOffsetTo<>

 src/hb-aat-layout-ankr-table.hh |  6 +++---
 src/hb-aat-layout-trak-table.hh |  2 +-
 src/hb-aat-ltag-table.hh        |  2 +-
 src/hb-open-file.hh             | 10 +++++-----
 src/hb-ot-cff2-table.hh         |  6 +++---
 src/hb-ot-color-cbdt-table.hh   |  2 +-
 src/hb-ot-color-colr-table.hh   |  4 ++--
 src/hb-ot-color-cpal-table.hh   |  8 ++++----
 src/hb-ot-color-svg-table.hh    |  2 +-
 src/hb-ot-name-table.hh         |  2 +-
 src/hb-ot-stat-table.hh         |  4 ++--
 11 files changed, 24 insertions(+), 24 deletions(-)

commit 205d72a198805ba276c1d0e63b1ca313c7bd517f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 18:10:38 2019 -0500

    Add NNOffsetTo<>

 src/hb-open-type.hh | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit c99d13d860e3d34e16cd2c070070d4f5d7d58cf4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 17:56:27 2019 -0500

    [AAT] Comment

 src/hb-aat-layout-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f39b5603ffa0452528b2366f8641e7e770960847
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 17:49:55 2019 -0500

    Comment

 src/hb-ot-layout-gpos-table.hh | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 347ad454b88b89fc4bc30fca86c9ca37bea0be5b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 17:47:29 2019 -0500

    [AAT] Remove unused code

 src/hb-aat-layout-ankr-table.hh |  3 +--
 src/hb-aat-layout-common.hh     |  3 +--
 src/hb-aat-layout-kerx-table.hh |  6 ++----
 src/hb-aat-layout.cc            | 14 +++-----------
 4 files changed, 7 insertions(+), 19 deletions(-)

commit b344d4385af5bc9adac2a24850cb963929d4ae9e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 17:44:39 2019 -0500

    [AAT] Allow null in ankr lookupTable offset

 src/hb-aat-layout-ankr-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 14a560a245109376b7314c949895968d0a54452c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 17:42:44 2019 -0500

    [pragma GCC] Ignore -Wtype-limits

 src/hb.hh | 1 +
 1 file changed, 1 insertion(+)

commit 41b4312e936a0dfc396e6f0ef13c2c691dac6e40
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 16:07:27 2019 -0500

    [ci] Remove -Werror from Travis

    hb-machinery.hh:111:37: warning: comparison of unsigned expression >=
    0 is always true [-Wtype-limits]

    Also ignore -Wtype-limits.

 .travis.yml | 2 --
 1 file changed, 2 deletions(-)

commit 3f2daae63073bd536bceb1ae71dffd3187afce11
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 15:27:31 2019 -0500

    More GCC pragmas

 src/hb.hh | 2 ++
 1 file changed, 2 insertions(+)

commit d6c5473e1f86cae7f1060abe18f73ccb8e536d6c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 15:22:46 2019 -0500

    Rename macro

 src/hb.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a9946b7cfef185d53304e804169d6e53e9d522a0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 15:22:28 2019 -0500

    Add more GCC warning pragmas

 src/hb.hh | 6 ++++++
 1 file changed, 6 insertions(+)

commit 868b0c0c2e2f1a2dea9b0d3c8eb6e56ded8b1a14
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 15:08:36 2019 -0500

    Move -Wcast-align to hb.hh

 configure.ac | 3 ---
 src/hb.hh    | 4 ++++
 2 files changed, 4 insertions(+), 3 deletions(-)

commit 8874eef8ff70de6416266d719fa74eec39e5d8f9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 15:04:44 2019 -0500

    Add pragram GCC diagnostic ignored "-Wunused-macros"

 src/gen-indic-table.py                 | 3 +++
 src/gen-use-table.py                   | 3 +++
 src/hb-blob.cc                         | 3 +++
 src/hb-ot-shape-complex-indic-table.cc | 3 +++
 src/hb-ot-shape-complex-use-table.cc   | 3 +++
 5 files changed, 15 insertions(+)

commit cc8e9a436fa408a1c63f4b9afb7643cea76a079c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 14:54:32 2019 -0500

    [AAT] Fully sanitize ankr table at sanitize time

    Third try to fix access. Followup
    6879efc2c1596d11a6a6ad296f80063b558d5e0f

    Fixes https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=12532
    Fixes https://bugs.chromium.org/p/chromium/issues/detail?id=922303

 src/hb-aat-layout-ankr-table.hh | 13 ++++---------
 1 file changed, 4 insertions(+), 9 deletions(-)

commit 6879efc2c1596d11a6a6ad296f80063b558d5e0f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 14:06:37 2019 -0500

    [AAT] Fix anchor bound checking, again

    Fixes https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=12532
    Fixes https://bugs.chromium.org/p/chromium/issues/detail?id=922303

 src/hb-aat-layout-ankr-table.hh                           |   3 ++-
 ...zz-testcase-minimized-harfbuzz_fuzzer-5166320261529600 | Bin 0 ->
 393 bytes
 ...zz-testcase-minimized-hb-shape-fuzzer-5667182741028864 | Bin 0 ->
 407 bytes
 3 files changed, 2 insertions(+), 1 deletion(-)

commit a262eb3d0b7009aabd9e0beebc77e5c0a2a65548
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 17 14:06:32 2019 -0500

    [aat] Minor

 src/hb-aat-layout-kerx-table.hh | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit c986ca15a6320d78471adf950394f391e8729b15
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 15 13:58:19 2019 -0500

    Improve overflow avoidance

    Better fix for 480406cd3ef9e5ab8476ddfa04498bf23906c508
    This way we behave the same on 32bit and 64bit archs.

 src/hb-machinery.hh | 10 +++-------
 1 file changed, 3 insertions(+), 7 deletions(-)

commit 0d2727f4fe734af146785df10a44e3505e410ba1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 14 18:23:17 2019 -0800

    fix FDSelect fuzzing bug (#1539)

    Rewrote struct FDSelect3_4.ranges as ArrayOf
    Updated FDSelect3_4::sanitize () to call ranges.sanitize ()
    nRanges now a function to return a reference to ranges.len

 src/hb-ot-cff-common.hh     | 29 +++++++++++++++--------------
 src/hb-subset-cff-common.cc |  2 +-
 2 files changed, 16 insertions(+), 15 deletions(-)

commit 9f6172d669d53abbf3bf2a3546429cb5036e3d5f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 14 20:45:31 2019 -0500

    Move _POSIX_SOURCE definition

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1308

 src/hb-blob.cc | 9 +++++++++
 src/hb.hh      | 4 ----
 2 files changed, 9 insertions(+), 4 deletions(-)

commit 91d774712fa76dd26c441526712bddddca5b4bdd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 14 15:31:31 2019 -0500

    [test] Add test for previous commit

 ...uzz-testcase-minimized-harfbuzz_fuzzer-5662548265009152 | Bin 0 ->
 28 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 480406cd3ef9e5ab8476ddfa04498bf23906c508
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 14 15:27:34 2019 -0500

    Fix assertion on address overflow

    Fixes https://bugs.chromium.org/p/chromium/issues/detail?id=917031

 src/hb-machinery.hh | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 7a6686a589ed6bf17a5af0b8012501e4d4ee2ded
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 14 15:09:14 2019 -0500

    [AAT] Fix mort ContextualSubtable offset access

    Fixes https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=12312

 src/hb-aat-layout-morx-table.hh                           |   3 ++-
 ...zz-testcase-minimized-hb-shape-fuzzer-5631444412530688 | Bin 0 ->
 336 bytes
 2 files changed, 2 insertions(+), 1 deletion(-)

commit a3fa7d33360a58df5333dbbd121328e580f08849
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 14 14:37:36 2019 -0500

    [AAT] Fix ankr table access

    Fixes https://bugs.chromium.org/p/chromium/issues/detail?id=918340

 src/hb-aat-layout-ankr-table.hh                          |   7 ++++---
 ...z-testcase-minimized-harfbuzz_fuzzer-5126525414014976 | Bin 0 ->
 1141 bytes
 2 files changed, 4 insertions(+), 3 deletions(-)

commit 760303d411b1561533f8f08c7c15db331c71ece8
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Jan 11 15:27:35 2019 -0800

    deleted a duplicate fontdicts_mod.fini() call (#1538)

 src/hb-subset-cff1.cc | 1 -
 1 file changed, 1 deletion(-)

commit 5110f3da9a4711a35bfb780ea06cda677cc00209
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Jan 9 16:01:11 2019 +0330

    Add an initial .clang-format config

    There are things can be improved on clang-format side I guess before
    the full assertion, but is the best we can get for now I guess.

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1536

 .clang-format | 38 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 38 insertions(+)

commit 099bca6d406af9c8e12a66b93fcc9a38ff7914f9
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Jan 9 15:56:32 2019 +0330

    Minor, hack .editorconfig for vscode use

    As VSCode and Atom https://github.com/Microsoft/vscode/issues/44438
    don't support it

 .editorconfig | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 7b48641aa8551115d21c534940ac4fb364e5ab92
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Jan 8 12:37:48 2019 -0800

    fix leak in subset_enc_supp_codes (#1537)

    oss-fuzz issue 12310

 src/hb-subset-cff1.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 97f67a3c3d499959d33e66aeed449e2957a14bc6
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Jan 4 23:10:39 2019 +0330

    [ci] Enable more of GCC compile warnings (#1533)

 .circleci/config.yml      | 16 ++++++++--------
 src/hb-gobject-structs.cc |  4 ++--
 2 files changed, 10 insertions(+), 10 deletions(-)

commit ad954870383a880262edcd01acd8e171c4614a68
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Mon Dec 3 12:49:44 2018 -0600

    Usermanual: small formatting and wording fixes.

 docs/usermanual-getting-started.xml  |  3 +++
 docs/usermanual-install-harfbuzz.xml | 30 ++++++++++++++----------------
 docs/usermanual-what-is-harfbuzz.xml | 11 ++++++-----
 3 files changed, 23 insertions(+), 21 deletions(-)

commit ed13caddf2de68312608e12c37d0e6287c1ac0a0
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Wed Nov 28 13:48:38 2018 -0600

    Usermanual: small updates.

 ...anual-buffers-language-script-and-direction.xml |   7 +-
 docs/usermanual-clusters.xml                       | 279
 ++++++++++++++++-----
 docs/usermanual-getting-started.xml                |  91 ++++++-
 docs/usermanual-install-harfbuzz.xml               |   3 +-
 docs/usermanual-shaping-concepts.xml               |  11 +-
 5 files changed, 314 insertions(+), 77 deletions(-)

commit 26c5b54fb09fb45e02c9c4618bcea4958c698953
Author: cclauss <cclauss@me.com>
Date:   Mon Dec 31 04:30:43 2018 +0100

    CircleCI: Test for Python 3 syntax errors and undefined names (#1522)

    Catch missing imports and errors like #1520 and #1521

    __E901,E999,F821,F822,F823__ are the "_showstopper_"
    [flake8](http://flake8.pycqa.org) issues that can halt the runtime
    with a SyntaxError, NameError, etc. Most other flake8 issues are
    merely "style violations" -- useful for readability but they do not
    effect runtime safety.
    * F821: undefined name `name`
    * F822: undefined name `name` in `__all__`
    * F823: local variable name referenced before assignment
    * E901: SyntaxError or IndentationError
    * E999: SyntaxError -- failed to compile a file into an Abstract
    Syntax Tree

 .circleci/config.yml             | 3 ++-
 src/gen-use-table.py             | 4 +++-
 test/subset/subset_test_suite.py | 2 +-
 3 files changed, 6 insertions(+), 3 deletions(-)

commit 686e6f2e40da378e031b4c9871a471599c6d61cf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 30 11:27:42 2018 -0500

    Fix automake warnings

    [skip ci]

 test/api/Makefile.am         | 1 -
 test/subset/data/Makefile.am | 2 +-
 2 files changed, 1 insertion(+), 2 deletions(-)

commit b5c12b9f4d2c32a5013c340f7e40649cb5f2b41a
Author: cclauss <cclauss@me.com>
Date:   Sun Dec 30 13:07:28 2018 +0100

    print() is a function in Python 3 (#1520)

 test/subset/generate-expected-outputs.py | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit f4da28b1f153ccf293b367363a1a4d83c056e4e1
Author: cclauss <cclauss@me.com>
Date:   Sun Dec 30 12:58:34 2018 +0100

    Python 3 fixes to gen-os2-unicode-ranges.py (#1521)

    In Python 3, __reload()__ was moved and __sys.setdefaultencoding()__
    because the default is already utf-8.  Also __Error()__ is an
    _undefined name_ and __Exception()__ creates a generic exception.

 src/gen-os2-unicode-ranges.py | 11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

commit e5989e0962309b27b2486d8fd20f3cbc05c3d79a
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sun Dec 30 10:23:47 2018 +0330

    [cmake] Enable C++11 on CMake (#1519)

 CMakeLists.txt | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit d092fb27198f24423e51ce07375ebd6d486f64d3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 30 01:53:03 2018 -0500

    Ouch! Fix build on C++<11

 src/hb.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 89949ed28db96edabeb09433fcc09f28168163d2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 30 01:52:19 2018 -0500

    Fix ubsan with passing nullptr to qsort()

 src/hb-array.hh | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit 357a0a7ad344caf898eb1697fcdb859d118b7a13
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 27 18:29:23 2018 -0500

    Fix build on C++ < 11

 src/hb.hh | 1 +
 1 file changed, 1 insertion(+)

commit 54c0a1731069a17ae4f3b79b419af75709f03f5b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 27 18:27:36 2018 -0500

    [vector] Fix warning

 src/hb-vector.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 1043ddbee878a14df0ad8d83fbaa893370ef5a75
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 27 18:27:11 2018 -0500

    [aat] Minor

 src/hb-aat-layout-morx-table.hh | 2 +-
 src/hb-aat-map.hh               | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 71da9ca62fa87bd3e0fa9d40924bb4c220313a03
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 27 18:01:06 2018 -0500

    [vector] Remove use of arrayZ() by using casts

 src/hb-ot-name-table.hh | 2 +-
 src/hb-ot-name.cc       | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit fa333e34d6230210bc73a88b0ba6df2102dcda51
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 27 17:56:22 2018 -0500

    [vector] Remove static_array

    Was good idea, but with C++ types with constructor/destructor,
    was getting in
    the way as compiler was destructing those items where it was not
    desired.
    Since C++ does not allow zero-sized arrays, just remove it...

 src/hb-aat-map.hh            |  4 ++--
 src/hb-cff-interp-common.hh  |  2 +-
 src/hb-face.cc               |  2 +-
 src/hb-object.hh             |  2 +-
 src/hb-ot-cff-common.hh      |  2 +-
 src/hb-ot-layout-gsubgpos.hh |  2 +-
 src/hb-ot-map.hh             | 10 +++++-----
 src/hb-ot-post-table.hh      |  2 +-
 src/hb-set.hh                |  4 ++--
 src/hb-vector.hh             | 34 +++++++++++-----------------------
 src/hb.hh                    |  3 +++
 11 files changed, 29 insertions(+), 38 deletions(-)

commit ab2258a419abbace9ff27916143b46f88e8ccef3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 27 17:45:05 2018 -0500

    [vector] Use allocated = -1 to signify failure

 src/hb-vector.hh | 16 +++++++++-------
 1 file changed, 9 insertions(+), 7 deletions(-)

commit 09fa536d89d969998fe6bbe274a9964c73d1d982
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Thu Dec 27 08:33:09 2018 -0800

    fix lealk with cff2::accelerator_templ_t::topDict (#1517)

 src/hb-ot-cff2-table.hh | 1 +
 1 file changed, 1 insertion(+)

commit 3b81442cd5c11099ae9245074d24ef679b4473fa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 24 11:31:04 2018 -0500

    [vector] Change pre-alloced count from 8 to 2

    I'm thinking about dropping it to zero, but that needs slight code
    changes.

 src/hb-vector.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d25a2f1496d13846ddaea123ac6fb9807dc5669a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 23 20:19:52 2018 -0500

    Fix a few warnings

 src/hb-aat-layout-common.hh | 12 ++++++------
 src/hb-iter.hh              |  8 ++++----
 src/hb-null.hh              |  2 +-
 src/hb-ot-cff1-table.hh     |  2 +-
 src/hb-ot-cff2-table.hh     |  2 +-
 src/hb-subset-cff-common.hh |  3 ++-
 src/hb.hh                   |  3 ++-
 7 files changed, 17 insertions(+), 15 deletions(-)

commit 85003b594b3aa1f6638e274bc89f18999a5de9f5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 22 16:19:10 2018 -0500

    [iter] Fix warning

 src/hb-iter.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e4355b1ca177200db6769136ead1ee25da86ec85
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 22 16:11:22 2018 -0500

    [set] Add iter_t as alias to const_iter_t

 src/hb-set.hh    | 6 ++++--
 src/test-iter.cc | 2 ++
 2 files changed, 6 insertions(+), 2 deletions(-)

commit 33f8de61863efa538c488121c476fd0e907020d0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 22 15:10:18 2018 -0500

    [set] Change to const_iter

 src/hb-set.hh | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit f88fed5cd8787e3deeec05dac4353337dc02abdd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 22 11:11:10 2018 -0500

    [set] Cache length in iterator

 src/hb-set.hh | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit d0a706c7fdb72a1d224b4a5bdbad0fb8c90e3186
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Dec 22 19:47:48 2018 +0330

    Minor, remove redundant inline

 src/hb-ot-layout.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit ae6e348d642194585543f0d548fb94d210575fe4
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Dec 22 19:47:29 2018 +0330

    Minor, tweak spaces

 src/hb-ot-glyf-table.hh     |  8 ++++----
 src/hb-subset-cff-common.hh | 15 ++++++---------
 2 files changed, 10 insertions(+), 13 deletions(-)

commit 29f0b6bce7da4c599f54066f7e7f6000f10d2f29
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Sat Dec 22 07:47:04 2018 -0800

    CFF renaming (#1507)

    * reimplement ByteStr as byte_str_t based on hb_ubytes_t

    Unuse start_embed<ByteStr>
    Also renamed SubByteStr to byte_str_ref_t
    More renaming to come

    * substr renamed to str_ref in line with its type byte_str_ref_t

    * uncamelize non-table struct names

    * uncamelized non-struct types OpCode etc

    * add byte_str_t copy ctor

    * test

    * test2

    * undo tests

    * fix bot failure

    * undo the previous change

    * fixed tabs, added inline

    * Revert "fixed tabs, added inline"

    This reverts commit 21163c30e9d18759414f7fe2518628241599f039.

    * fix tabs

 src/hb-cff-interp-common.hh      | 215 +++++++++++++++------------------
 src/hb-cff-interp-cs-common.hh   | 250
 +++++++++++++++++++--------------------
 src/hb-cff-interp-dict-common.hh |  64 +++++-----
 src/hb-cff1-interp-cs.hh         |  26 ++--
 src/hb-cff2-interp-cs.hh         |  56 ++++-----
 src/hb-ot-cff-common.hh          |  59 ++++-----
 src/hb-ot-cff1-table.cc          |  56 ++++-----
 src/hb-ot-cff1-table.hh          | 147 ++++++++++++-----------
 src/hb-ot-cff2-table.cc          |  28 ++---
 src/hb-ot-cff2-table.hh          | 128 ++++++++++----------
 src/hb-subset-cff-common.cc      |  10 +-
 src/hb-subset-cff-common.hh      | 232
 ++++++++++++++++++------------------
 src/hb-subset-cff1.cc            | 244
 +++++++++++++++++++-------------------
 src/hb-subset-cff2.cc            | 100 ++++++++--------
 14 files changed, 796 insertions(+), 819 deletions(-)

commit 89d04129e2f4dedb865635dcb8f0fd020e4218c2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 20:07:52 2018 -0500

    [set] Actually derive iterator from hb_sorted_iter_t<>

 src/hb-set.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fc35919d015c5b8d231933d6bc6ea640c83af6b2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 20:06:17 2018 -0500

    [set] Implement unified iterator

 src/hb-set.hh | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

commit 4911e67d2d2188ee9bdc0315e121e51d9967b567
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 20:00:52 2018 -0500

    [set] Mark some internals protected

 src/hb-set.hh | 2 ++
 1 file changed, 2 insertions(+)

commit 954b985422a8964f6e7da9f71ab7a68074017111
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 19:55:02 2018 -0500

    [iter] Add hb_sorted_iter_t<>

 src/hb-array.hh |  2 +-
 src/hb-iter.hh  | 11 +++++++++++
 2 files changed, 12 insertions(+), 1 deletion(-)

commit b205105c9e1c6295b17cfd88ffb8ca7d963ef173
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 19:48:21 2018 -0500

    [iter] Change operator[] operand to be signed

    To fix older compilers again (this was the case in hb_array_t).

    hb-ot-layout-common.hh:1353: note: candidate 2: operator[](T*,
    int) <built-in>
    hb-ot-layout-common.hh:1354: error: ISO C++ says that these are
    ambiguous, even though the worst conversion for the first is better
    than the worst conversion for the second:
    hb-iter.hh:63: note: candidate 1: Item& hb_iter_t<Iter,
    Item>::operator[](unsigned int) const [with Iter = hb_array_t<const
    OT::IntType<short unsigned int, 2u> >, Item = const OT::IntType<short
    unsigned int, 2u>]
    hb-ot-layout-common.hh:1354: note: candidate 2: operator[](T*,
    int) <built-in>
    hb-ot-layout-common.hh: In member function 'bool
    OT::ClassDef::serialize(hb_serialize_context_t*, hb_array_t<const
    OT::IntType<short unsigned int, 2u> >, hb_array_t<const
    OT::IntType<short unsigned int, 2u> >)':
    hb-ot-layout-common.hh:1490: error: ISO C++ says that these are
    ambiguous, even though the worst conversion for the first is better
    than the worst conversion for the second:
    hb-iter.hh:63: note: candidate 1: Item& hb_iter_t<Iter,
    Item>::operator[](unsigned int) const [with Iter = hb_array_t<const
    OT::IntType<short unsigned int, 2u> >, Item = const OT::IntType<short
    unsigned int, 2u>]
    hb-ot-layout-common.hh:1490: note: candidate 2: operator[](T*,
    int) <built-in>

 src/hb-iter.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 25786f49c1df36fdb5f78681055a1f4aa4b17f86
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 19:29:00 2018 -0500

    [array] Port to hb_iter_t<>

    hb_array_t is its own iterator...

 src/hb-array.hh | 75
 +++++++++++++++++++++++++--------------------------------
 src/hb-iter.hh  |  5 ++--
 2 files changed, 36 insertions(+), 44 deletions(-)

commit 2a33ab0560a13cb8fef5983bfe0f6d68dfd47b14
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 18:49:27 2018 -0500

    [iter] Change __more__ to fallback to __len__

 src/hb-iter.hh   | 15 ++++++---------
 src/test-iter.cc |  1 -
 2 files changed, 6 insertions(+), 10 deletions(-)

commit 474a12058d681f2d7cef84db0cf20f9f784fa400
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 18:46:51 2018 -0500

    [array/vector] Rename len to length

 src/hb-aat-layout-feat-table.hh |  5 ++-
 src/hb-aat-layout-lcar-table.hh |  2 +-
 src/hb-aat-map.cc               |  4 +--
 src/hb-array.hh                 | 72
 ++++++++++++++++++++---------------------
 src/hb-cff-interp-common.hh     | 10 +++---
 src/hb-cff2-interp-cs.hh        |  6 ++--
 src/hb-coretext.cc              | 12 +++----
 src/hb-face.cc                  |  4 +--
 src/hb-object.hh                | 23 +++++++------
 src/hb-open-file.hh             |  4 +--
 src/hb-open-type.hh             |  8 ++---
 src/hb-ot-cff-common.hh         | 38 +++++++++++-----------
 src/hb-ot-cff1-table.hh         | 28 ++++++++--------
 src/hb-ot-cmap-table.hh         | 24 +++++++-------
 src/hb-ot-color-colr-table.hh   |  6 ++--
 src/hb-ot-hdmx-table.hh         |  6 ++--
 src/hb-ot-hmtx-table.hh         |  8 ++---
 src/hb-ot-layout-common.hh      | 32 +++++++++---------
 src/hb-ot-layout-gdef-table.hh  |  4 +--
 src/hb-ot-layout-gsub-table.hh  | 24 +++++++-------
 src/hb-ot-layout-gsubgpos.hh    |  2 +-
 src/hb-ot-layout.cc             |  2 +-
 src/hb-ot-map.cc                | 22 ++++++-------
 src/hb-ot-map.hh                |  4 +--
 src/hb-ot-math-table.hh         |  4 +--
 src/hb-ot-maxp-table.hh         |  2 +-
 src/hb-ot-name-table.hh         |  8 ++---
 src/hb-ot-name.cc               |  4 +--
 src/hb-ot-post-table.hh         |  8 ++---
 src/hb-ot-var-fvar-table.hh     |  2 +-
 src/hb-ot-vorg-table.hh         | 10 +++---
 src/hb-set.hh                   | 36 ++++++++++-----------
 src/hb-subset-cff-common.cc     |  8 ++---
 src/hb-subset-cff-common.hh     | 50 ++++++++++++++--------------
 src/hb-subset-cff1.cc           | 48 +++++++++++++--------------
 src/hb-subset-cff2.cc           | 16 ++++-----
 src/hb-subset-glyf.cc           | 14 ++++----
 src/hb-subset-plan.cc           |  2 +-
 src/hb-uniscribe.cc             | 26 +++++++--------
 src/hb-vector.hh                | 56 ++++++++++++++++----------------
 src/test-iter.cc                |  4 +--
 41 files changed, 325 insertions(+), 323 deletions(-)

commit 2fc1860a5b40f5deba720c0c1099fdd0450b77c0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 18:09:45 2018 -0500

    [iter] Split hb_iter_t<> into hb_iter_t<> and hb_iter_mixin_t<>

 src/hb-iter.hh   | 31 ++++++++++++++++++++-----------
 src/test-iter.cc |  2 +-
 2 files changed, 21 insertions(+), 12 deletions(-)

commit 865deeb3be1cb40efe3d7c42db48b0cdf977de47
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 17:35:58 2018 -0500

    Adjust internal header dependencies

 src/hb-array.hh            |  5 ++++-
 src/hb-dsalgs.hh           |  1 -
 src/hb-iter.hh             |  1 +
 src/hb-vector.hh           |  1 +
 src/hb.hh                  | 15 +++++++++------
 src/test-iter.cc           |  1 +
 src/test-unicode-ranges.cc |  1 +
 7 files changed, 17 insertions(+), 8 deletions(-)

commit 8e5c2bc60bd9a800dacc96cc29c6ff831a852ae3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 17:29:11 2018 -0500

    [Makefile.am] Minor

 src/Makefile.am | 14 ++++++++------
 1 file changed, 8 insertions(+), 6 deletions(-)

commit f419cef4174c5447bf5031e771483f3274ae4dce
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 17:22:09 2018 -0500

    [iter] Include from hb.hh

 src/hb.hh | 1 +
 1 file changed, 1 insertion(+)

commit 7557e34872c846433c2465b21b99bf7c5f961673
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 17:21:19 2018 -0500

    [iter] Move hb_fill() and hb_copy() to hb-iter.hh

 src/hb-iter.hh   | 18 ++++++++++++++++++
 src/test-iter.cc | 16 ----------------
 2 files changed, 18 insertions(+), 16 deletions(-)

commit 5e1840e031cff1127842fc5cc8ee93e5959f02d5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 16:39:57 2018 -0500

    [iter] Disallow copy-construction or assignment of hb_iter_t<>

    Should only be done by subclass.

 src/hb-iter.hh | 5 +++++
 1 file changed, 5 insertions(+)

commit 65e8bd56ad26912636fbdc400a83cc48db2a13ce
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 16:20:30 2018 -0500

    [iter] Fix hb_copy() return value

 src/test-iter.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 40d71211a8969ec4414d2476a209e60d0a3525d3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 16:19:44 2018 -0500

    [iter] Add const_iter_t / const_iter()

 src/hb-iter.hh | 2 ++
 1 file changed, 2 insertions(+)

commit aaddfaa57a841726a8b49653af3f8b702831da1b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 16:04:38 2018 -0500

    [iter] Make hb_fill() take collection type, not iter

    Starting to get the hang of when take which.

 src/test-iter.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 7b4eea853c36fd59db6e5d68bbef9b8cebad760e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 16:02:16 2018 -0500

    [array] Add more hb_array() / hb_sorted_array() variants

 src/hb-array.hh | 15 +++++++++++----
 1 file changed, 11 insertions(+), 4 deletions(-)

commit 09740148e310021a4a690666c2e2836c2005353d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 15:56:01 2018 -0500

    [serialize] Use component_list by reference, as a supplier

 src/hb-ot-layout-gsub-table.hh | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 3dbe1e364c19d82ab436b9ea7b41c9754d43e923
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 15:53:09 2018 -0500

    [iter] Add .random_access()

 src/hb-iter.hh   | 4 ++++
 src/test-iter.cc | 1 +
 2 files changed, 5 insertions(+)

commit 20f14b4aa6311d8fb2ed80c47bb15e8d87d2f6b3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 15:19:22 2018 -0500

    [iter] Fix __end__()

 src/hb-iter.hh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 95265aeab7da54f31d4f68590af7730054b6be16
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 15:12:55 2018 -0500

    [array] Remove copy constructor

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1502

 src/hb-array.hh | 1 -
 1 file changed, 1 deletion(-)

commit 69d232eaea323b8c42e5fa1788553ac4e8bf3a50
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 15:08:06 2018 -0500

    Fix bot

      C:\projects\harfbuzz\src\hb-uniscribe.cc(709): error C2666:
      'hb_vector_t<OPENTYPE_FEATURE_RECORD,8>::operator
      +': 3 overloads have similar conversions
      [C:\projects\harfbuzz\build\harfbuzz.vcxproj]

 src/hb-uniscribe.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b9a51f531009ce201b86a0326aff662fd19a68a1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 15:05:00 2018 -0500

    Minor

 src/hb-ot-layout-gpos-table.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit bdb6da72267c8fa4802a2183ba69a1535653378b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 11:20:27 2018 -0500

    [iter] Fix test again

 src/test-iter.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit e9520752489298e0ce1a08da10ec3d439f9356d9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 11:15:16 2018 -0500

    Minor

 src/Makefile.am  | 6 +++---
 src/test-iter.cc | 1 -
 2 files changed, 3 insertions(+), 4 deletions(-)

commit 35503d7d7324293162b605ffe0bd712656dd52b8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 03:03:46 2018 -0500

    [iter] More prototyping

 src/test-iter.cc | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit 73c7a896d1395539e3c9e71b073ce5094c835aa0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 02:48:28 2018 -0500

    [iter] Make hb_fill() and hb_copy() take iterators

    I'm still going back and force...

 src/test-iter.cc | 11 ++++-------
 1 file changed, 4 insertions(+), 7 deletions(-)

commit 12e506fda4bfd82d67e4beede29ae7dbc02ad8f4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 02:47:04 2018 -0500

    [iter] Add hb_fill()

 src/test-iter.cc | 20 ++++++++++++++------
 1 file changed, 14 insertions(+), 6 deletions(-)

commit ad3ed58de5297930826c67d18b99991b93d29654
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 02:12:55 2018 -0500

    [iter] Start prototyping hb_copy()

 src/test-iter.cc | 18 ++++++++++++++----
 1 file changed, 14 insertions(+), 4 deletions(-)

commit 44af738d19486095c0fbc2ef2b359a298126ac2b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 01:59:37 2018 -0500

    [iter] Showcase implicit casts

 src/test-iter.cc | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 879faa2aee74e237594901426096ceeb78a716a4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 01:57:40 2018 -0500

    Rename

 src/hb-array.hh     | 2 +-
 src/hb-open-type.hh | 4 ++--
 src/hb-vector.hh    | 2 +-
 3 files changed, 4 insertions(+), 4 deletions(-)

commit aeb696a91cd1cdc73bf5b87e56163c7f64778616
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 01:57:02 2018 -0500

    [iter] Rename

 src/hb-iter.hh | 44 ++++++++++++++++++++++----------------------
 1 file changed, 22 insertions(+), 22 deletions(-)

commit 8001e00a470ad06f0307002b4cade5612ee7b521
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 01:53:27 2018 -0500

    [iter] First sample use

 src/Makefile.am  |  5 ++++-
 src/hb-iter.hh   | 25 +++++++++++--------------
 src/test-iter.cc | 25 ++++++++++++++++++++-----
 3 files changed, 35 insertions(+), 20 deletions(-)

commit 19d2b5013d8ac7aa45b3b8e8c61ad90773c86925
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 01:17:35 2018 -0500

    [iter] Add bidirectionality

 src/hb-iter.hh | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

commit 314d8698d0746416efd332f5fae45aecb26df7ee
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 00:54:55 2018 -0500

    [iter] Sketch new iterator design

 src/hb-iter.hh   | 154
 +++++++++++++++++++------------------------------------
 src/test-iter.cc |  16 ++++++
 2 files changed, 69 insertions(+), 101 deletions(-)

commit f6d5f1e91ced2b6b1114ad765f568f799dd3612f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 00:23:34 2018 -0500

    [iter] Add empty test

 src/Makefile.am            |  7 +++++--
 src/hb-machinery.hh        |  1 -
 src/test-iter.cc           | 33 +++++++++++++++++++++++++++++++++
 src/test-unicode-ranges.cc |  2 --
 4 files changed, 38 insertions(+), 5 deletions(-)

commit b80b97b549dacc10d314bf8b5fd4ace596ccdfe1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Dec 21 00:08:05 2018 -0500

    Revert "Remove unused hb-iter.hh"

    This reverts commit 969ff3c7aadbe721cdd414488eb170433f10d00c.

 src/Makefile.sources |   1 +
 src/hb-iter.hh       | 146
 +++++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-machinery.hh  |   1 +
 3 files changed, 148 insertions(+)

commit a728c63a98281fd4a0661e17fc01171bc3205b27
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 20 23:15:49 2018 -0500

    [vector] Add operator bool

 src/hb-vector.hh | 2 ++
 1 file changed, 2 insertions(+)

commit bd369773921b4891996bd21f325702e490f47ca4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 20 23:14:24 2018 -0500

    Rename

 src/hb-array.hh     | 2 +-
 src/hb-open-type.hh | 4 ++--
 src/hb-vector.hh    | 2 +-
 3 files changed, 4 insertions(+), 4 deletions(-)

commit e6ebc9b6f89e62d888b3bcf926afd624f16f3e95
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 20 23:13:36 2018 -0500

    Remove unused typedef

 src/hb-machinery.hh | 3 ---
 1 file changed, 3 deletions(-)

commit 4941e95f10fe0fe658752134a42b58896fb19c42
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 20 21:48:57 2018 -0500

    2.3.0

 NEWS                 | 15 +++++++++++++++
 configure.ac         |  2 +-
 src/hb-aat-layout.cc |  6 +++---
 src/hb-version.h     |  4 ++--
 4 files changed, 21 insertions(+), 6 deletions(-)

commit 87f7c83fffb7e64970be23c8e3c620d32a3b8f5b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 20 15:54:17 2018 -0500

    [serializer] Add operator <<

    Not sure if we are going to use it.  But might incentivize us to.

 src/hb-machinery.hh | 2 ++
 1 file changed, 2 insertions(+)

commit 5b70074edf1c12a9442037d54c03d3025bd93995
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 20 15:38:59 2018 -0500

    Add hb_assign(obj, value)

 src/hb-machinery.hh |  2 +-
 src/hb-null.hh      | 24 +++++++++++++++++++++++-
 src/hb-open-type.hh |  5 +++--
 3 files changed, 27 insertions(+), 4 deletions(-)

commit 6124123393eabb77d34830c971ec463998d50aba
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 20 12:26:30 2018 -0500

    [serialize] Adjust ClassDef

    [skip ci]

 src/hb-ot-layout-common.hh | 32 ++++++++++++++++----------------
 1 file changed, 16 insertions(+), 16 deletions(-)

commit 4220b7bdd7706622563401bf8f055c4b1482b4e5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 20 11:48:45 2018 -0500

    Fix code on big-endian gcc / clang

    Ouch!  We need a bigendian bot...

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1498

 src/hb-machinery.hh | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit c87ee72232416099a73b563ca7aaf293b1c87b2a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 19 22:28:16 2018 -0500

    Minor [skip ci]

 src/hb-dsalgs.hh | 13 +++++++------
 1 file changed, 7 insertions(+), 6 deletions(-)

commit 5000a59a6391d588c2cbdda132839b1fb1f75bf2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 19 21:07:53 2018 -0500

    [saitnize] Minor

 src/hb-machinery.hh | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 3ee4ea945674c4b96c9aa6b0367bbf22dc8745d1
Author: fanc999 <fanc999@yahoo.com.tw>
Date:   Thu Dec 20 11:26:54 2018 +0800

    Fix build on older Visual Studio versions (#1499)

    * src/hb-cff-interp-dict-common.hh: Use ull for unsigned int64_t

    The llu suffix does not work for older Visual Studio versions
    (pre-2013), but ull works for all the compilers that we attempt to
    support.

    * test/api: Fix build on pre-C99 compilers

    Ensure variables are declared at the top of the block.

    * src/hb-dsalgs.hh: Add specialization for hb_is_signed<> for __int8

    Pre-Visual Studio 2010 does not consider __int8 (which is typedef'ed
    to
    int8_t) to be equivilant to signed char, so the compiler cannot
    find the
    corresponding hb_is_signed<> specialization that is needed.

    The interesting thing is unsigned __int8 is considered to be
    equivilant
    to unsigned char, so as the other types (short, int, long) that
    we look
    for here, so only the specialization for __int8 is added here.

    This will fix builds on Visual Studio 2008 at least.

 src/hb-cff-interp-dict-common.hh |  2 +-
 src/hb-dsalgs.hh                 |  9 +++++++++
 test/api/test-aat-layout.c       |  3 ++-
 test/api/test-subset-cff1.c      | 12 ++++++++----
 4 files changed, 20 insertions(+), 6 deletions(-)

commit a62870506d16949582bf0b54e3dc8846b9747a4a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 19 21:05:00 2018 -0500

    [sanitize] Use hb_static_size instead of ::static_size

    https://github.com/harfbuzz/harfbuzz/issues/1496#issuecomment-448818112

 src/hb-machinery.hh | 11 +++++------
 1 file changed, 5 insertions(+), 6 deletions(-)

commit 0c9cd5d5f4d96df77e4298e16c786e67b83f9bc4
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Dec 19 21:18:30 2018 +0330

    [test] Fix test-name-table.cc leak issue

    Spotted it accidentally but wanted to see if is anything serious so
    went for fixing it

 src/test-name-table.cc | 2 ++
 1 file changed, 2 insertions(+)

commit 3d9d7dc4dd4be8e746507282569504b511afa709
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 18 22:11:23 2018 -0500

    [arrays] Add hb_ubytes_t for unsigned char

 src/hb-array.hh | 1 +
 1 file changed, 1 insertion(+)

commit f1e95e40edc871c840abe8a8a695efc252af40f5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 18 16:49:08 2018 -0500

    [arrays] Remove hb_supplier_t<>

 src/hb-array.hh                            |  11 --
 src/hb-cff2-interp-cs.hh                   |   2 +-
 src/hb-face.cc                             |   6 +-
 src/hb-open-file.hh                        |  15 +-
 src/hb-open-type.hh                        |  18 +-
 src/hb-ot-cmap-table.hh                    |   3 +-
 src/hb-ot-layout-common.hh                 | 104 ++++--------
 src/hb-ot-layout-gsub-table.hh             | 257
 +++++++++++++----------------
 src/hb-ot-shape-complex-arabic-fallback.hh |  23 +--
 9 files changed, 170 insertions(+), 269 deletions(-)

commit f9417af29bd5a1d2f5b55389a1cc6f4280b347d8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 18 13:23:32 2018 -0500

    [serialize] Propagate error from hb-face

 src/hb-face.cc | 1 +
 1 file changed, 1 insertion(+)

commit 9aebfb418222427a324d911b32abfc11256ca9e3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 18 13:22:17 2018 -0500

    [serialize] Streamline error propagation

 src/hb-buffer.hh               |  2 ++
 src/hb-machinery.hh            | 35 ++++++++++++++++++++++++++---------
 src/hb-map.hh                  |  2 ++
 src/hb-ot-layout-common.hh     |  4 ++--
 src/hb-ot-layout-gsub-table.hh |  4 ++--
 src/hb-set.hh                  |  2 ++
 src/hb-subset.cc               |  2 +-
 7 files changed, 37 insertions(+), 14 deletions(-)

commit 969ff3c7aadbe721cdd414488eb170433f10d00c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 22:43:00 2018 -0500

    Remove unused hb-iter.hh

    The ideas there are all part of hb-array.hh now.  To be determined
    how we
    want to use generic iterator patterns.

 src/Makefile.sources |   1 -
 src/hb-iter.hh       | 146
 ---------------------------------------------------
 src/hb-machinery.hh  |   1 -
 3 files changed, 148 deletions(-)

commit b1094fc2d2b614c1407b502d15bd98407a5ffb56
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 22:41:04 2018 -0500

    [arrays] Minor tweaks to hb_supplier_t

    I think I like to keep this hb_supplier_t thing separately from
    hb_array_t.

 src/hb-array.hh | 5 +++++
 1 file changed, 5 insertions(+)

commit cf39c242057636feebafce347f8e7ac2b305112a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 22:36:23 2018 -0500

    [arrays] Rename Supplier to hb_supplier_t

 src/hb-array.hh                            |   6 +-
 src/hb-face.cc                             |   2 +-
 src/hb-open-file.hh                        |   4 +-
 src/hb-open-type.hh                        |   4 +-
 src/hb-ot-cmap-table.hh                    |   2 +-
 src/hb-ot-layout-common.hh                 |  34 ++++-----
 src/hb-ot-layout-gsub-table.hh             | 108
 ++++++++++++++---------------
 src/hb-ot-shape-complex-arabic-fallback.hh |  14 ++--
 8 files changed, 87 insertions(+), 87 deletions(-)

commit 6b5eaa753047b6b0389cb7521c52efbaccf72daf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 21:55:33 2018 -0500

    Hide hb_addressof()

 src/hb-dsalgs.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6befa75cdf83d561de69fb342f68694cd7b46f5e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 20:34:51 2018 -0500

    Enable __builtin_* on clang

    We'll see which old clang versions this breaks...

 src/hb-dsalgs.hh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 8d2d41025619e24160ed80edd1c413168a2dda36
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 20:23:26 2018 -0500

    Add hb_addressof() and use it to fix bug after hb_bytes_t merge

    We cannot take address hb_bytes_t direction.  We need to use the
    newly added hb_addressof(), ala std::addressof().

 src/hb-dsalgs.hh        | 9 +++++++++
 src/hb-ot-post-table.hh | 3 ++-
 2 files changed, 11 insertions(+), 1 deletion(-)

commit 49334f9b509fc15e8baa93d49b86886ca933de04
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 18:27:36 2018 -0500

    Enable system extensions in hb.hh

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1491

 configure.ac |  1 -
 src/hb.hh    | 26 ++++++++++++++++++++++++++
 2 files changed, 26 insertions(+), 1 deletion(-)

commit 37c14bc7459e8b9cc0840b68223123ffb950b4cc
Author: prrace <philip.race@oracle.com>
Date:   Mon Dec 17 14:59:37 2018 -0800

    Fix Solaris use after free (#1495)

 src/hb-atomic.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 483f2491e40ccf660836ed2797738297e40bd100
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 17:56:10 2018 -0500

    Remove define GNU_SOURCE

    Not needed.  We get it in our config.h automatically thanks to
    AC_USE_SYSTEM_EXTENSIONS.  Let's see whose build it breaks...
    If we end up putting it back, we should add other things from
    that macro and remove the macro.

 src/hb.hh | 2 --
 1 file changed, 2 deletions(-)

commit 87ff65aea117391c732d51d874964b3e32d6fa94
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 17:19:42 2018 -0500

    Fix more warnings

 src/hb.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f9d219a17417f61fa2c6152d2181504866583a72
Author: prrace <philip.race@oracle.com>
Date:   Mon Dec 17 14:18:47 2018 -0800

    Fix Solaris Trailing comma in enum warnings (#1490)

 src/hb-ot-color.h | 2 +-
 src/hb-ot-name.h  | 2 +-
 src/hb-ot-var.h   | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit 244a8627f7b0ed651d6010c7ee7e54fa8fcca400
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Mon Dec 17 21:31:43 2018 +0330

    Lower coretext_aat shaper priority (#1488)

    Related to https://github.com/harfbuzz/harfbuzz/issues/1478

 src/hb-shaper-list.hh | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit e41200859997ccf8fd7d36fff654f3ceea3a4160
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Mon Dec 17 21:31:01 2018 +0330

    Remove redundant void from C++ sources (#1486)

 src/dump-indic-data.cc           |   2 +-
 src/dump-khmer-data.cc           |   2 +-
 src/dump-myanmar-data.cc         |   2 +-
 src/dump-use-data.cc             |   2 +-
 src/hb-aat-fdsc-table.hh         |   4 +-
 src/hb-aat-layout-common.hh      |  23 +++---
 src/hb-aat-layout-feat-table.hh  |   8 +--
 src/hb-aat-layout-just-table.hh  |   2 +-
 src/hb-aat-layout-kerx-table.hh  |  21 +++---
 src/hb-aat-layout-morx-table.hh  |  10 +--
 src/hb-aat-layout-trak-table.hh  |   4 +-
 src/hb-aat-layout.cc             |   6 +-
 src/hb-aat-map.hh                |   4 +-
 src/hb-array.hh                  |  24 +++----
 src/hb-atomic.hh                 |  18 ++---
 src/hb-blob.cc                   |   8 +--
 src/hb-blob.hh                   |  33 ++++-----
 src/hb-buffer-serialize.cc       |   2 +-
 src/hb-buffer.cc                 |  24 +++----
 src/hb-buffer.hh                 |  51 ++++++-------
 src/hb-cache.hh                  |   6 +-
 src/hb-cff-interp-common.hh      | 113 +++++++++++++----------------
 src/hb-cff-interp-cs-common.hh   |  26 +++----
 src/hb-cff-interp-dict-common.hh |  12 ++--
 src/hb-cff1-interp-cs.hh         |   4 +-
 src/hb-cff2-interp-cs.hh         |  24 +++----
 src/hb-common.cc                 |  20 +++---
 src/hb-coretext.cc               |   2 +-
 src/hb-debug.hh                  |   6 +-
 src/hb-directwrite.cc            |  16 ++---
 src/hb-dsalgs.hh                 |   2 +-
 src/hb-face.cc                   |   6 +-
 src/hb-face.hh                   |   8 +--
 src/hb-font.cc                   |   6 +-
 src/hb-font.hh                   |   6 +-
 src/hb-ft.cc                     |  18 ++---
 src/hb-glib.cc                   |   8 +--
 src/hb-gobject-enums.cc.tmpl     |   2 +-
 src/hb-gobject-enums.h.tmpl      |   2 +-
 src/hb-gobject-structs.cc        |   2 +-
 src/hb-icu.cc                    |   8 +--
 src/hb-iter.hh                   |  15 ++--
 src/hb-machinery.hh              | 150
 ++++++++++++++++-----------------------
 src/hb-map.cc                    |   4 +-
 src/hb-map.hh                    |  24 +++----
 src/hb-mutex.hh                  |  10 +--
 src/hb-null.hh                   |  32 ++++-----
 src/hb-object.hh                 |  22 +++---
 src/hb-open-file.hh              |  32 ++++-----
 src/hb-open-type.hh              |  66 +++++++++--------
 src/hb-ot-cff-common.hh          |  30 ++++----
 src/hb-ot-cff1-table.cc          |  17 ++---
 src/hb-ot-cff1-table.hh          |  52 ++++++--------
 src/hb-ot-cff2-table.cc          |   8 +--
 src/hb-ot-cff2-table.hh          |  34 ++++-----
 src/hb-ot-cmap-table.hh          |  10 +--
 src/hb-ot-color-cbdt-table.hh    |   4 +-
 src/hb-ot-color-colr-table.hh    |   2 +-
 src/hb-ot-color-cpal-table.hh    |  10 +--
 src/hb-ot-color-sbix-table.hh    |  11 ++-
 src/hb-ot-color-svg-table.hh     |   7 +-
 src/hb-ot-face.cc                |   2 +-
 src/hb-ot-face.hh                |   2 +-
 src/hb-ot-font.cc                |   8 +--
 src/hb-ot-glyf-table.hh          |   6 +-
 src/hb-ot-hdmx-table.hh          |   4 +-
 src/hb-ot-head-table.hh          |   8 +--
 src/hb-ot-hmtx-table.hh          |   2 +-
 src/hb-ot-kern-table.hh          |  20 +++---
 src/hb-ot-layout-base-table.hh   |  10 +--
 src/hb-ot-layout-common.hh       |  67 +++++++++--------
 src/hb-ot-layout-gdef-table.hh   |  20 +++---
 src/hb-ot-layout-gpos-table.hh   |  34 ++++-----
 src/hb-ot-layout-gsub-table.hh   |  24 +++----
 src/hb-ot-layout-gsubgpos.hh     |  92 +++++++++++-------------
 src/hb-ot-layout-jstf-table.hh   |   8 +--
 src/hb-ot-map.cc                 |   2 +-
 src/hb-ot-map.hh                 |   8 +--
 src/hb-ot-math-table.hh          |  11 ++-
 src/hb-ot-maxp-table.hh          |   5 +-
 src/hb-ot-name-table.hh          |   6 +-
 src/hb-ot-os2-table.hh           |  18 ++---
 src/hb-ot-post-table.hh          |   4 +-
 src/hb-ot-shape.cc               |   2 +-
 src/hb-ot-shape.hh               |   2 +-
 src/hb-ot-tag.cc                 |   4 +-
 src/hb-ot-var-fvar-table.hh      |   9 ++-
 src/hb-ot-var-hvar-table.hh      |   9 +--
 src/hb-ot-vorg-table.hh          |   2 +-
 src/hb-set-digest.hh             |   4 +-
 src/hb-set.cc                    |   4 +-
 src/hb-set.hh                    |  38 +++++-----
 src/hb-shape-plan.cc             |   2 +-
 src/hb-shape-plan.hh             |   5 +-
 src/hb-shape.cc                  |  10 +--
 src/hb-shaper.cc                 |  14 ++--
 src/hb-shaper.hh                 |   6 +-
 src/hb-static.cc                 |   4 +-
 src/hb-subset-cff-common.hh      |  91 +++++++++++-------------
 src/hb-subset-cff1.cc            |  20 ++----
 src/hb-subset-cff2.cc            |   8 +--
 src/hb-subset-input.cc           |   2 +-
 src/hb-subset.hh                 |   4 +-
 src/hb-ucdn.cc                   |  10 +--
 src/hb-unicode.cc                |  64 ++++++++---------
 src/hb-uniscribe.cc              |  12 ++--
 src/hb-vector.hh                 |  38 +++++-----
 src/hb.hh                        |   6 +-
 src/test-unicode-ranges.cc       |   4 +-
 util/ansi-print.cc               |   6 +-
 util/hb-fc.cc                    |   2 +-
 util/hb-shape.cc                 |   5 +-
 util/helper-cairo.cc             |   2 +-
 util/helper-cairo.hh             |   2 +-
 util/main-font-text.hh           |   2 +-
 util/options.cc                  |   8 +--
 util/options.hh                  |  22 +++---
 util/view-cairo.hh               |  14 ++--
 118 files changed, 861 insertions(+), 1024 deletions(-)

commit 7ace10078c23d00da4af0480f91b877faeed3d38
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Mon Dec 17 20:07:04 2018 +0330

    Minor, fix two more ArrayOf incorrect operator logic

 src/hb-open-type.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a1240383aa82fd88e922a1e751444d14033ae882
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 10:44:14 2018 -0500

    [arrays] Minor fix

 src/hb-open-type.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 381c3548e9022a421bcf88db148cc11f337f3b79
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 00:39:30 2018 -0500

    [array] Add cast operator to add const to Type

    In lieu of constructor removed in previous commit.

 src/hb-array.hh | 1 +
 1 file changed, 1 insertion(+)

commit 15acf33c228e0c8e0f8cc6a04e566970164dd5f1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 00:38:13 2018 -0500

    [array] Remove problematic constructor

 src/hb-array.hh | 1 -
 1 file changed, 1 deletion(-)

commit 470369a871791b610e0c42212558e83baeb83409
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 00:20:19 2018 -0500

    [array] Add arithmetic operators

 src/hb-array.hh | 22 ++++++++++++++++++----
 1 file changed, 18 insertions(+), 4 deletions(-)

commit 6cd60c2f2aa17e3f02b50c19cf640b3f183f3354
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 00:09:06 2018 -0500

    [array] Return Crap instead of Null if Type is not const

    Ouch!

 src/hb-array.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 94e72cf1c9af563fbf522efb7f2e0b1fcd616418
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 00:06:40 2018 -0500

    [array] Add operator *

 src/hb-array.hh | 2 ++
 1 file changed, 2 insertions(+)

commit 68d4a5eee0f248891d20d69b897201d105951aef
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 17 00:02:42 2018 -0500

    [array] Add constructor from fixed-size array

 src/hb-array.hh | 1 +
 src/hb-iter.hh  | 4 ++--
 2 files changed, 3 insertions(+), 2 deletions(-)

commit a4354d2fd36377ec8b544c7b88a231cb1273dccd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 23:57:27 2018 -0500

    [array] Organize

 src/hb-array.hh | 75
 ++++++++++++++++++++++++++++++++++++---------------------
 1 file changed, 48 insertions(+), 27 deletions(-)

commit 84c1865821151d83a8798ae11ebba3329a12c560
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 23:52:17 2018 -0500

    [arrays] Reduce Supplier<> even further

 src/hb-array.hh | 24 +++---------------------
 1 file changed, 3 insertions(+), 21 deletions(-)

commit 1bcc4fc9f34ab518fc822c9464a73ba3e90f5f1c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 23:47:56 2018 -0500

    Whitespace

 src/hb-ot-shape-complex-arabic-fallback.hh | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit f85f6e815f439075f8c6f5391e5c8dfe77e0f00d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 23:45:07 2018 -0500

    [array] Add operator +=

 src/hb-array.hh | 18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

commit 7c0e3e9b2b077fced829a10f616ed3d6b51c15c4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 23:43:17 2018 -0500

    [array] Add constructor from hb_array_t<const Type>

 src/hb-array.hh | 1 +
 1 file changed, 1 insertion(+)

commit 92680361ec68734ad38e2158626feebaf18eec88
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 23:38:51 2018 -0500

    [arrays] Move Supplier<> to hb-array.hh

 src/hb-array.hh     | 33 +++++++++++++++++++++++++++++++++
 src/hb-machinery.hh | 32 --------------------------------
 2 files changed, 33 insertions(+), 32 deletions(-)

commit 2a3fa3f82ffdb778a2d21fc01e859579161237c9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 23:33:03 2018 -0500

    [arrays] Remove unnecessary constructor from Supplier<>

    Looks like operator hb_array_t<> from vector works here. :)

 src/hb-machinery.hh | 5 -----
 1 file changed, 5 deletions(-)

commit 507cac4943e987879b95d842fe60643abbf22efa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 23:31:19 2018 -0500

    [arrays] Start moving Supplier<> to hb_array_t<>

 src/hb-machinery.hh | 31 +++++++++++--------------------
 1 file changed, 11 insertions(+), 20 deletions(-)

commit 1e2c98126e8500ace31483b05d77478afd59bab8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 22:30:44 2018 -0500

    [arrays] Remove unused stride from Supplier

 src/hb-machinery.hh | 10 +++-------
 1 file changed, 3 insertions(+), 7 deletions(-)

commit 0d0fe9df46c645538feaee1ec99a0108383a3669
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 22:29:40 2018 -0500

    [arrays] Remove need of stride in Supplier<>

 src/hb-face.cc      |  6 ++----
 src/hb-open-file.hh | 19 +++++++++----------
 src/hb-vector.hh    |  2 +-
 3 files changed, 12 insertions(+), 15 deletions(-)

commit dcfa4a8d711716de88b94a370663e9564e3e7ccc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 20:40:07 2018 -0500

    [array] Remove custom hb_bytes_t implementation

 src/hb-array.hh         | 67
 +++++++++++++++++--------------------------------
 src/hb-machinery.hh     |  2 +-
 src/hb-ot-name-table.hh |  8 +++---
 src/hb-ot-name.cc       | 10 ++++----
 4 files changed, 33 insertions(+), 54 deletions(-)

commit 3656f56d47cf6b89a25990d7836704fef79fa5b4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 20:35:11 2018 -0500

    [arrays] Minor

 src/hb-array.hh     |  3 ++-
 src/hb-open-type.hh | 10 ++++------
 src/hb-vector.hh    |  4 +---
 3 files changed, 7 insertions(+), 10 deletions(-)

commit aa8f94714ee720c56be1a3406df7bacb0550158c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 20:20:35 2018 -0500

    [array] Minor

 src/hb-array.hh | 4 ++++
 src/hb-iter.hh  | 2 +-
 2 files changed, 5 insertions(+), 1 deletion(-)

commit 5a552f75468d777d8d4bd3168e28f56a3369eafd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 20:07:44 2018 -0500

    [array] Move hb_array_t and related types to hb-array.hh

 src/Makefile.sources |   1 +
 src/hb-array.hh      | 241
 +++++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-dsalgs.hh     | 206 -------------------------------------------
 src/hb-machinery.hh  |   1 +
 src/hb-vector.hh     |   2 +-
 5 files changed, 244 insertions(+), 207 deletions(-)

commit 01d06e34ffa746d3737df00bb692cdb1e859c1c6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 16 14:27:43 2018 -0500

    Minor change to explicit_operator aesthetics

 src/hb-iter.hh      | 2 +-
 src/hb-machinery.hh | 2 +-
 src/hb-vector.hh    | 4 ++--
 src/hb.hh           | 4 ++--
 4 files changed, 6 insertions(+), 6 deletions(-)

commit b2ebaa9afac0f57006283db92d1f3b4df3d6bd7e
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sun Dec 16 22:38:10 2018 +0330

    Remove redundant 'inline' from methods (#1483)

 src/hb-aat-fdsc-table.hh         |  12 +-
 src/hb-aat-layout-ankr-table.hh  |  12 +-
 src/hb-aat-layout-bsln-table.hh  |  13 +-
 src/hb-aat-layout-common.hh      | 150 +++++++-------
 src/hb-aat-layout-feat-table.hh  |  46 ++---
 src/hb-aat-layout-just-table.hh  |  26 +--
 src/hb-aat-layout-kerx-table.hh  | 120 +++++------
 src/hb-aat-layout-lcar-table.hh  |  14 +-
 src/hb-aat-layout-morx-table.hh  | 104 +++++-----
 src/hb-aat-layout-trak-table.hh  |  28 +--
 src/hb-aat-layout.hh             |   2 +-
 src/hb-aat-ltag-table.hh         |   6 +-
 src/hb-aat-map.hh                |   7 +-
 src/hb-atomic.hh                 |  26 +--
 src/hb-blob.hh                   |  32 ++-
 src/hb-buffer.hh                 |  76 ++++---
 src/hb-cache.hh                  |  10 +-
 src/hb-cff-interp-common.hh      | 197 +++++++++---------
 src/hb-cff-interp-cs-common.hh   | 166 +++++++--------
 src/hb-cff-interp-dict-common.hh |  26 +--
 src/hb-cff1-interp-cs.hh         |  21 +-
 src/hb-cff2-interp-cs.hh         |  48 ++---
 src/hb-common.cc                 |  13 +-
 src/hb-debug.hh                  |  20 +-
 src/hb-directwrite.cc            |   2 +-
 src/hb-dsalgs.hh                 |  84 ++++----
 src/hb-face.cc                   |   2 +-
 src/hb-face.hh                   |   6 +-
 src/hb-font.hh                   | 216 ++++++++++----------
 src/hb-ft.cc                     |   8 +-
 src/hb-glib.cc                   |   2 +-
 src/hb-icu.cc                    |   2 +-
 src/hb-iter.hh                   |  18 +-
 src/hb-kern.hh                   |   8 +-
 src/hb-machinery.hh              | 210 +++++++++----------
 src/hb-map.hh                    |  38 ++--
 src/hb-mutex.hh                  |  12 +-
 src/hb-null.hh                   |  26 +--
 src/hb-object.hh                 |  34 ++--
 src/hb-open-file.hh              |  92 ++++-----
 src/hb-open-type.hh              | 253 ++++++++++++-----------
 src/hb-ot-cff-common.hh          | 177 ++++++++--------
 src/hb-ot-cff1-table.cc          |  32 +--
 src/hb-ot-cff1-table.hh          | 160 +++++++--------
 src/hb-ot-cff2-table.cc          |  16 +-
 src/hb-ot-cff2-table.hh          |  62 +++---
 src/hb-ot-cmap-table.hh          | 185 +++++++++--------
 src/hb-ot-color-cbdt-table.hh    |  40 ++--
 src/hb-ot-color-colr-table.hh    |  18 +-
 src/hb-ot-color-cpal-table.hh    |  55 +++--
 src/hb-ot-color-sbix-table.hh    |  48 ++---
 src/hb-ot-color-svg-table.hh     |  20 +-
 src/hb-ot-font.cc                |   2 +-
 src/hb-ot-gasp-table.hh          |   6 +-
 src/hb-ot-glyf-table.hh          |  37 ++--
 src/hb-ot-hdmx-table.hh          |  36 ++--
 src/hb-ot-head-table.hh          |  10 +-
 src/hb-ot-hhea-table.hh          |   2 +-
 src/hb-ot-hmtx-table.hh          |  18 +-
 src/hb-ot-kern-table.hh          |  44 ++--
 src/hb-ot-layout-base-table.hh   | 104 +++++-----
 src/hb-ot-layout-common.hh       | 425
 ++++++++++++++++++++-------------------
 src/hb-ot-layout-gdef-table.hh   | 126 ++++++------
 src/hb-ot-layout-gpos-table.hh   | 209 +++++++++----------
 src/hb-ot-layout-gsub-table.hh   | 360 ++++++++++++++++-----------------
 src/hb-ot-layout-gsubgpos.hh     | 353 ++++++++++++++++----------------
 src/hb-ot-layout-jstf-table.hh   |  44 ++--
 src/hb-ot-map.hh                 |  38 ++--
 src/hb-ot-math-table.hh          | 142 ++++++-------
 src/hb-ot-maxp-table.hh          |  12 +-
 src/hb-ot-name-table.hh          |  21 +-
 src/hb-ot-os2-table.hh           |  34 ++--
 src/hb-ot-post-table.hh          |  26 +--
 src/hb-ot-shape-complex-indic.cc |  10 +-
 src/hb-ot-shape-complex-khmer.cc |  10 +-
 src/hb-ot-shape.hh               |   6 +-
 src/hb-ot-stat-table.hh          |  16 +-
 src/hb-ot-var-avar-table.hh      |   8 +-
 src/hb-ot-var-fvar-table.hh      |  55 +++--
 src/hb-ot-var-hvar-table.hh      |  16 +-
 src/hb-ot-var-mvar-table.hh      |  10 +-
 src/hb-ot-vorg-table.hh          |  22 +-
 src/hb-set-digest.hh             |  41 ++--
 src/hb-set.hh                    | 114 +++++------
 src/hb-shape.cc                  |  14 +-
 src/hb-shaper.cc                 |  14 +-
 src/hb-shaper.hh                 |  10 +-
 src/hb-subset-cff-common.hh      | 175 ++++++++--------
 src/hb-subset-cff1.cc            |  91 ++++-----
 src/hb-subset-cff2.cc            |  36 ++--
 src/hb-subset-plan.hh            |  12 +-
 src/hb-subset.hh                 |   4 +-
 src/hb-ucdn.cc                   |   2 +-
 src/hb-unicode.hh                |  26 +--
 src/hb-uniscribe.cc              |  16 +-
 src/hb-utf.hh                    |  54 +++--
 src/hb-vector.hh                 |  86 ++++----
 97 files changed, 2911 insertions(+), 2987 deletions(-)

commit 7251c7729061b7df29efe2b466315e96c81ad03f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 15 21:00:55 2018 -0500

    Whitespace

 src/hb-buffer-serialize.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 829b56b1a22736eac49132b2e56dc480157afca2
Author: Behdad Esfahbod <behdad@google.com>
Date:   Sat Dec 15 13:02:13 2018 -0500

    Whitespace

 src/hb-ot-cff-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 42a1012562c1f020f470526a34b68ed21ad138cc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 13 19:39:59 2018 -0500

    [subset] Actually subset GDEF

 src/hb-subset.cc | 3 +++
 1 file changed, 3 insertions(+)

commit c9c746c7f6091e575fd74ba8f8cae2c4fd44a1ad
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 13 18:37:37 2018 -0500

    [subset] Fix up ClassDef some more

 src/hb-ot-layout-common.hh | 13 +++++++++----
 1 file changed, 9 insertions(+), 4 deletions(-)

commit 7ee6128902333716dd8d8df6e38a8d1ebacb0a46
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 13 18:32:04 2018 -0500

    [subset] Fix ClassDefFormat1 subsetting

 src/hb-ot-layout-common.hh | 13 ++++++++-----
 1 file changed, 8 insertions(+), 5 deletions(-)

commit 1b6d0c44b3067f5840d3fdac99fbc7448d0f37bf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 13 18:10:48 2018 -0500

    [subset] Sketch GDEF subsetting

 src/hb-ot-layout-gdef-table.hh | 20 ++++++++++++++++++++
 src/hb-ot-layout-gsubgpos.hh   |  2 ++
 2 files changed, 22 insertions(+)

commit 705e2f5056d60c28154004e0c5d3b0ec67fe93c8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 13 17:48:42 2018 -0500

    [subset] Implement for ClassDef

 src/hb-ot-layout-common.hh     | 80
 ++++++++++++++++++++++++++++++++++++++++++
 src/hb-ot-layout-gsub-table.hh |  8 ++---
 2 files changed, 84 insertions(+), 4 deletions(-)

commit 6e33a3955df77b9d1fda5ea44302d97b21e7871c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 13 16:40:01 2018 -0500

    Minor

 src/hb-machinery.hh            | 12 +++++++++---
 src/hb-ot-cmap-table.hh        |  3 +--
 src/hb-ot-layout-gsub-table.hh |  8 ++++----
 3 files changed, 14 insertions(+), 9 deletions(-)

commit cc65901ca7185df926570d5067ace763a2cc759e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 13 16:01:45 2018 -0500

    [serialize] Implement for ClassDef

 src/hb-ot-layout-common.hh | 33 +++++++++++++++++++++++++++++++--
 1 file changed, 31 insertions(+), 2 deletions(-)

commit e5309e4fd8583aa5c5ad9f3934d8aa593c850468
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 13 15:57:12 2018 -0500

    [serialize] Implement for ClassDefFormat2

 src/hb-ot-layout-common.hh | 50
 ++++++++++++++++++++++++++++++++++++++++++----
 1 file changed, 46 insertions(+), 4 deletions(-)

commit c8b43cbe316b07507aece4dc769f38226cd706da
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 13 15:50:13 2018 -0500

    [serialize] Implement for ClassDefFormat1

 src/hb-ot-layout-common.hh | 34 ++++++++++++++++++++++++++++++++++
 1 file changed, 34 insertions(+)

commit 576103132945c9d916514720d4034b398e099cfa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 12 21:21:26 2018 -0500

    [subset] Minor

 src/hb-subset.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 798e98c47bd9fa4d434487ae92e2c88ebb8a19a5
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 12 18:08:15 2018 -0800

    [CFF] bad offset in Index (#1476)

    * Update hb-ot-cff-common.hh

    * fix bug

    * bummer fix wasn't hit. refix

    * additional sanity check

    * Added test cases for oss-fuzz issues 11805, 11806

 src/hb-ot-cff-common.hh                                   |  10
 ++++++++--
 ...clusterfuzz-testcase-hb-subset-fuzzer-5643036478930944 | Bin 0 ->
 369 bytes
 ...clusterfuzz-testcase-hb-subset-fuzzer-5686186874503168 | Bin 0 ->
 962 bytes
 3 files changed, 8 insertions(+), 2 deletions(-)

commit bcb4ecaf68c7219e89a801352bfc6a682b1581ef
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 12 17:36:01 2018 -0800

    [CFF] check out of range FD index (#1477)

    * add fd index checks to subr subsetter

    also added oss-fuzz test case

    * undid SubrSubsetParam::is_valid

    because already validated by SubrClosures.valid

 src/hb-subset-cff-common.hh                              |  10 ++++++++++
 ...lusterfuzz-testcase-hb-subset-fuzzer-5762137968869376 | Bin 0 ->
 2037 bytes
 2 files changed, 10 insertions(+)

commit 3f8e7a98d3cc10fefe65b9638c8abdf3ebe152cb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 12 11:32:57 2018 -0500

    [util/hb-subset] Add --layout to keep GDEF/GSUB/GPOS

    Will become default and option removed in the future.

 util/hb-subset.cc | 1 +
 util/options.cc   | 1 +
 util/options.hh   | 2 ++
 3 files changed, 4 insertions(+)

commit 2cc993e035cb37711f894968246817e53a9e823d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 12 10:07:38 2018 -0500

    [dispatch] Minor

 src/hb-ot-layout-gpos-table.hh | 4 +---
 src/hb-ot-layout-gsub-table.hh | 4 +---
 2 files changed, 2 insertions(+), 6 deletions(-)

commit 602fbfe3c96b3f18b0109239528ba18a19be4948
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 12 09:56:47 2018 -0500

    [sanitize] Fix sanitizing sublookup array

 src/hb-ot-layout-common.hh | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

commit c78e4784fbe06ceb27b54a1d8908016ade071cb4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 12 09:50:18 2018 -0500

    [dispatch] Minor

 src/hb-machinery.hh          | 1 +
 src/hb-ot-layout-gsubgpos.hh | 3 ---
 src/hb-subset.hh             | 1 -
 3 files changed, 1 insertion(+), 4 deletions(-)

commit f9d211af1d6d78d092038d263b222ec8a65cf09d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 12 09:44:30 2018 -0500

    Revert "Minor fix re sanitize of Lookup subtables"

    This reverts commit 7146718bef81492e13aede0a2801cda1da41ce35.

    Fixing differently.

 src/hb-ot-layout-common.hh | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 7ee5c52345c122436e054062084cd51292b90ad1
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Dec 12 15:14:37 2018 +0330

    minor style fix, use void in methods on no argument

 src/hb-aat-fdsc-table.hh        |   4 +-
 src/hb-aat-layout-common.hh     |   6 +-
 src/hb-aat-layout-feat-table.hh |   4 +-
 src/hb-aat-layout-trak-table.hh |  18 +--
 src/hb-aat-layout.cc            |   4 +-
 src/hb-buffer.cc                |  48 +++----
 src/hb-directwrite.cc           | 297
 +++++++++++++++++++---------------------
 src/hb-dsalgs.hh                |   5 +-
 src/hb-map.hh                   |  20 +--
 src/hb-ot-cmap-table.hh         |   2 +-
 src/hb-ot-color-cbdt-table.hh   |   2 +-
 src/hb-ot-color-cpal-table.hh   |   4 +-
 src/hb-ot-color-sbix-table.hh   |  10 +-
 src/hb-ot-color-svg-table.hh    |  15 +-
 src/hb-ot-glyf-table.hh         |   2 +-
 src/hb-ot-hdmx-table.hh         |   6 +-
 src/hb-ot-layout-base-table.hh  |  11 +-
 src/hb-ot-os2-table.hh          |  15 +-
 18 files changed, 211 insertions(+), 262 deletions(-)

commit a33f238f8888cc969e1e393deda0518fb8dd6b13
Merge: 7146718b 1e09add2
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Dec 12 12:44:06 2018 +0330

    Merge pull request #1474 from fanc999/master.msvc

    Few fixes for Visual Studio builds

commit 7146718bef81492e13aede0a2801cda1da41ce35
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 11 23:44:29 2018 -0500

    Minor fix re sanitize of Lookup subtables

    We were dereferencing Null pointers and trying to sanitize them,
    which is not necessary...

 src/hb-ot-layout-common.hh | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit ce069d193229cde12c77a3f464fc10286bedf5f3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 11 23:07:48 2018 -0500

    Minor

 src/hb-open-type.hh | 1 -
 1 file changed, 1 deletion(-)

commit 1aea86944605e7e18acfd2c0a77ba60e62239274
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 11 22:53:58 2018 -0500

    [subset] Map glyphs during SingleSubst subsetting

    Ha!

 src/hb-ot-layout-gsub-table.hh | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit 41d1a1c10f7e5ca69a337ae164d270e09b5f93ac
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 11 22:48:27 2018 -0500

    [subset] Minor

 src/hb-machinery.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2aba2c6c73301396f7e0e5dee819ab6863e74900
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 11 21:18:47 2018 -0500

    [serialize] Break down assert

 src/hb-machinery.hh | 18 ++++++++----------
 1 file changed, 8 insertions(+), 10 deletions(-)

commit 9844c880e280e9cd28dcbeac2e581ac923c5ddf3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 11 17:28:04 2018 -0500

    Minor

 test/shaping/Makefile.am | 2 ++
 util/Makefile.am         | 2 ++
 2 files changed, 4 insertions(+)

commit 2941208f1eedabec2715b2a67d40f058df7eb5e6
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 11 12:21:24 2018 -0800

    [CFF] oss-fuzz issue 11690 ASSERT: substr.offset >= opStart (#1461)

    * fix oss-fuzz 11690: substr.offset >= opStart

    detect recursive subroutine call & handle as error

    * fix build failure

    * add minimized test case for oss-fuzz 11690

    * removed asserts

 src/hb-cff-interp-common.hh                             |   9 ++++-----
 src/hb-subset-cff-common.hh                             |  12
 ++++++++++--
 src/hb-subset-cff1.cc                                   |   4 ++--
 src/hb-subset-cff2.cc                                   |   4 ++--
 ...testcase-minimized-hb-subset-fuzzer-5750420593442816 | Bin 0 ->
 96091 bytes
 5 files changed, 18 insertions(+), 11 deletions(-)

commit 333586245cb37668c8a29af17920474c09667f4b
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 11 12:20:20 2018 -0800

    minimize use of assert: removed or changed to error handling (#1467)

 src/hb-ot-cff-common.hh     |  2 +-
 src/hb-ot-cff1-table.hh     | 12 ++++++++----
 src/hb-subset-cff-common.cc |  6 ++++--
 src/hb-subset-cff-common.hh |  1 -
 src/hb-subset-cff1.cc       | 22 +++++++++++++++++-----
 src/hb-subset-cff2.cc       | 14 +++++++++++---
 6 files changed, 41 insertions(+), 16 deletions(-)

commit f24498c1e95e816889eb7a2f8b1062bbf15bed1b
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Tue Dec 11 23:02:52 2018 +0330

    [ci] Fix Travis macOS bot ICU issue (#1472)

 .travis.yml | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 9f3a51ddb952e1281f9a656fde7193c3e3b8dad2
Author: 👻 <sarabi@Corsac-Fox.local>
Date:   Tue Dec 11 13:38:05 2018 -0500

    [ucdn] Fix header

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1470

 src/hb-ucdn/ucdn.h | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit b225593d6baf3455e1ac951efc0df5015fdf7c69
Author: David Corbett <corbett.dav@husky.neu.edu>
Date:   Tue Dec 11 13:19:17 2018 -0500

    Correct REPLACEMENT CHARACTER's code point to FFFD (#1471)

 test/shaping/hb_test_tools.py | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 1e09add232e14ef61d2f222a5ee05a2105af64f0
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:   Wed Dec 12 01:32:01 2018 +0800

    test/api: Fix building on pre-C99 compilers

    Ensure variables are declared at the top of the block.

 test/api/hb-test.h         |  3 ++-
 test/api/test-aat-layout.c |  3 ++-
 test/api/test-font.c       |  2 +-
 test/api/test-map.c        |  9 ++++++---
 test/api/test-ot-color.c   |  9 +++++----
 test/api/test-ot-face.c    | 14 ++++++++------
 test/api/test-ot-name.c    | 30 ++++++++++++++++--------------
 test/api/test-ot-tag.c     | 11 ++++++-----
 8 files changed, 46 insertions(+), 35 deletions(-)

commit 09b16c536d31376de771eedde54620dd6c8f39d7
Author: Chun-wei Fan <fanchunwei@src.gnome.org>
Date:   Wed Dec 12 01:23:53 2018 +0800

    CMake: Fix Introspection builds

    We need to add -DHB_AAT_H and -DHB_AAT_H_IN to the flags that
    are passed
    to g-ir-scanner, so that introspection builds can proceed normally.

 CMakeLists.txt | 2 ++
 1 file changed, 2 insertions(+)

commit 1683bb2c9337fa34e5e80d459ab5eab99d7a9804
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Dec 8 13:57:39 2018 +0330

    [glyf] minor

 src/hb-ot-glyf-table.hh | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit f7cfe99815c07f82d5ad253af1e811db734bf92b
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Dec 8 13:40:44 2018 +0330

    [os2] Move typometrics detection logic to the table (#1465)

 src/hb-ot-hmtx-table.hh | 14 +++++---------
 src/hb-ot-os2-table.hh  |  7 ++++---
 2 files changed, 9 insertions(+), 12 deletions(-)

commit 47cf9a9633bbff12fef1131e7179dfc351f7e5f3
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Dec 8 10:20:25 2018 +0330

    Apply non-controversial parts of ot-style (#1464)

    Things to be used in https://github.com/harfbuzz/harfbuzz/pull/1459

 src/hb-aat-fdsc-table.hh    | 29 +++++++++++++++++++++++++---
 src/hb-aat-layout-common.hh |  1 +
 src/hb-ot-head-table.hh     | 13 +++++++++++++
 src/hb-ot-os2-table.hh      | 46
 +++++++++++++++++++++++++++++++++++++++++++++
 src/hb-ot-stat-table.hh     | 38 ++++++++++++++++++-------------------
 5 files changed, 105 insertions(+), 22 deletions(-)

commit 4d809696ef4db046d11072e5433ea5ff36bd7b26
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Dec 7 20:49:39 2018 -0800

    fix for issue #1447 (#1462)

    Added case for OpCode_BaseFontName. This opcode in spec but
    practically unused.
    Added a comment for default case which can't be hit

 src/hb-ot-cff1-table.hh | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 1abd4fcaec31053b442525d7f240af489c5974b1
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Dec 7 22:34:12 2018 +0330

    [fdsc] minor

 src/hb-aat-fdsc-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 59345cdef38cf1f514a6a0eb6e8852350acb6166
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Thu Dec 6 13:36:26 2018 -0800

    [CFF] Refix oss-fuzz 11714: set_blends (PR #1458) (#1460)

    * pass subarray of stack to set_blends

    * get_subarray to return a value, not ref

    * restored error check (with tweak)

 src/hb-cff-interp-common.hh |  5 +++++
 src/hb-cff2-interp-cs.hh    | 14 +++++++++-----
 2 files changed, 14 insertions(+), 5 deletions(-)

commit 20245f0000a0f04f2ba172b51ce69ee7ebb256aa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 6 10:27:37 2018 -0800

    Fix likely check

    Ouch!

 src/hb-cff-interp-dict-common.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit d866e905fd555d393464ed58d5fc11ee453c7ea4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 6 10:26:32 2018 -0800

    Add default value to first argument of sub_array()

 src/hb-dsalgs.hh | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit f1352f7486caaf6d3480ef2ac6b4719acf73e6a2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 6 10:21:06 2018 -0800

    Add sub_array to hb_vector_t

 src/hb-vector.hh | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit ca23b719357b01e98a5cf533bbf637d6706a4ec2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Dec 6 10:19:03 2018 -0800

    Add default-value for second arg of sub_array()

 src/hb-dsalgs.hh    | 7 +++----
 src/hb-open-type.hh | 8 ++++----
 2 files changed, 7 insertions(+), 8 deletions(-)

commit 6ad3fcddaf2ba8ebc9ad49ff9e7b33b60fcad16a
Merge: f95324a3 ae087d10
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Dec 6 10:21:00 2018 +0330

    Merge pull request #1458 from harfbuzz/cff-check-blends

    [CFF] oss-fuzz issue 11714: set_blends

commit ae087d10c22249f3aec3239e4eac98a728f71f75
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 21:47:34 2018 -0800

    add minimized test case for oss-fuzz issue 11714

 ...-testcase-minimized-hb-subset-fuzzer-5710107829075968 | Bin 0 ->
 3660 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 1ccbdcf73bbc967f5f94c0bc7f7e869bd87d9fa0
Merge: 14d29a10 f95324a3
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 21:37:38 2018 -0800

    Merge branch 'master' into cff-check-blends

commit 14d29a10437205566c4bd7bcfa2282d34d9f4f2f
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 21:33:29 2018 -0800

    check number of blends against args on stack

 src/hb-cff2-interp-cs.hh | 5 +++++
 1 file changed, 5 insertions(+)

commit f95324a3351c1f699214ad84d073268218ea83a3
Merge: 6727c4b6 9d8f3b0d
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Dec 6 08:33:44 2018 +0330

    Merge pull request #1457 from harfbuzz/cff-varstore-sanitize

    [CFF] oss-fuzz issue 11713 (CFF2VariationStore::serialize)

commit 6727c4b6f0356b08803b4d5cde608ec004e3533f
Merge: d9dabc00 34e3ef8f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 5 17:37:21 2018 -0800

    Merge pull request #1456 from harfbuzz/cff-subr-sanitize

    [CFF] fix oss-fuzz issue 11691 (BlendArg::set_blends)

commit 9d8f3b0dfbf39f5dfa25d52f47e8af6ad318eb17
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 17:14:51 2018 -0800

    add minimized test case for oss-fuzz issue 11713

 ...z-testcase-minimized-hb-subset-fuzzer-5660711141769216 | Bin 0 ->
 383 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit c31092ab34641072606f854408eb1bea18ed2507
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 17:04:55 2018 -0800

    sanitize variationStore in CFF2 against its size

 src/hb-ot-cff2-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 34e3ef8ff394f281b8d7e2c08f346a9495692edc
Merge: 72d8f763 d9dabc00
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 15:50:05 2018 -0800

    Merge branch 'master' into cff-subr-sanitize

commit 72d8f76368b264a42fe58438fe15811d458a7935
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 15:49:11 2018 -0800

    add minimized test case for oss-fuzz issue 11691

 ...z-testcase-minimized-hb-shape-fuzzer-5686369209286656 | Bin 0 ->
 2880 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit d9dabc00e9278a346e85538212c126da7e610d55
Merge: 81cfd3c7 010e2ddb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 5 15:39:34 2018 -0800

    Merge pull request #1454 from harfbuzz/cff-fixbcd

    [CFF] fix oss-fuzz issue 11674: parse_bcd

commit 81cfd3c775dbc470f57d7fe2775cc068ffa367b6
Merge: 8394a6cb 6708c559
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Dec 5 15:37:15 2018 -0800

    Merge pull request #1455 from harfbuzz/cff-strinc_assert

    [CFF] fix oss-fuzz issue 11675 (ASSERT: count <= str.len)

commit 6dcfda92c17a7701479118751a8290246e9a3c05
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 15:07:46 2018 -0800

    sanitize CFF1 & CFF2 global subrs

 src/hb-ot-cff1-table.hh | 2 +-
 src/hb-ot-cff2-table.hh | 1 +
 2 files changed, 2 insertions(+), 1 deletion(-)

commit 6708c5595fc6babdae0132f8a23cbe3558a58703
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 12:51:18 2018 -0800

    fix oss-fuzz issue 11675 (ASSERT: count <= str.len)

    Also added an additional error check to avail ()

 src/hb-cff-interp-common.hh                           |  18
 ++++++++++++++++--
 ...stcase-minimized-hb-subset-fuzzer-5768186323009536 | Bin 0 ->
 337 bytes
 2 files changed, 16 insertions(+), 2 deletions(-)

commit 010e2ddb384b5a721172fd7466aafec58dbf8063
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 12:23:58 2018 -0800

    minimized test case for oss-fuzz issue 11674

 ...zz-testcase-minimized-hb-subset-fuzzer-5672006905757696 | Bin 0 ->
 73 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 2cb9d4c183afc838ecf2ba0d47814e9eaa6f09c6
Merge: a5fa843c 8394a6cb
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 11:25:29 2018 -0800

    Merge branch 'master' into cff-fixbcd

commit a5fa843c746e20aaca48ece6cff057deb8d916ca
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 11:18:16 2018 -0800

    fixed a bug with fractional part in a negative value

 src/hb-cff-interp-dict-common.hh | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 8394a6cb252dd8b4230c2b59e8c346ec5403bf88
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Dec 5 15:23:41 2018 +0330

    [os2] Make newer table fields accessible (#1452)

 src/hb-ot-os2-table.hh | 88
 +++++++++++++++++++++++++++++++++++++-------------
 1 file changed, 66 insertions(+), 22 deletions(-)

commit 5ab086ebb18112ef48bf6c913acc91b2009a9bed
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Dec 5 14:17:37 2018 +0330

    [fdsc] Implement the table parsing

    Related to https://github.com/harfbuzz/harfbuzz/issues/1337

    May used in addition to an API related to STAT.

    Lots of Apple fonts have it.

 src/Makefile.sources     |   1 +
 src/hb-aat-fdsc-table.hh | 103
 +++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-aat-layout.cc     |   1 +
 3 files changed, 105 insertions(+)

commit 8f80e53341a3d5bac6c2c39ab6d6973eedb0b074
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Dec 5 13:51:14 2018 +0330

    [gasp] Implement the table parsing

    May or may not be used in
    https://github.com/harfbuzz/harfbuzz/pull/1432

 src/Makefile.sources    |  1 +
 src/hb-ot-gasp-table.hh | 84
 +++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-ot-layout.cc     |  5 +--
 3 files changed, 88 insertions(+), 2 deletions(-)

commit 79e7e3445efef2dc57f8a10c7e355e802af08868
Merge: cf4b7db6 78f639b8
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Dec 5 13:25:18 2018 +0330

    Merge pull request #1449 from harfbuzz/cff-fixcharset

    [CFF] fix for oss-fuzz 11657: Charset overrun

commit cf4b7db6b1e01c11d7a8a26d95cf947935a234a7
Merge: 32cc46c7 803d2f92
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Dec 5 13:23:23 2018 +0330

    Merge pull request #1448 from harfbuzz/cff-leak

    [CFF] fix leak: oss-fuzz 11662

commit 620d1ef588c6ce25644891cfe4b9c20fd8a9d1db
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 00:36:11 2018 -0800

    fix unsigned long const

 src/hb-cff-interp-dict-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 28dfb4c14280b05ad0a519f9df2b0eda41a62540
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Dec 5 00:26:03 2018 -0800

    fix signed/unsigned comparison

 src/hb-cff-interp-dict-common.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f9cee08edd32182044407bf6ffde00df0feb09b7
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 23:58:26 2018 -0800

    use sized int types in parse_bcd

 src/hb-cff-interp-dict-common.hh | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit c01a5f32a33fa875de68ca29a4672fd36a05245b
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 23:23:23 2018 -0800

    refix

 src/hb-cff-interp-dict-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 755fefc92113e469a1aadee2546958fede156c01
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 23:18:28 2018 -0800

    fix bug

 src/hb-cff-interp-dict-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0e81b153aff1f2e301e73ca1a15a9bc5b2e7bb82
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 22:40:07 2018 -0800

    fix typo

 src/hb-cff-interp-dict-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 85d4b15cd88ce9a6ffccccf90300f9c184166058
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 22:30:33 2018 -0800

    include float.h

 src/hb-cff-interp-dict-common.hh | 1 +
 1 file changed, 1 insertion(+)

commit 5a7c371e4c6f1775ebbfe120fafe92afe402a954
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 22:24:38 2018 -0800

    check overflow & clamp

 src/hb-cff-interp-dict-common.hh | 36
 +++++++++++++++++++++++++++---------
 1 file changed, 27 insertions(+), 9 deletions(-)

commit 32cc46c75a5f163f254b7998ed9193d5bbc85e4b
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 21:32:34 2018 -0800

    [CFF] fix oss-fuzz issue 11670: NULL dereference (#1450)

    * guard against no subr access

    * code tweak

    * add minimized testcase for oss-fuzz 11670 (Null deference)

 src/hb-cff-interp-cs-common.hh                     |  22
 ++++++++++++++++-----
 src/hb-ot-cff-common.hh                            |   2 +-
 ...ase-minimized-hb-subset-fuzzer-5672913680728064 | Bin 0 -> 861 bytes
 3 files changed, 18 insertions(+), 6 deletions(-)

commit 78f639b8bf508ccfb27224f12442f8e8a1460e08
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 14:17:03 2018 -0800

    added minimized testcase for oss-fuzz issue 11657

 ...zz-testcase-minimized-hb-shape-fuzzer-5700264032468992 | Bin 0 ->
 648 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit d3d2f32c6e85de1d7fbbb18afef356e09110e61c
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 13:51:26 2018 -0800

    fix oss-fuzz 11657: buffer overrun

    Check overrun in Charset1_2::get_glyph

 src/hb-ot-cff1-table.hh | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit d0a250a7b15f1099c2005bc2427d62e7370dcc33
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Tue Dec 4 23:42:13 2018 +0330

    Reuse hb_aat_layout_has_* logic in coretext-aat detection logic
    (#1442)

 src/hb-coretext.cc | 16 ++--------------
 1 file changed, 2 insertions(+), 14 deletions(-)

commit 803d2f92dca329a84d92c224a73e13906e8b8d56
Merge: 6ce8d10b c775adc1
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 11:01:26 2018 -0800

    Merge branch 'master' into cff-leak

commit 6ce8d10b45598f5f6dade38e65486f793f33d0b6
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 10:39:17 2018 -0800

    add unlikely to error handling

 src/hb-ot-cff1-table.hh | 2 +-
 src/hb-ot-cff2-table.hh | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit b61f74f69a84f427b40deefefed429fbc915981c
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 10:30:35 2018 -0800

    added minimized test case for oss-fuzz issue 11662

 ...testcase-minimized-hb-shape-fuzzer-5175735354916864 | Bin 0 ->
 354461 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 0b952e6026c8be13d16d97f464034ee477e6282f
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 10:22:35 2018 -0800

    more leak fixes

 src/hb-ot-cff1-table.hh | 2 +-
 src/hb-ot-cff2-table.hh | 3 ++-
 2 files changed, 3 insertions(+), 2 deletions(-)

commit c775adc1383f72f02b1329628b3eba1dc377a0f7
Merge: c968869f 04f2ca94
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Tue Dec 4 21:30:07 2018 +0330

    Merge pull request #1444 from harfbuzz/cff-assert

    removed assert, fixes https://github.com/harfbuzz/harfbuzz/issues/1443

commit 9473463f5c884fcb1de8a7ba7410da2601e6ffa8
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 09:58:48 2018 -0800

    fix attempt for oss-fuzz 11662 leak

 src/hb-ot-cff1-table.hh | 1 +
 1 file changed, 1 insertion(+)

commit 04f2ca94212983d675ed2cd36350be23ff2a6e19
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Tue Dec 4 09:24:07 2018 -0800

    removed assert

 src/hb-ot-cff1-table.hh | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit c968869f212dbfcb86d42fb36049328521cbf00c
Merge: 8c05b955 c48f53d3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Dec 4 04:14:13 2018 -0500

    Merge pull request #1441 from harfbuzz/cff-doublenum

    use double as CFF Number implementation

commit c48f53d30901dfc20b7432c2947e66642010dc4e
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Mon Dec 3 16:59:41 2018 -0800

    more double changes

 src/hb-cff2-interp-cs.hh       | 4 ++--
 test/api/test-ot-extents-cff.c | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit 9424e8052686a6a93e0d30e38aecbe927db9d787
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Mon Dec 3 16:18:10 2018 -0800

    added minimized test cases

 ...zz-testcase-minimized-hb-shape-fuzzer-5647267827023872 | Bin 0 ->
 655 bytes
 ...zz-testcase-minimized-hb-shape-fuzzer-5725855502827520 | Bin 0 ->
 655 bytes
 ...zz-testcase-minimized-hb-shape-fuzzer-5736657639178240 | Bin 0 ->
 459 bytes
 3 files changed, 0 insertions(+), 0 deletions(-)

commit 5fff6ab0024547a8ac47723a0047f4b17416d6ce
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Mon Dec 3 16:06:58 2018 -0800

    additional precision made a difference in extents test

 src/hb-cff-interp-common.hh    | 2 +-
 src/hb-cff2-interp-cs.hh       | 2 +-
 test/api/test-ot-extents-cff.c | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit 9e5180cd444b6900a0fa0c3df4c8138f9a663383
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Mon Dec 3 15:32:42 2018 -0800

    more double changes

 src/hb-cff-interp-common.hh      |  8 ++++----
 src/hb-cff-interp-dict-common.hh | 10 +++++-----
 2 files changed, 9 insertions(+), 9 deletions(-)

commit 9af33d7a2ad5ce88fc508bc5c6a56be4650d2621
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Mon Dec 3 14:48:46 2018 -0800

    Number to use double for all types

 src/hb-cff-interp-common.hh | 84
 +++++++--------------------------------------
 1 file changed, 13 insertions(+), 71 deletions(-)

commit 8c05b955eb4aa088b2b5df9b6415863486eaf59c
Merge: d19b1680 01f628cf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 3 14:30:51 2018 -0500

    Merge pull request #1439 from ebraminio/tracking

    [aat] Expose hb_aat_layout_has_tracking API

commit 01f628cf5571b8b58108ab66cfc3e929c9840e31
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Mon Dec 3 22:04:48 2018 +0330

    [aat] Expose hb_aat_layout_has_tracking API

 docs/harfbuzz-sections.txt  |   7 ++++---
 src/hb-aat-layout.cc        |   9 ++++++++-
 src/hb-aat-layout.h         |   8 ++++++++
 src/hb-aat-layout.hh        |   3 ---
 test/api/fonts/aat-morx.ttf | Bin 0 -> 1620 bytes
 test/api/fonts/aat-trak.ttf | Bin 0 -> 2456 bytes
 test/api/test-aat-layout.c  |  13 +++++++++++++
 7 files changed, 33 insertions(+), 7 deletions(-)

commit d19b1680b53e54f449736432f369a676c394ebf8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Dec 3 10:41:37 2018 -0500

    [aat] Expose a couple APIs

    New API:
    +hb_aat_layout_has_substitution()
    +hb_aat_layout_has_positioning()

 docs/harfbuzz-sections.txt |  2 ++
 src/hb-aat-layout.cc       | 20 ++++++++++++++++----
 src/hb-aat-layout.h        | 16 ++++++++++++++++
 src/hb-aat-layout.hh       |  6 ------
 4 files changed, 34 insertions(+), 10 deletions(-)

commit 84efe0438e1cfc5b070e114b70e8c070be6119ca
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Dec 2 12:38:53 2018 -0500

    [aat] Fix division sign fallout

    Happened after 11d2f49af8f53340134c844173f4d8655b00dea3
    since now nClasses is unsigned int...

 src/hb-aat-layout-common.hh                               |   2 +-
 ...zz-testcase-minimized-hb-shape-fuzzer-5768046065483776 | Bin 0 ->
 342 bytes
 2 files changed, 1 insertion(+), 1 deletion(-)

commit 2087f5a2a743380b36399ba8a2b4ff9e93890fcf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 1 20:04:45 2018 -0500

    Add casts to hb_array_t<>

 src/hb-open-type.hh | 13 ++++++++++---
 src/hb-vector.hh    |  2 ++
 2 files changed, 12 insertions(+), 3 deletions(-)

commit 58d4d19947794aded4e966290b01e1034f216a7d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 1 19:34:18 2018 -0500

    Simplify build source list

 CMakeLists.txt       |  12 +--
 src/Makefile.am      |   6 --
 src/Makefile.sources | 231
 ++++++++++++++++++++++++---------------------------
 3 files changed, 111 insertions(+), 138 deletions(-)

commit 967a204ee92548163a0d19678a237dcaf3720c20
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 1 19:28:17 2018 -0500

    Minor

 test/api/hb-subset-test.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 11d2f49af8f53340134c844173f4d8655b00dea3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 1 13:12:21 2018 -0500

    New approach to change BigEndian casts to be int-sized

    Fixes spurious warnings like:
    Fixes https://github.com/harfbuzz/harfbuzz/issues/1436

 src/hb-open-type.hh | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

commit 50e0273ab18acd2fbb21bcf18ad487092e890b4e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 1 13:03:52 2018 -0500

    Change hb_assert_unsigned_t<> to hb_is_signed<>

 src/hb-dsalgs.hh | 16 ++++++++++------
 1 file changed, 10 insertions(+), 6 deletions(-)

commit c3a8b047aab47e40dc107a952b3a1472068ec932
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 1 00:14:48 2018 -0500

    Revert "Change BigEndian casts to be int-sized"

    This reverts commit eb5ddd32bf4e458ca0af8d5784f8fd46485ad225.

    Broke tests, badly.  To be investigated and reenabled.

 src/hb-open-type.hh | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit be45677ab605efc711a433323d66e4051c289252
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 1 00:04:29 2018 -0500

    Minor

 src/hb-ot-layout-gsub-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit eb5ddd32bf4e458ca0af8d5784f8fd46485ad225
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Dec 1 00:03:01 2018 -0500

    Change BigEndian casts to be int-sized

    Fixes spurious warnings like:
    Fixes https://github.com/harfbuzz/harfbuzz/issues/1436

 src/hb-open-type.hh | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit e8860fdcaa69e3452edd903f78599bc8fa9d109c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 23:38:24 2018 -0500

    Fix more warning

 src/hb-ot-cff-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit af349ee3487b31c2328f0a37a43d31b248ed14e5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 23:20:50 2018 -0500

    Fix warning

 src/hb-ot-cff-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 825df6dbc7fd013c68d7b5672f81e69b69bc14e7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 23:04:59 2018 -0500

    [CFF] Change spaces to tabs

 src/hb-cff-interp-common.hh      | 389 ++++++++++++++++-----------------
 src/hb-cff-interp-cs-common.hh   | 324 ++++++++++++++--------------
 src/hb-cff-interp-dict-common.hh | 190 ++++++++--------
 src/hb-cff1-interp-cs.hh         |  72 +++----
 src/hb-cff2-interp-cs.hh         |  76 +++----
 src/hb-ot-cff-common.hh          | 128 +++++------
 src/hb-ot-cff1-table.cc          |   4 +-
 src/hb-ot-cff1-table.hh          | 456
 +++++++++++++++++++--------------------
 src/hb-ot-cff2-table.cc          |   4 +-
 src/hb-ot-cff2-table.hh          | 216 +++++++++----------
 src/hb-subset-cff-common.cc      |  76 +++----
 src/hb-subset-cff-common.hh      | 384 ++++++++++++++++-----------------
 src/hb-subset-cff1.cc            | 416
 +++++++++++++++++------------------
 src/hb-subset-cff1.hh            |   2 +-
 src/hb-subset-cff2.cc            | 240 ++++++++++-----------
 src/hb-subset-cff2.hh            |   2 +-
 16 files changed, 1492 insertions(+), 1487 deletions(-)

commit 592f39b3c4ed04a6f6cf129020358e64782c7108
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 22:54:57 2018 -0500

    [CFF] Whitespace

 src/hb-cff-interp-common.hh      |  7 +++----
 src/hb-cff-interp-cs-common.hh   |  6 +++---
 src/hb-cff-interp-dict-common.hh |  6 +++---
 src/hb-cff2-interp-cs.hh         |  2 +-
 src/hb-ot-cff-common.hh          | 12 ++++++------
 src/hb-ot-cff1-table.hh          | 30 +++++++++++++++---------------
 src/hb-ot-cff2-table.hh          | 12 ++++++------
 src/hb-subset-cff-common.cc      |  8 ++++----
 src/hb-subset-cff-common.hh      | 34 +++++++++++++++++-----------------
 src/hb-subset-cff1.cc            | 20 ++++++++++----------
 src/hb-subset-cff2.cc            | 18 +++++++++---------
 11 files changed, 77 insertions(+), 78 deletions(-)

commit a2e8d1d455c5d0ae22927567cf8a9a2539cd3470
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 22:54:20 2018 -0500

    Minor

 src/Makefile.sources | 27 +++++++++++++--------------
 1 file changed, 13 insertions(+), 14 deletions(-)

commit e3dc47c6357813d2dd098aad312d79e9d7c2aa18
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 22:43:22 2018 -0500

    Remove generated files that were accidentally added by CFF2 branch

 gtk-doc.make      |  320 --
 m4/libtool.m4     | 8369
 -----------------------------------------------------
 m4/ltoptions.m4   |  437 ---
 m4/ltsugar.m4     |  124 -
 m4/ltversion.m4   |   23 -
 m4/lt~obsolete.m4 |   99 -
 6 files changed, 9372 deletions(-)

commit 5e64e0f53259dbc0a3ea8e220ded15e85bbc1782
Merge: 09096aa8 d8c69137
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 22:40:54 2018 -0500

    Merge pull request #1113 from harfbuzz/cff-subset

    CFF/CFF2 subsetter

commit 09096aa89f1944dff94a5518bce578eba8989e74
Author: Bruce Mitchener <bruce.mitchener@gmail.com>
Date:   Sat Dec 1 10:22:49 2018 +0700

    Use nullptr instead of 0/NULL. (#1435)

    * Use nullptr instead of 0/NULL.

    * Update test-name-table.cc

 src/hb-debug.hh        | 2 +-
 src/test-name-table.cc | 4 ++--
 2 files changed, 3 insertions(+), 3 deletions(-)

commit d8c69137655fbe9678d1dfef0eb3c4172f8bbfc0
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Nov 30 18:58:14 2018 -0800

    undo 0u

 src/hb-cff2-interp-cs.hh    | 2 +-
 src/hb-ot-cff1-table.hh     | 4 ++--
 src/hb-ot-vorg-table.hh     | 2 +-
 src/hb-subset-cff-common.hh | 4 ++--
 src/hb-subset-cff1.cc       | 4 ++--
 5 files changed, 8 insertions(+), 8 deletions(-)

commit 2c859b3880868b30823eb00bed90dc0de873628b
Merge: 9483da14 bb72de66
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Nov 30 18:47:34 2018 -0800

    Merge branch 'master' into cff-subset

commit bb72de66ddf3ae9ae53cf68642cb228e88aa64f5
Merge: fedd8e6c fb059082
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 21:36:35 2018 -0500

    Merge pull request #1433 from harfbuzz/overload-overload

    Fix ambiguous overload errors with old compilers

commit fb059082138bf17a5a8616410d9a35f927f9fd85
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 20:45:40 2018 -0500

    Revert ugly fixes

    Now that we have 6daf45e0, revert cryptic hacks...

    This reverts commit abd81ed4f5cbc5a94171747909bc6b77551cb929.
    This reverts commit 9c6921c08c905a0cf45ba0182134e6ff910fac51.
    This reverts commit d39760cabfe4007cefdfc45231e85e93fababac2.
    This reverts commit fedd8e6c176dea85194693399e50243eb1c117c4.

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1374

 src/hb-aat-layout-morx-table.hh |  4 ++--
 src/hb-face.cc                  |  4 ++--
 src/hb-machinery.hh             |  4 ++--
 src/hb-ot-color-cpal-table.hh   |  2 +-
 src/hb-ot-kern-table.hh         |  2 +-
 src/hb-ot-layout-gpos-table.hh  | 32 ++++++++++++++++----------------
 src/hb-ot-layout-gsubgpos.hh    | 14 +++++++-------
 7 files changed, 31 insertions(+), 31 deletions(-)

commit dfad19ad5aefdacecca6af81917abc2670d4416f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 19:57:12 2018 -0500

    Make operator [] take signed int

    The built-in operator takes signed int.  So, match it, such that
    the built-in is never a better or equally-good match to our operator.
    Fixes "ambiguous overload" errors from gcc 4.2 and VS 2008.

    See https://github.com/harfbuzz/harfbuzz/issues/1374

 src/hb-dsalgs.hh    |  3 ++-
 src/hb-open-type.hh | 42 ++++++++++++++++++++++++++++--------------
 src/hb-vector.hh    |  6 ++++--
 3 files changed, 34 insertions(+), 17 deletions(-)

commit 9483da145d6da1bdfa3224fe13a5b4e9b449d19f
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Nov 30 16:59:41 2018 -0800

    redo fixes

 src/hb-cff2-interp-cs.hh    | 2 +-
 src/hb-ot-cff1-table.hh     | 4 ++--
 src/hb-subset-cff-common.hh | 6 +++---
 src/hb-subset-cff1.cc       | 4 ++--
 4 files changed, 8 insertions(+), 8 deletions(-)

commit 291da448237cdc0b5534fbc1ce2288e1aa8e7b8a
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Nov 30 16:50:46 2018 -0800

    yet another

 src/hb-subset-cff-common.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b1821b9d092e4fd7fd888f4bffc341283bace461
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Nov 30 16:31:01 2018 -0800

    some more

 src/hb-subset-cff-common.hh | 4 ++--
 src/hb-subset-cff1.cc       | 4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

commit 9784cff55688d1ee93275e39c2339d5a486ed78b
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Nov 30 16:07:08 2018 -0800

    fix another pesky gcc error

 src/hb-cff2-interp-cs.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 23a797b44365ed76fc7db25be13bd9c3580a8695
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Nov 30 15:15:31 2018 -0800

    silence picky gcc errors

 src/hb-ot-cff1-table.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 9ae954f43ad1eb703d54db98ce46157370b71a9c
Merge: 471db3aa fedd8e6c
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Fri Nov 30 15:00:52 2018 -0800

    Merge branch 'master' into cff-subset

commit fedd8e6c176dea85194693399e50243eb1c117c4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 16:50:30 2018 -0500

    One more.........

    I wonder if there's something better to do about these :(.

    In file included from hb-ot-color.cc:31:
    hb-ot-color-cpal-table.hh: In member function 'unsigned int
    OT::CPAL::get_size() const':
    hb-ot-color-cpal-table.hh:118: error: ISO C++ says that these are
    ambiguous, even though the worst conversion for the first is better
    than the worst conversion for the second:

 src/hb-ot-color-cpal-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bc5db9b0807767ac04d6e50070d69cb9c520f06e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 16:04:52 2018 -0500

    One more....

    hb-ot-vorg-table.hh:96: error: ISO C++ says that these are ambiguous,
    even though the worst conversion for the first is better than the
    worst conversion for the second:
    hb-vector.hh:87: note: candidate 1: const Type& hb_vector_t<Type,
    PreallocedCount>::operator[](unsigned int) const [with Type =
    OT::VertOriginMetric, unsigned int PreallocedCount = 8u]
    hb-ot-vorg-table.hh:96: note: candidate 2: operator[](const T*,
    int) <built-in>

 src/hb-ot-vorg-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d39760cabfe4007cefdfc45231e85e93fababac2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 15:55:30 2018 -0500

    One more...

    Sigh.

    hb-ot-kern-table.hh: In member function 'int
    OT::KernSubTableFormat3<KernSubTableHeader>::get_kerning(hb_codepoint_t,
    hb_codepoint_t) const':
    hb-ot-kern-table.hh:59: error: ambiguous overload for 'operator[]'
    in 'kernValue[kernIndex[i]]'
    hb-ot-kern-table.hh:59: note: candidates are: operator[](T*, int)
    <built-in>
    hb-dsalgs.hh:574: note:                 Type&
    hb_array_t<Type>::operator[](unsigned int) const [with Type = const
    OT::IntType<short int, 2u>]

 src/hb-ot-kern-table.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9c6921c08c905a0cf45ba0182134e6ff910fac51
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 15:16:57 2018 -0500

    More...

    hb-ot-layout-gsubgpos.hh:1707: error: ISO C++ says that these are
    ambiguous, even though the worst conversion for the first is better
    than the worst conversion for the second:
    ...

 src/hb-aat-layout-morx-table.hh |  4 ++--
 src/hb-ot-layout-gpos-table.hh  | 32 ++++++++++++++++----------------
 src/hb-ot-layout-gsubgpos.hh    | 16 ++++++++--------
 3 files changed, 26 insertions(+), 26 deletions(-)

commit f998bb2086342d6fdcd4295593eddea91396e0b6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 12:52:21 2018 -0500

    More weird fixes

    In file included from hb-ot-name.cc:29:
    hb-ot-name-table.hh: In member function 'unsigned int
    OT::name::get_size() const':
    hb-ot-name-table.hh:157: error: ISO C++ says that these are ambiguous,
    even though the worst conversion for the first is better than the
    worst conversion for the second:
    hb-open-type.hh:354: note: candidate 1: const Type&
    OT::UnsizedArrayOf<Type>::operator[](unsigned int) const [with Type
    = OT::NameRecord]
    hb-ot-name-table.hh:157: note: candidate 2: operator[](const T*,
    int) <built-in>
    hb-ot-name-table.hh: In member function 'void
    OT::name::accelerator_t::init(hb_face_t*)':
    hb-ot-name-table.hh:196: error: ISO C++ says that these are ambiguous,
    even though the worst conversion for the first is better than the
    worst conversion for the second:
    hb-dsalgs.hh:574: note: candidate 1: Type&
    hb_array_t<Type>::operator[](unsigned int) const [with Type =
    const OT::NameRecord]
    hb-ot-name-table.hh:196: note: candidate 2: operator[](T*, int)
    <built-in>
    hb-ot-name-table.hh:197: error: ISO C++ says that these are ambiguous,
    even though the worst conversion for the first is better than the
    worst conversion for the second:
    hb-dsalgs.hh:574: note: candidate 1: Type&
    hb_array_t<Type>::operator[](unsigned int) const [with Type =
    const OT::NameRecord]
    hb-ot-name-table.hh:197: note: candidate 2: operator[](T*, int)
    <built-in>
    hb-ot-name-table.hh:198: error: ISO C++ says that these are ambiguous,
    even though the worst conversion for the first is better than the
    worst conversion for the second:
    hb-dsalgs.hh:574: note: candidate 1: Type&
    hb_array_t<Type>::operator[](unsigned int) const [with Type =
    const OT::NameRecord]
    hb-ot-name-table.hh:198: note: candidate 2: operator[](T*, int)
    <built-in>
    make[4]: *** [libharfbuzz_la-hb-ot-name.lo] Error 1
    make[3]: *** [all-recursive] Error 1

 src/hb-ot-name-table.hh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 67fd94da98f950b5feb719ac805f2a45379fc935
Merge: abd81ed4 ae79fdaa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 11:53:30 2018 -0500

    Merge commit 'ae79fdaa7774d3f886a8f03926577c3bd2010b03'

commit abd81ed4f5cbc5a94171747909bc6b77551cb929
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 11:51:26 2018 -0500

    Umm.  Cryptic, yes

    In file included from hb-face.cc:35:
    hb-ot-cmap-table.hh: In member function 'void
    OT::CmapSubtableFormat4::_compiles_assertion_on_line_388() const':
    hb-ot-cmap-table.hh:388: error: ISO C++ says that these are ambiguous,
    even though the worst conversion for the first is better than the
    worst conversion for the second:
    hb-open-type.hh:354: note: candidate 1: const Type&
    OT::UnsizedArrayOf<Type>::operator[](unsigned int) const [with Type =
    OT::IntType<short unsigned int, 2u>]
    hb-ot-cmap-table.hh:388: note: candidate 2: operator[](const T*,
    int) <built-in>
    hb-ot-cmap-table.hh: In member function 'void
    OT::CmapSubtableFormat4::_instance_assertion_on_line_388() const':
    hb-ot-cmap-table.hh:388: error: ISO C++ says that these are ambiguous,
    even though the worst conversion for the first is better than the
    worst conversion for the second:
    hb-open-type.hh:354: note: candidate 1: const Type&
    OT::UnsizedArrayOf<Type>::operator[](unsigned int) const [with Type =
    OT::IntType<short unsigned int, 2u>]
    hb-ot-cmap-table.hh:388: note: candidate 2: operator[](const T*,
    int) <built-in>
    hb-face.cc: In function 'hb_blob_t*
    _hb_face_builder_data_reference_blob(hb_face_builder_data_t*)':
    hb-face.cc:650: error: ISO C++ says that these are ambiguous, even
    though the worst conversion for the first is better than the worst
    conversion for the second:
    hb-vector.hh:81: note: candidate 1: Type& hb_vector_t<Type,
    PreallocedCount>::operator[](unsigned int) [with Type =
    hb_face_builder_data_t::table_entry_t, unsigned int PreallocedCount
    = 32u]
    hb-face.cc:650: note: candidate 2: operator[](T*, int) <built-in>
    hb-face.cc:650: error: ISO C++ says that these are ambiguous, even
    though the worst conversion for the first is better than the worst
    conversion for the second:
    hb-vector.hh:81: note: candidate 1: Type& hb_vector_t<Type,
    PreallocedCount>::operator[](unsigned int) [with Type =
    hb_face_builder_data_t::table_entry_t, unsigned int PreallocedCount
    = 32u]
    hb-face.cc:650: note: candidate 2: operator[](const T*, int)
    <built-in>
    hb-face.cc:651: error: ISO C++ says that these are ambiguous, even
    though the worst conversion for the first is better than the worst
    conversion for the second:
    hb-vector.hh:81: note: candidate 1: Type& hb_vector_t<Type,
    PreallocedCount>::operator[](unsigned int) [with Type =
    hb_face_builder_data_t::table_entry_t, unsigned int PreallocedCount
    = 32u]
    hb-face.cc:651: note: candidate 2: operator[](T*, int) <built-in>
    hb-face.cc:651: error: ISO C++ says that these are ambiguous, even
    though the worst conversion for the first is better than the worst
    conversion for the second:
    hb-vector.hh:81: note: candidate 1: Type& hb_vector_t<Type,
    PreallocedCount>::operator[](unsigned int) [with Type =
    hb_face_builder_data_t::table_entry_t, unsigned int PreallocedCount
    = 32u]
    hb-face.cc:651: note: candidate 2: operator[](const T*, int)
    <built-in>

 src/hb-face.cc      | 4 ++--
 src/hb-machinery.hh | 4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

commit ae79fdaa7774d3f886a8f03926577c3bd2010b03
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 11:51:26 2018 -0500

    Umm.  Cryptic, yes

    hb-face.cc:650: error: ISO C++ says that these are ambiguous, even
    though the worst conversion for the first is better than the worst
    conversion for the second:
    hb-vector.hh:81: note: candidate 1: Type& hb_vector_t<Type,
    PreallocedCount>::operator[](unsigned int) [with Type =
    hb_face_builder_data_t::table_entry_t, unsigned int PreallocedCount
    = 32u]
    hb-face.cc:650: note: candidate 2: operator[](T*, int) <built-in>

 src/hb-face.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 0f32c95e1487ffcc37439635c3294f941eae857a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 11:31:39 2018 -0500

    Fix a few more sizeof(vector[0]) errors with weird compilers

 src/hb-face.cc | 4 ++--
 src/hb-set.hh  | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit 88630a458b21b811075bed9e761a94c50736dc11
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 01:11:04 2018 -0500

    Fix build for realz

 src/hb-ot-deprecated.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 346286d04eb616c43ba8c796211fa2e5e7bf1983
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 00:44:40 2018 -0500

    Fix build

 src/hb-ot-deprecated.h | 1 +
 1 file changed, 1 insertion(+)

commit 31f39cb41e1497a76c5838c93f9b4034089049f2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 00:38:08 2018 -0500

    [post] Rename v2 to v2X

 src/hb-ot-post-table.hh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit e3dd47e6025a7f082af4830ba483d90d9b44381f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 30 00:32:12 2018 -0500

    Move things

 src/Makefile.sources   |   1 +
 src/hb-deprecated.h    |  61 +---------------------------
 src/hb-ot-deprecated.h | 106
 +++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-ot.h            |   1 +
 4 files changed, 109 insertions(+), 60 deletions(-)

commit 27a6b0a2f7255ed6fc7bfe1f10052c2e344e319b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 16:29:30 2018 -0500

    Fix build for realz

 src/hb-coretext.cc  |  2 +-
 src/hb-uniscribe.cc | 10 +++++-----
 2 files changed, 6 insertions(+), 6 deletions(-)

commit e2af4dd1ecbe398c60fe5f3f370dd35400d7e1eb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 16:03:15 2018 -0500

    [uniscribe] Fix build

 src/hb-uniscribe.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bf738ba3ba80778c7feb95ece446607a250d9382
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Nov 30 00:06:40 2018 +0330

    [test][aat] Remove extra --shaper ot

    As run-tests.py already adds it

 test/shaping/data/in-house/tests/macos.tests | 64
 ++++++++++++++--------------
 1 file changed, 32 insertions(+), 32 deletions(-)

commit b65645bbafb3f1f9f956df3028cf4479a4bdc265
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 29 23:57:50 2018 +0330

    [ci] Re-enable llvm-gcc-4.2 bots (#1429)

 .circleci/config.yml | 48
 ++++++++++++++++++++++++------------------------
 1 file changed, 24 insertions(+), 24 deletions(-)

commit e7bd29ea11bd6301a332b471120a4a2cd8575d09
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 29 23:47:20 2018 +0330

    Limit __builtin_bswap16 to GCC >= 5 as it was implemented on 4.8

 src/hb-machinery.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ac0264717b949df8840b179d882a9bed2993fb74
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 15:07:44 2018 -0500

    [coretext] Fix compile

    Fingers crossed.

 src/hb-coretext.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5c4fead734b082e0168e6811bec4bcaa19acc36a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 15:04:34 2018 -0500

    Convert "static const hb_tag_t" constants to enum

 src/hb-aat-layout-ankr-table.hh |  2 +-
 src/hb-aat-layout-bsln-table.hh |  2 +-
 src/hb-aat-layout-feat-table.hh |  2 +-
 src/hb-aat-layout-just-table.hh |  2 +-
 src/hb-aat-layout-kerx-table.hh |  2 +-
 src/hb-aat-layout-lcar-table.hh |  2 +-
 src/hb-aat-layout-morx-table.hh |  6 +++---
 src/hb-aat-layout-trak-table.hh |  2 +-
 src/hb-aat-ltag-table.hh        |  2 +-
 src/hb-ot-cmap-table.hh         |  2 +-
 src/hb-ot-color-cbdt-table.hh   |  4 ++--
 src/hb-ot-color-colr-table.hh   |  2 +-
 src/hb-ot-color-cpal-table.hh   |  2 +-
 src/hb-ot-color-sbix-table.hh   |  2 +-
 src/hb-ot-color-svg-table.hh    |  2 +-
 src/hb-ot-glyf-table.hh         |  4 ++--
 src/hb-ot-hdmx-table.hh         |  2 +-
 src/hb-ot-head-table.hh         |  2 +-
 src/hb-ot-hhea-table.hh         |  4 ++--
 src/hb-ot-hmtx-table.hh         | 14 +++++++-------
 src/hb-ot-kern-table.hh         |  6 +++---
 src/hb-ot-layout-base-table.hh  |  2 +-
 src/hb-ot-layout-gdef-table.hh  |  2 +-
 src/hb-ot-layout-gpos-table.hh  |  2 +-
 src/hb-ot-layout-gsub-table.hh  |  2 +-
 src/hb-ot-layout-jstf-table.hh  |  2 +-
 src/hb-ot-math-table.hh         |  2 +-
 src/hb-ot-maxp-table.hh         |  2 +-
 src/hb-ot-name-table.hh         |  2 +-
 src/hb-ot-os2-table.hh          |  2 +-
 src/hb-ot-post-table.hh         |  2 +-
 src/hb-ot-stat-table.hh         |  2 +-
 src/hb-ot-var-avar-table.hh     |  2 +-
 src/hb-ot-var-fvar-table.hh     |  2 +-
 src/hb-ot-var-hvar-table.hh     |  8 ++++----
 src/hb-ot-var-mvar-table.hh     |  2 +-
 src/hb-ot-vorg-table.hh         |  2 +-
 37 files changed, 53 insertions(+), 53 deletions(-)

commit 9e4138c82548c2b29a1ae8801d2c6c7c1f1a9c7a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 15:01:10 2018 -0500

    Convert misc "static const" constants to enum

 src/hb-aat-layout-kerx-table.hh |  4 ++--
 src/hb-map.hh                   |  2 +-
 src/hb-ot-kern-table.hh         |  4 ++--
 src/hb-set-digest.hh            | 14 +++++++-------
 4 files changed, 12 insertions(+), 12 deletions(-)

commit 44cbd2ea3dc36312bd80860983b6616586e78c6c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 14:53:43 2018 -0500

    Convert "static const bool" constants to anonymous enum

 src/hb-aat-layout-common.hh     |  4 ++--
 src/hb-aat-layout-kerx-table.hh |  4 ++--
 src/hb-aat-layout-morx-table.hh |  8 ++++----
 src/hb-dsalgs.hh                | 16 ++++++++--------
 src/hb-ot-kern-table.hh         |  4 ++--
 src/hb-ot-layout.cc             |  4 ++--
 6 files changed, 20 insertions(+), 20 deletions(-)

commit 861bc75349257f74c12b261abfcd5ab9e2f04863
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 14:34:44 2018 -0500

    [vector] Make pointer cast explicit

    Too bad this doesn't help MSVC 2008 build, as explicit operators are
    C++11.

 src/hb-machinery.hh     | 2 +-
 src/hb-ot-cmap-table.hh | 3 ++-
 src/hb-set.hh           | 4 ++--
 src/hb-subset.cc        | 2 +-
 src/hb-vector.hh        | 4 ++--
 5 files changed, 8 insertions(+), 7 deletions(-)

commit 72955e68256806f082439d65e6f9b5cf2e35fa8a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 14:28:44 2018 -0500

    Hand-hold older compilers

 src/hb-set.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1a182e97ee71de0e78a70ff823ae17fa93a31830
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 12:39:52 2018 -0500

    [test/text-rendering-tests] Update from upstream

 .../text-rendering-tests/fonts/TestGVAR-Composite-0.ttf  | Bin 0 ->
 3136 bytes
 .../fonts/TestGVAR-Composite-Missing.ttf                 | Bin 0 ->
 2984 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 000d4b128eba58677acdc3b361829ff2f9a257b1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 12:32:47 2018 -0500

    Make shaper's override_features() override user features as well

    The override_features is used to override features that are normally
    discretionary features, but in a specific shaper are for various
    reasons desired to be bolted on or off, because they've been used
    for inherent shaping.  As such, it makes sense that they also
    override user features.  Ie. if user turned 'liga' on, we don't
    want Khmer shaping to become broken...  Or turn 'clig' off...

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1310

 src/hb-ot-shape.cc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit a95d9d8c8465ebc927bc2194dffe4ea95542e54c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 12:30:14 2018 -0500

    [khmer] Move 'clig' to overrides

    Prerequisite for https://github.com/harfbuzz/harfbuzz/issues/1310

 src/hb-ot-shape-complex-khmer.cc | 15 +++++++++------
 1 file changed, 9 insertions(+), 6 deletions(-)

commit 282ce7230b8bd8ad65c408cdaf1499504038247d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 12:18:14 2018 -0500

    Fix "typename outside template" issues

    Nothing an extra template class wouldn't fix...

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1419

 src/hb-null.hh | 25 +++++++++++++++++++------
 1 file changed, 19 insertions(+), 6 deletions(-)

commit dc41ecef85b094b30c612113606597b91c55351c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 11:53:53 2018 -0500

    2.2.0

 NEWS                 | 35 +++++++++++++++++++++++++++++++++++
 configure.ac         |  2 +-
 src/hb-aat-layout.cc |  6 +++---
 src/hb-aat-layout.h  |  4 ++--
 src/hb-deprecated.h  |  4 ++--
 src/hb-ot-var.cc     |  8 ++++----
 src/hb-ot-var.h      |  4 ++--
 src/hb-version.h     |  6 +++---
 8 files changed, 52 insertions(+), 17 deletions(-)

commit 7b85081be4fbd6cad75dc28ae933ce920f71b22d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 11:34:22 2018 -0500

    [icu] Minor

 src/hb-icu.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 0bcb1de1265368a27e53c6d935c965cbcb4130a0
Merge: e0307de8 a85886fc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 29 10:39:18 2018 -0500

    Merge pull request #1418 from gvictor/replace_icu_deprecated

    Replace @Deprecated ICU API - USCRIPT_CODE_LIMIT

commit e0307de818ad1f70ef96938642bda61d7a62532a
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 29 11:36:05 2018 +0330

    [test][aat.kern] More (#1427)

 test/shaping/data/in-house/tests/macos.tests | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit 471db3aa6f963ecd4ebaf66daa81ef245d30d3b8
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Nov 28 17:06:11 2018 -0800

    workaround for issue #1417

 src/hb-cff-interp-common.hh | 9 +++++++++
 1 file changed, 9 insertions(+)

commit 32d291ae899eb095500052bed2a22e5255a34838
Merge: 1ecbf4d3 949655aa
Author: Michiharu Ariza <ariza@adobe.com>
Date:   Wed Nov 28 16:27:45 2018 -0800

    Merge branch 'master' into cff-subset

commit 949655aa7853a4513af6b5247b9822be38f5d322
Merge: 7b78d223 d3d0f15f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Nov 28 17:21:57 2018 -0500

    Merge pull request #1425 from mbutterick/patch-1

    update simple shaping example (closes #298)

commit d3d0f15f7d20bedf7018fb2fb652f92ff4159bd7
Author: Matthew Butterick <mbutterick@users.noreply.github.com>
Date:   Wed Nov 28 13:46:12 2018 -0800

    update simple shaping example (closes #298)

    add call to `FT_Set_Char_Size`, otherwise default size remains at
    `0`, and glyph positions come back as `0` too

 docs/usermanual-getting-started.xml | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 7b78d2233df0e51e2967bc54a9202b3f9e05059a
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 29 00:55:05 2018 +0330

    [test][aat] Update expectency

    It is not visually noticeable but apparently affected by kern format2
    correct implementation.
    I should've checked CoreText result which can't as CircleCI outage.

 test/shaping/data/in-house/tests/macos.tests | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 5155067e10011f78f1ce35b3dadb062bccd3a706
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 29 00:07:00 2018 +0330

    [test] Add test for format2 kern (#1423)

 test/shaping/data/in-house/Makefile.sources             |   1 +
 .../fonts/e39391c77a6321c2ac7a2d644de0396470cd4bfe.ttf  | Bin 0 ->
 34116 bytes
 test/shaping/data/in-house/tests/kern-format2.tests     |   3 +++
 3 files changed, 4 insertions(+)

commit 42a2b496e428521151ff5cb07454d2e993f892cc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Nov 28 15:24:30 2018 -0500

    [kerx] Fix Format2 index calc again

 src/hb-aat-layout-common.hh     | 14 ++++++++++++++
 src/hb-aat-layout-kerx-table.hh |  2 +-
 2 files changed, 15 insertions(+), 1 deletion(-)

commit 9e4f03b6ed80a81f8aee5ba93564f5eabab4299c
Merge: 19863c80 a3267cf8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Nov 28 15:08:01 2018 -0500

    Merge remote-tracking branch 'fdo/master'

commit a3267cf803082af157a7f2b0026af2633b14f8e3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Nov 28 15:06:01 2018 -0500

    [kern] Fix kern table Format2 offsetToIndex

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1421

 src/hb-aat-layout-kerx-table.hh | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit f9a9c0fd1e561715d696c7bd840bab552d0718ee
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Nov 28 14:51:56 2018 -0500

    [kerx] Fix ClassTable implementation for 'kern' table Format 2

 src/hb-aat-layout-common.hh     |  8 +++++---
 src/hb-aat-layout-kerx-table.hh | 10 ++--------
 2 files changed, 7 insertions(+), 11 deletions(-)

commit 5b4a789ca857664668ff69936574dcd09bee6065
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Nov 28 14:46:26 2018 -0500

    [aat] Towards adding two ClassTable's

 src/hb-aat-layout-common.hh | 40 ++++++++++++++++++++--------------------
 1 file changed, 20 insertions(+), 20 deletions(-)

commit 19863c805982d5d1d059d4dd9376039d3fdaabcd
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Wed Nov 28 20:28:42 2018 +0330

    [test][aat] Add a test and make macOS runners faster (#1422)

 .circleci/config.yml                         | 15 +++-----
 test/shaping/data/in-house/tests/macos.tests | 54
 ++++++++++++++--------------
 2 files changed, 33 insertions(+), 36 deletions(-)

commit 987f4187722a05e3f360b85c66309a351fc5d6ad
Merge: 1042d9fb 4e2a03b6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Nov 27 17:40:32 2018 -0500

    Merge pull request #1398 from Adenilson/bigInt01

    Optimize harfbuzz big integer conversions

commit 4e2a03b6b6e0c0d1c4edea10dc1aae63eeb6c581
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Nov 27 17:40:09 2018 -0500

    Comment

 src/hb-machinery.hh | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 4a719a7f4c997ea7e47588bc0288c97706dae015
Author: Adenilson Cavalcanti <adenilson.cavalcanti@arm.com>
Date:   Tue Nov 20 14:41:19 2018 -0800

    Optimize harfbuzz big integer conversions

    Profiling showed that type conversions were adding considerable
    cycles in time
    spent doing text shaping.

    The idea is to optimize it using native processor instructions to
    help Blink
    layout performance.

    Doing further investigation revelead that compilers may not use the
    proper instruction on ARM 32bits builds (i.e. REV16).

    One way to insure that the generated ASM was ideal for both gcc/clang
    was using __builtin_bswap16.

    Added bonus is that we no longer need to test for CPU architecture.

 src/hb-machinery.hh | 4 ++++
 1 file changed, 4 insertions(+)

commit a85886fc77083084e9a12ee15b47eab7876f9f53
Author: Victor Chang <vichang@google.com>
Date:   Tue Nov 27 11:34:56 2018 +0000

    Replace @Deprecated ICU API - USCRIPT_CODE_LIMIT

    Use of the deprecated API USCRIPT_CODE_LIMIT prevents harfbuzz
    using the ICU4C as a shared library.

    The API has been replaced by u_getIntPropertyMaxValue(UCHAR_SCRIPT)

 src/hb-icu.cc | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 1042d9fbc05aff9d51f15c2824a8521e963d0acd
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Mon Nov 26 18:58:39 2018 +0330

    [ci] Add .codecov.yml

    Similar to
    https://github.com/GoogleChrome/lighthouse/blob/master/.codecov.yml

    No strong preference on commenting, feel free to enable it again

 .codecov.yml | 7 +++++++
 1 file changed, 7 insertions(+)

commit 97eaedca5de76c74534bab41562aee130098558a
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Mon Nov 26 16:58:58 2018 +0330

    [test][aat] Enable Tamil MN test (#1414)

 test/shaping/data/in-house/tests/macos.tests | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 574d888c8a409295a952361a39c8e83a52a0fc3d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Nov 25 16:51:22 2018 -0500

    [aat] Ignore GSUB table of Muthu Foundry if they have morx table

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1410

 src/hb-ot-layout-gpos-table.hh |  3 +++
 src/hb-ot-layout-gsub-table.hh |  3 +++
 src/hb-ot-layout-gsubgpos.hh   |  5 +++++
 src/hb-ot-layout.cc            | 36 +++++++++++++++++++++++++++++++++++-
 4 files changed, 46 insertions(+), 1 deletion(-)

commit 4151c2848d8df75b6d0a4f5d79bee843158aa4a4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Nov 25 16:38:36 2018 -0500

    [GDEF] Move more code

 src/hb-ot-layout-gdef-table.hh | 10 +++++++++-
 src/hb-ot-layout.cc            | 11 -----------
 2 files changed, 9 insertions(+), 12 deletions(-)

commit 4f21703f225b6977196ef180e8d7300ea86d2cc3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Nov 25 15:59:18 2018 -0500

    [GDEF] Move code around

 src/hb-ot-layout-gdef-table.hh |  3 +++
 src/hb-ot-layout.cc            | 16 +++++++---------
 2 files changed, 10 insertions(+), 9 deletions(-)

commit 4ed9fb1a0050f3151f9332f08c8bb2c13652c607
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Nov 25 15:51:01 2018 -0500

    [GDEF] Minor

 src/hb-ot-layout.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0e3a48e54248d69197e8fb23c824d987f91b3bf7
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sun Nov 25 13:37:23 2018 +0330

    [test][aat] fix 10.13.6 Helvetica expectation

 test/shaping/data/in-house/tests/macos.tests | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cbc541b426f01717641f1f3529a7c9703aec7a28
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sun Nov 25 12:50:30 2018 +0330

    [aat] Add m grave test (#1412)

 test/shaping/data/in-house/tests/macos.tests | 4 ++++
 1 file changed, 4 insertions(+)

commit fa26ad0f48462063f2160a43cb62b018bb21e251
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sun Nov 25 11:25:17 2018 +0330

    [aat] Fix macos expectation

 test/shaping/data/in-house/tests/macos.tests | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 926f512f354835f8323bb2c2e58789dd918a9b65
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Nov 25 01:14:40 2018 -0500

    [aat.feat] Rework API and implementation

    Fixes https://github.com/harfbuzz/harfbuzz/pull/1346

 docs/harfbuzz-docs.xml          |  5 +++
 docs/harfbuzz-sections.txt      |  7 ++--
 src/hb-aat-layout-feat-table.hh | 89
 +++++++++++++++++++++++------------------
 src/hb-aat-layout.cc            | 80 ++++++++++++++++--------------------
 src/hb-aat-layout.h             | 32 +++++++++------
 test/api/test-aat-layout.c      | 58 ++++++++++++++-------------
 6 files changed, 141 insertions(+), 130 deletions(-)

commit 84dacbca7ea54a3ca2d5d711d50272a7f3baf456
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 12:08:36 2018 -0500

    [aat.feat] Add _MAX_VALUE to enums

 src/hb-aat-layout.h | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 3922aae1620958768d3257c0988432d5609dca1b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 11:02:04 2018 -0500

    [aat.feat] Minor

 src/hb-aat-layout-feat-table.hh | 12 ++----------
 1 file changed, 2 insertions(+), 10 deletions(-)

commit 0f8e98eca2463da3b83d1b66a19259a584df1682
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 11:00:42 2018 -0500

    [aat.feat] Whitespace

 src/hb-aat-layout-feat-table.hh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit c2256068339c9e10c8e6df5d1749be4b4eb04ad4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 10:54:40 2018 -0500

    [aat.feat] Port to SortedUnsizedArrayOf.bsearch()

 src/hb-aat-layout-feat-table.hh | 19 +++++++------------
 1 file changed, 7 insertions(+), 12 deletions(-)

commit 52ae9867efd6520d17306b9f3ad612fe5463e93d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 10:46:56 2018 -0500

    [AAT.feat] Use lsearch for looking up SettingName's

    They are not sorted.

 src/hb-aat-layout-feat-table.hh | 18 ++++++------------
 src/hb-open-type.hh             | 16 ++++++++--------
 src/hb-static.cc                |  6 ++++--
 3 files changed, 18 insertions(+), 22 deletions(-)

commit 44b9331f663c09174d94e06baf36d48a50599c42
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 10:30:35 2018 -0500

    [aat] Fix include issues

 src/Makefile.am | 2 ++
 src/hb-aat.h    | 2 ++
 2 files changed, 4 insertions(+)

commit b206133d1f616339a57996b634dadc7f0a2c4cfb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 14:05:11 2018 -0500

    [aat] Move contents of hb-aat.h to hb-aat-layout.h

    Since it was pages and pages...

 src/Makefile.sources |   1 +
 src/hb-aat-layout.cc |   1 -
 src/hb-aat-layout.h  | 452
 +++++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-aat-layout.hh |   1 -
 src/hb-aat-map.hh    |   1 -
 src/hb-aat.h         | 417
 +----------------------------------------------
 src/hb.hh            |   2 +
 7 files changed, 458 insertions(+), 417 deletions(-)

commit 2cb235d0210e74ea4ee123767b489301a9c340ab
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 12:23:35 2018 -0500

    [aat.feat] Fix enum namespace

 src/hb-aat-layout-feat-table.hh |   2 +-
 src/hb-aat-layout-morx-table.hh |   4 +-
 src/hb-aat-layout.cc            | 150 ++++++------
 src/hb-aat.h                    | 502
 ++++++++++++++++++++--------------------
 test/api/test-aat-layout.c      |   2 +-
 5 files changed, 330 insertions(+), 330 deletions(-)

commit 712762cabbbe85e6ab8361cd115c22a176827734
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 12:21:02 2018 -0500

    Minor

 src/hb-aat.h | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit e20f81f4fa977a8d22c6afee1e46fbf46bc182d9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 11:57:42 2018 -0500

    [aat] Rename feat API a bit more

 docs/harfbuzz-sections.txt      | 10 +++++-----
 src/hb-aat-layout-feat-table.hh |  8 ++++----
 src/hb-aat-layout.cc            | 32 ++++++++++++++++----------------
 src/hb-aat.h                    | 26 +++++++++++++-------------
 test/api/test-aat-layout.c      | 28 ++++++++++++++--------------
 5 files changed, 52 insertions(+), 52 deletions(-)

commit 54f4c17f0a932b0ca0317e1ad5e5e43a11a83fd1
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Nov 23 12:05:06 2018 +0330

    [feat] Rename API uses of setting to selector

 docs/harfbuzz-sections.txt      |  6 +--
 src/hb-aat-layout-feat-table.hh | 52 ++++++++++++------------
 src/hb-aat-layout-morx-table.hh |  2 +-
 src/hb-aat-layout.cc            | 88
 ++++++++++++++++++++---------------------
 src/hb-aat-layout.hh            |  4 +-
 src/hb-aat-map.cc               |  2 +-
 src/hb-aat-map.hh               |  2 +-
 src/hb-aat.h                    | 20 +++++-----
 test/api/test-aat-layout.c      | 46 ++++++++++-----------
 9 files changed, 111 insertions(+), 111 deletions(-)

commit 9c64b216ec7ae2c2c124ebd00dc6fa568752be78
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Nov 23 11:44:53 2018 +0330

    [feat] Apply renamings and add documentation

 docs/harfbuzz-sections.txt | 10 ++++++++++
 src/hb-aat-layout.cc       | 44
 ++++++++++++++++++++++++++++++++++++++------
 src/hb-aat.h               |  6 +++---
 test/api/test-aat-layout.c | 28 ++++++++++++++--------------
 4 files changed, 65 insertions(+), 23 deletions(-)

commit a8726cb4830f51a820db4bc6346ed09c91493817
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Nov 17 14:23:11 2018 +0330

    [feat] Use bsearch

 src/hb-aat-layout-feat-table.hh | 36 ++++++++++++++++++++++--------------
 src/hb-aat-layout-morx-table.hh |  2 +-
 src/hb.hh                       |  2 ++
 3 files changed, 25 insertions(+), 15 deletions(-)

commit 4009a05ca7de21fff2176621597cd0cd01e9d80e
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Nov 17 11:30:50 2018 +0330

    [feat] Address Behdad comments

 src/hb-aat-layout-feat-table.hh | 114 ++++---
 src/hb-aat-layout.cc            |  14 +-
 src/hb-aat.h                    | 673
 +++++++++++++++++-----------------------
 test/api/test-aat-layout.c      |  88 +++---
 4 files changed, 423 insertions(+), 466 deletions(-)

commit 19b6025534a98df96d67eee45c5c1ea6fbc1cc43
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Nov 17 01:07:09 2018 +0330

    [feat] Address @behdad comments

 src/Makefile.sources            |   2 +-
 src/hb-aat-layout-feat-table.hh |  82 +++----
 src/hb-aat-layout-morx-table.hh |   2 +-
 src/hb-aat-layout.cc            | 104 ++++----
 src/hb-aat-map.cc               |   2 +-
 src/hb-aat.h                    | 533
 ++++++++++++----------------------------
 src/hb-ot.h                     |   1 -
 test/api/test-aat-layout.c      |  84 +++----
 8 files changed, 282 insertions(+), 528 deletions(-)

commit 9212ec203c948e290a1d92b701619ccdbc89377c
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Nov 9 00:50:10 2018 +0330

    [feat] Complete feature types list

 src/hb-aat-layout-morx-table.hh |   2 +-
 src/hb-aat-layout.cc            | 154 ++++-----
 src/hb-aat.h                    | 697
 ++++++++++++++++++++++++++++++++++++++--
 3 files changed, 752 insertions(+), 101 deletions(-)

commit fbad794bd2c574363a0c5c5fefabce764496f93c
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 1 22:24:42 2018 +0330

    [feat] Add feature iteration API

 src/hb-aat-layout-feat-table.hh | 36 +++++++++++++++++++++--------
 src/hb-aat-layout.cc            | 26 +++++++++++----------
 src/hb-aat.h                    | 23 +++++++++++++++++--
 test/api/test-aat-layout.c      | 51
 +++++++++++++++++++++++++++--------------
 4 files changed, 96 insertions(+), 40 deletions(-)

commit 7a0471aa356bcd062d31a59bdb19c335249116c7
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 1 21:38:54 2018 +0330

    [feat] Turn AAT feature id into enum

 src/hb-aat-layout-feat-table.hh |  20 ++---
 src/hb-aat-layout-morx-table.hh |  10 +--
 src/hb-aat-layout.cc            | 170
 ++++++++++++++++++++--------------------
 src/hb-aat-layout.hh            |   6 +-
 src/hb-aat-map.cc               |   2 +-
 src/hb-aat-map.hh               |   4 +-
 src/hb-aat.h                    |  64 +++++++++------
 test/api/test-aat-layout.c      |   8 +-
 test/api/test-c.c               |   1 +
 9 files changed, 150 insertions(+), 135 deletions(-)

commit b233fa4bc9cdb1c6677b37106d96d878d6e03bfd
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 1 20:02:57 2018 +0330

    [feat] Rename records to selectors as @drott

 src/hb-aat-layout-feat-table.hh | 20 ++++++++++----------
 src/hb-aat-layout.cc            | 10 +++++-----
 src/hb-aat.h                    |  4 ++--
 3 files changed, 17 insertions(+), 17 deletions(-)

commit a157b3e4ebd57ad29f217c4cef6519e7398cfa5c
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 1 19:56:16 2018 +0330

    [feat] Apply @behdad comments

 src/Makefile.sources              |  2 +-
 src/hb-aat-layout-feat-table.hh   |  1 +
 src/hb-aat-layout.cc              | 16 ++++++++--------
 src/hb-aat-layout.hh              |  2 +-
 src/hb-aat-map.hh                 |  2 +-
 src/{hb-aat-layout.h => hb-aat.h} | 22 +++++++++++++---------
 src/hb-ot.h                       |  1 +
 test/api/test-aat-layout.c        | 14 +++++++-------
 test/api/test-c.c                 |  1 -
 9 files changed, 33 insertions(+), 28 deletions(-)

commit 3aff3f822f0d7bf7a2b5160ad93df3fe413c7c47
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 1 19:20:20 2018 +0330

    [feat] Apply @drott and @jfkthame comments

 src/hb-aat-layout-feat-table.hh | 14 ++++++--------
 src/hb-aat-layout.cc            | 12 +++++++-----
 src/hb-aat-layout.h             | 10 +++++-----
 test/api/test-aat-layout.c      |  4 ++--
 4 files changed, 20 insertions(+), 20 deletions(-)

commit b791bbbae47aa19709da640a1dc5e84590c5c2c2
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 1 15:15:56 2018 +0330

    [feat] Apply @jfkthame reviews

 src/hb-aat-layout-feat-table.hh |  27 +++++++++++++++------------
 src/hb-aat-layout.cc            |  23 ++++++++++++-----------
 src/hb-aat-layout.h             |  14 +++++++++-----
 test/api/fonts/aat-feat.ttf     | Bin 0 -> 1132 bytes
 test/api/test-aat-layout.c      |  30 ++++++++++++++++++------------
 5 files changed, 54 insertions(+), 40 deletions(-)

commit 95abd53758e281325b9124f0942aafb382a89090
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Thu Nov 1 13:14:29 2018 +0330

    [feat] Expose public API

    * hb_aat_get_feature_settings

 src/Makefile.sources            |  1 +
 src/hb-aat-layout-feat-table.hh | 68 ++++++++++++++++++++++++++++++-
 src/hb-aat-layout-morx-table.hh |  6 +--
 src/hb-aat-layout.cc            | 33 +++++++++++++++
 src/hb-aat-layout.h             | 75 ++++++++++++++++++++++++++++++++++
 src/hb-aat-layout.hh            |  7 ++--
 src/hb-aat-map.hh               |  5 ++-
 src/hb-ot-face.hh               |  1 +
 test/api/Makefile.am            |  1 +
 test/api/test-aat-layout.c      | 89
 +++++++++++++++++++++++++++++++++++++++++
 test/api/test-c.c               |  1 +
 11 files changed, 278 insertions(+), 9 deletions(-)

commit 264c4a539cbfd8d5e5f143206d9d27230a186897
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Nov 25 00:30:08 2018 -0500

    [test] Reorder test suites

    aots is less interesting.  Run text-rendering-tests before aots.

 test/shaping/data/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9326912941e5927bcfb4689689c954b9a3995baa
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Nov 25 00:27:23 2018 -0500

    [kerx] Fix crash

 src/hb-machinery.hh | 2 ++
 1 file changed, 2 insertions(+)

commit 6ee401049d475b2a2d9c859e6dbf8ff2750a1609
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Nov 25 00:21:13 2018 -0500

    Simplify sanitize set_object() / fix bots

 src/hb-machinery.hh | 26 +++++++++++++-------------
 1 file changed, 13 insertions(+), 13 deletions(-)

commit c5a6b355e165e90d8d90454ceeca7b100282945f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 23:49:23 2018 -0500

    [kerx] Port to hb_sanitize_with_object_t

 src/hb-aat-layout-kerx-table.hh | 19 +++++++------------
 1 file changed, 7 insertions(+), 12 deletions(-)

commit c405ed0509afaa7c3846e8e461bedfbceb0cd937
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 23:46:15 2018 -0500

    [morx] Port to hb_sanitize_with_object_t

 src/hb-aat-layout-morx-table.hh | 18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

commit 1e8994221fb5cfdb1902d5249c7a75cde6d6e3c8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 23:38:06 2018 -0500

    Add hb_sanitize_with_object_t

    Context manager.

 src/hb-machinery.hh | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

commit b3c5affc05a3c7bbcfbd98521703d3d3447fcd7d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 23:34:34 2018 -0500

    Simplify sanitize set_object()

 src/hb-aat-layout-kerx-table.hh | 12 ++++++------
 src/hb-aat-layout-morx-table.hh | 10 +++++-----
 src/hb-machinery.hh             | 26 +++++++++++++-------------
 3 files changed, 24 insertions(+), 24 deletions(-)

commit 3d3097269995aa227b4b198d4da2baf942b65c66
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 23:12:28 2018 -0500

    [aat] Skip terminator in VarSizedBinSearchArray<>

    Fixes shaping with Apple Chancery on 10.13 again.  In that font,
    there was a terminator segment, that was tripping off sanitize().

 src/hb-aat-layout-common.hh |  6 ++++++
 src/hb-open-type.hh         | 21 ++++++++++++++++++++-
 2 files changed, 26 insertions(+), 1 deletion(-)

commit 4202a3cde3b6065124feb7f4c662563de1e08126
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 22:48:34 2018 -0500

    Minor

 src/hb-open-type.hh | 21 ++++++++++++++++-----
 1 file changed, 16 insertions(+), 5 deletions(-)

commit 1c2302bbf1d2d0e66f49ab54ad98d1b61bc5603d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 22:32:17 2018 -0500

    [debug] Print function in return_trace()

 src/hb-debug.hh | 16 +++++++++++-----
 1 file changed, 11 insertions(+), 5 deletions(-)

commit 748198a6718adbb200ee24ac013c617f62c946a4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 22:16:59 2018 -0500

    Revert "[aat.morx] Remove set_object() business"

    This reverts commit ae8ed58a6e53441d9ccbf67afd8a00b815cde99e.

    Apparently this broke Apple Chancery from OS X 10.12 :(.
    Investigating...

 src/hb-aat-layout-morx-table.hh | 8 ++++++++
 1 file changed, 8 insertions(+)

commit c8a2dc820eb0ee3124e3762cb1167ac9e528ad28
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 22:16:53 2018 -0500

    Revert "[aat.kerx] Remove kerx subtable boundary enforcement"

    This reverts commit 15905a2a2998f7ddd964f920a4828602235d6b00.

 src/hb-aat-layout-kerx-table.hh | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit 9eeebd8ddedb96c03860ce7eb5500aafa3969d6b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 22:16:47 2018 -0500

    Revert "[sanitize] Remove now-unused set_object() machinery"

    This reverts commit bbdb6edb3e1cea4c5b7076c4f6b3e6998ae36dae.

 src/hb-machinery.hh | 25 ++++++++++++++++++++++++-
 1 file changed, 24 insertions(+), 1 deletion(-)

commit 248ce22857c8918bf3468ef48d906de4c19c3d4d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 22:01:06 2018 -0500

    [tests] Minor

 test/shaping/run-tests.py | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f47c5da0aa04a88b37d9c3af4730204319a9a36b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 21:36:57 2018 -0500

    [arrays] Use hb_array_t<> in all places with sub_array()

 src/hb-aat-layout-lcar-table.hh |  6 +++---
 src/hb-ot-layout-gdef-table.hh  | 14 ++++++++------
 src/hb-ot-math-table.hh         | 10 ++++------
 3 files changed, 15 insertions(+), 15 deletions(-)

commit 3246a8ebbd900bcc3e3c70532eab0f406b8f5c4a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 21:32:00 2018 -0500

    [arrays] Merge ArrayOf's sub_array into hb_array_t's

 src/hb-dsalgs.hh    | 44 +++++++++++++++++++++++++++-----------------
 src/hb-open-type.hh | 30 ++++++++++++++++++------------
 2 files changed, 45 insertions(+), 29 deletions(-)

commit e6877e28cd30e89af7cce59d903184a5a01ec970
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sun Nov 25 02:12:40 2018 +0330

    [test] Add the missed aots fonts

 test/shaping/data/aots/fonts/classdef1_font1.otf   | Bin 0 -> 6004 bytes
 test/shaping/data/aots/fonts/classdef1_font2.otf   | Bin 0 -> 6020 bytes
 test/shaping/data/aots/tests/classdef1_empty.tests |   2 +-
 3 files changed, 1 insertion(+), 1 deletion(-)

commit 825ea5a4607fafa11c56a72a82bda773f6b44e79
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sun Nov 25 01:59:54 2018 +0330

    [test] Merge 10.12.6 and 10.13.6 tests, update to Apple Chancery fix

 test/shaping/data/in-house/Makefile.sources        |  3 +--
 .../data/in-house/tests/macos-10.12.6.tests        | 11 ---------
 .../data/in-house/tests/macos-10.13.6.tests        | 13 -----------
 test/shaping/data/in-house/tests/macos.tests       | 26
 ++++++++++++++++++++++
 4 files changed, 27 insertions(+), 26 deletions(-)

commit bbdb6edb3e1cea4c5b7076c4f6b3e6998ae36dae
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 17:15:38 2018 -0500

    [sanitize] Remove now-unused set_object() machinery

 src/hb-machinery.hh | 25 +------------------------
 1 file changed, 1 insertion(+), 24 deletions(-)

commit 15905a2a2998f7ddd964f920a4828602235d6b00
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 17:14:39 2018 -0500

    [aat.kerx] Remove kerx subtable boundary enforcement

    Have not encountered fonts needing this, but same reasoning as
    for morx (see previos commit.)

 src/hb-aat-layout-kerx-table.hh | 21 ---------------------
 1 file changed, 21 deletions(-)

commit ae8ed58a6e53441d9ccbf67afd8a00b815cde99e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 17:11:09 2018 -0500

    [aat.morx] Remove set_object() business

    With OS X 10.13 Apple Chancery fails to ligate if we limit each morx
    sub-chain to its declared length.  Perhaps their newer compiler does
    object-sharing across sub-chains.  Anyway, since that's a valid, if
    unspecified, way to compile tables, remove enforcement.

    Probably do the same with kern/kerx.

 src/hb-aat-layout-morx-table.hh | 8 --------
 1 file changed, 8 deletions(-)

commit b518e5af9f66414396752069bb8f43466a9236fa
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sun Nov 25 01:39:00 2018 +0330

    Add 10.13.6 aat fonts tests and bot (#1409)

 .circleci/config.yml                                     | 16
 ++++++++++++++--
 test/shaping/data/in-house/Makefile.sources              |  3 ++-
 .../in-house/tests/{macos.tests => macos-10.12.6.tests}  |  2 --
 test/shaping/data/in-house/tests/macos-10.13.6.tests     | 13
 +++++++++++++
 4 files changed, 29 insertions(+), 5 deletions(-)

commit b7f7950e8fc4b9e229b466ac2453d57b8da9a5a6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 15:56:17 2018 -0500

    [aat] Add test for recent regression

 test/shaping/data/in-house/tests/macos.tests | 1 +
 1 file changed, 1 insertion(+)

commit ea9512e61a7ed333b810918e74cce4c8bd2291b9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 15:49:33 2018 -0500

    [tests] Redo test runner logging a  bit

 test/shaping/run-tests.py | 44
 +++++++++++++++++++++++---------------------
 1 file changed, 23 insertions(+), 21 deletions(-)

commit 5020affc3877d39377506245ecaf01a659eef82a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 15:42:11 2018 -0500

    [tests] Minor

 test/shaping/data/in-house/tests/macos.tests | 2 ++
 1 file changed, 2 insertions(+)

commit ee3a3e10d45f5df1a74b65fbe3df77f8dd8f902e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 15:37:01 2018 -0500

    [tests/shaping] Allow comments in test files

    Line should start with "# ".

 test/shaping/run-tests.py | 17 +++++++++++++++--
 1 file changed, 15 insertions(+), 2 deletions(-)

commit ed900ee9afa0dabdbf6bf9d2af46c2343a16773f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 15:22:09 2018 -0500

    [tests] Rename

 test/shaping/data/in-house/Makefile.sources                         |
 2 +-
 test/shaping/data/in-house/tests/{macos-10.12.tests => macos.tests} | 0
 2 files changed, 1 insertion(+), 1 deletion(-)

commit 20edc70d537b01e8a384ee05673335f2f8a18238
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 14:52:34 2018 -0500

    [morx/kerx] Fix sanitize regression

    Broke in 8dcc1913a1670ede7b124f7b5b775d7ab8791386

    If sanitizer is left with another object, it wouldn't work.

    Better fix coming soon.

 src/hb-aat-layout-kerx-table.hh | 6 +-----
 src/hb-aat-layout-morx-table.hh | 4 +---
 2 files changed, 2 insertions(+), 8 deletions(-)

commit 3cc14e78aeb1c70eb82891ab4513c0e7d0f59928
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Nov 24 20:49:21 2018 +0330

    [test] Enable more of aots tests (#1408)

    The ones commented out in this change should've be passed :/
    a closer look is needed.

 test/shaping/data/aots/Makefile.sources            | 76
 +++++++++++-----------
 test/shaping/data/aots/hb-aots-tester.cpp          |  1 +
 test/shaping/data/aots/tests/classdef1_empty.tests |  2 +-
 test/shaping/data/aots/tests/gsub3_1_simple.tests  |  2 +-
 .../data/aots/tests/lookupflag_ignore_attach.tests | 10 +--
 5 files changed, 46 insertions(+), 45 deletions(-)

commit 24887d1115ee41cfad70577eb243382f6c23ab6e
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Sat Nov 24 20:07:24 2018 +0330

    Add Adobe AOTS tests (#1395)

    Annotated OpenType Specification or aots,
    https://github.com/adobe-type-tools/aots
    provides a set of tests for OpenType specification, this change add
    those tests in addition
    to modified version of their HarfBuzz test runner for generating
    harfbuzz project specific tests.

 configure.ac                                       |   1 +
 test/shaping/CMakeLists.txt                        |  13 +-
 test/shaping/data/Makefile.am                      |   1 +
 test/shaping/data/aots/COPYING                     |  13 +
 test/shaping/data/aots/Makefile.am                 |  37 +++
 test/shaping/data/aots/Makefile.sources            | 126 ++++++++
 test/shaping/data/aots/fonts/classdef1_font3.otf   | Bin 0 -> 6060 bytes
 test/shaping/data/aots/fonts/classdef1_font4.otf   | Bin 0 -> 5984 bytes
 test/shaping/data/aots/fonts/classdef2_font1.otf   | Bin 0 -> 6004 bytes
 test/shaping/data/aots/fonts/classdef2_font2.otf   | Bin 0 -> 6016 bytes
 test/shaping/data/aots/fonts/classdef2_font3.otf   | Bin 0 -> 6052 bytes
 test/shaping/data/aots/fonts/classdef2_font4.otf   | Bin 0 -> 5984 bytes
 test/shaping/data/aots/fonts/cmap0_font1.otf       | Bin 0 -> 5196 bytes
 test/shaping/data/aots/fonts/cmap10_font1.otf      | Bin 0 -> 4968 bytes
 test/shaping/data/aots/fonts/cmap10_font2.otf      | Bin 0 -> 4960 bytes
 test/shaping/data/aots/fonts/cmap12_font1.otf      | Bin 0 -> 4980 bytes
 test/shaping/data/aots/fonts/cmap14_font1.otf      | Bin 0 -> 5028 bytes
 test/shaping/data/aots/fonts/cmap2_font1.otf       | Bin 0 -> 6000 bytes
 test/shaping/data/aots/fonts/cmap4_font1.otf       | Bin 0 -> 4964 bytes
 test/shaping/data/aots/fonts/cmap4_font2.otf       | Bin 0 -> 4956 bytes
 test/shaping/data/aots/fonts/cmap4_font3.otf       | Bin 0 -> 4956 bytes
 test/shaping/data/aots/fonts/cmap4_font4.otf       | Bin 0 -> 4972 bytes
 test/shaping/data/aots/fonts/cmap6_font1.otf       | Bin 0 -> 4948 bytes
 test/shaping/data/aots/fonts/cmap6_font2.otf       | Bin 0 -> 4944 bytes
 test/shaping/data/aots/fonts/cmap8_font1.otf       | Bin 0 -> 13224 bytes
 .../data/aots/fonts/cmap_composition_font1.otf     | Bin 0 -> 5096 bytes
 .../aots/fonts/cmap_subtableselection_font1.otf    | Bin 0 -> 6412 bytes
 .../aots/fonts/cmap_subtableselection_font2.otf    | Bin 0 -> 6140 bytes
 .../aots/fonts/cmap_subtableselection_font3.otf    | Bin 0 -> 5872 bytes
 .../aots/fonts/cmap_subtableselection_font4.otf    | Bin 0 -> 5600 bytes
 .../aots/fonts/cmap_subtableselection_font5.otf    | Bin 0 -> 5332 bytes
 .../data/aots/fonts/gpos1_1_lookupflag_f1.otf      | Bin 0 -> 5208 bytes
 test/shaping/data/aots/fonts/gpos1_1_simple_f1.otf | Bin 0 -> 5136 bytes
 test/shaping/data/aots/fonts/gpos1_1_simple_f2.otf | Bin 0 -> 5136 bytes
 test/shaping/data/aots/fonts/gpos1_1_simple_f3.otf | Bin 0 -> 5136 bytes
 test/shaping/data/aots/fonts/gpos1_1_simple_f4.otf | Bin 0 -> 5136 bytes
 test/shaping/data/aots/fonts/gpos1_2_font1.otf     | Bin 0 -> 5108 bytes
 test/shaping/data/aots/fonts/gpos1_2_font2.otf     | Bin 0 -> 5148 bytes
 test/shaping/data/aots/fonts/gpos2_1_font6.otf     | Bin 0 -> 5120 bytes
 test/shaping/data/aots/fonts/gpos2_1_font7.otf     | Bin 0 -> 5132 bytes
 .../data/aots/fonts/gpos2_1_lookupflag_f1.otf      | Bin 0 -> 5220 bytes
 .../data/aots/fonts/gpos2_1_lookupflag_f2.otf      | Bin 0 -> 5220 bytes
 .../data/aots/fonts/gpos2_1_next_glyph_f1.otf      | Bin 0 -> 5180 bytes
 .../data/aots/fonts/gpos2_1_next_glyph_f2.otf      | Bin 0 -> 5176 bytes
 test/shaping/data/aots/fonts/gpos2_1_simple_f1.otf | Bin 0 -> 5148 bytes
 test/shaping/data/aots/fonts/gpos2_2_font1.otf     | Bin 0 -> 5148 bytes
 test/shaping/data/aots/fonts/gpos2_2_font2.otf     | Bin 0 -> 5188 bytes
 test/shaping/data/aots/fonts/gpos2_2_font3.otf     | Bin 0 -> 5188 bytes
 test/shaping/data/aots/fonts/gpos2_2_font4.otf     | Bin 0 -> 5148 bytes
 test/shaping/data/aots/fonts/gpos2_2_font5.otf     | Bin 0 -> 5140 bytes
 test/shaping/data/aots/fonts/gpos3_font1.otf       | Bin 0 -> 5120 bytes
 test/shaping/data/aots/fonts/gpos3_font2.otf       | Bin 0 -> 5160 bytes
 test/shaping/data/aots/fonts/gpos3_font3.otf       | Bin 0 -> 5164 bytes
 .../data/aots/fonts/gpos4_lookupflag_f1.otf        | Bin 0 -> 5256 bytes
 .../data/aots/fonts/gpos4_lookupflag_f2.otf        | Bin 0 -> 5240 bytes
 .../data/aots/fonts/gpos4_multiple_anchors_1.otf   | Bin 0 -> 5352 bytes
 test/shaping/data/aots/fonts/gpos4_simple_1.otf    | Bin 0 -> 5200 bytes
 test/shaping/data/aots/fonts/gpos5_font1.otf       | Bin 0 -> 5284 bytes
 test/shaping/data/aots/fonts/gpos6_font1.otf       | Bin 0 -> 5176 bytes
 test/shaping/data/aots/fonts/gpos7_1_font1.otf     | Bin 0 -> 5160 bytes
 test/shaping/data/aots/fonts/gpos9_font1.otf       | Bin 0 -> 5096 bytes
 test/shaping/data/aots/fonts/gpos9_font2.otf       | Bin 0 -> 5124 bytes
 .../data/aots/fonts/gpos_chaining1_boundary_f1.otf | Bin 0 -> 5496 bytes
 .../data/aots/fonts/gpos_chaining1_boundary_f2.otf | Bin 0 -> 5500 bytes
 .../data/aots/fonts/gpos_chaining1_boundary_f3.otf | Bin 0 -> 5496 bytes
 .../data/aots/fonts/gpos_chaining1_boundary_f4.otf | Bin 0 -> 5496 bytes
 .../aots/fonts/gpos_chaining1_lookupflag_f1.otf    | Bin 0 -> 5520 bytes
 .../fonts/gpos_chaining1_multiple_subrules_f1.otf  | Bin 0 -> 5592 bytes
 .../fonts/gpos_chaining1_multiple_subrules_f2.otf  | Bin 0 -> 5592 bytes
 .../aots/fonts/gpos_chaining1_next_glyph_f1.otf    | Bin 0 -> 5540 bytes
 .../data/aots/fonts/gpos_chaining1_simple_f1.otf   | Bin 0 -> 5488 bytes
 .../data/aots/fonts/gpos_chaining1_simple_f2.otf   | Bin 0 -> 5488 bytes
 .../aots/fonts/gpos_chaining1_successive_f1.otf    | Bin 0 -> 5524 bytes
 .../data/aots/fonts/gpos_chaining2_boundary_f1.otf | Bin 0 -> 5704 bytes
 .../data/aots/fonts/gpos_chaining2_boundary_f2.otf | Bin 0 -> 5708 bytes
 .../data/aots/fonts/gpos_chaining2_boundary_f3.otf | Bin 0 -> 5704 bytes
 .../data/aots/fonts/gpos_chaining2_boundary_f4.otf | Bin 0 -> 5704 bytes
 .../aots/fonts/gpos_chaining2_lookupflag_f1.otf    | Bin 0 -> 5728 bytes
 .../fonts/gpos_chaining2_multiple_subrules_f1.otf  | Bin 0 -> 5800 bytes
 .../fonts/gpos_chaining2_multiple_subrules_f2.otf  | Bin 0 -> 5800 bytes
 .../aots/fonts/gpos_chaining2_next_glyph_f1.otf    | Bin 0 -> 5744 bytes
 .../data/aots/fonts/gpos_chaining2_simple_f1.otf   | Bin 0 -> 5696 bytes
 .../data/aots/fonts/gpos_chaining2_simple_f2.otf   | Bin 0 -> 5696 bytes
 .../aots/fonts/gpos_chaining2_successive_f1.otf    | Bin 0 -> 5732 bytes
 .../data/aots/fonts/gpos_chaining3_boundary_f1.otf | Bin 0 -> 5504 bytes
 .../data/aots/fonts/gpos_chaining3_boundary_f2.otf | Bin 0 -> 5508 bytes
 .../data/aots/fonts/gpos_chaining3_boundary_f3.otf | Bin 0 -> 5500 bytes
 .../data/aots/fonts/gpos_chaining3_boundary_f4.otf | Bin 0 -> 5500 bytes
 .../aots/fonts/gpos_chaining3_lookupflag_f1.otf    | Bin 0 -> 5548 bytes
 .../aots/fonts/gpos_chaining3_next_glyph_f1.otf    | Bin 0 -> 5524 bytes
 .../data/aots/fonts/gpos_chaining3_simple_f1.otf   | Bin 0 -> 5496 bytes
 .../data/aots/fonts/gpos_chaining3_simple_f2.otf   | Bin 0 -> 5516 bytes
 .../aots/fonts/gpos_chaining3_successive_f1.otf    | Bin 0 -> 5544 bytes
 .../data/aots/fonts/gpos_context1_boundary_f1.otf  | Bin 0 -> 5480 bytes
 .../data/aots/fonts/gpos_context1_boundary_f2.otf  | Bin 0 -> 5480 bytes
 .../data/aots/fonts/gpos_context1_expansion_f1.otf | Bin 0 -> 5492 bytes
 .../aots/fonts/gpos_context1_lookupflag_f1.otf     | Bin 0 -> 5508 bytes
 .../aots/fonts/gpos_context1_lookupflag_f2.otf     | Bin 0 -> 5500 bytes
 .../fonts/gpos_context1_multiple_subrules_f1.otf   | Bin 0 -> 5568 bytes
 .../fonts/gpos_context1_multiple_subrules_f2.otf   | Bin 0 -> 5568 bytes
 .../aots/fonts/gpos_context1_next_glyph_f1.otf     | Bin 0 -> 5500 bytes
 .../data/aots/fonts/gpos_context1_simple_f1.otf    | Bin 0 -> 5476 bytes
 .../data/aots/fonts/gpos_context1_simple_f2.otf    | Bin 0 -> 5468 bytes
 .../aots/fonts/gpos_context1_successive_f1.otf     | Bin 0 -> 5508 bytes
 .../data/aots/fonts/gpos_context2_boundary_f1.otf  | Bin 0 -> 5492 bytes
 .../data/aots/fonts/gpos_context2_boundary_f2.otf  | Bin 0 -> 5496 bytes
 .../data/aots/fonts/gpos_context2_classes_f1.otf   | Bin 0 -> 5540 bytes
 .../data/aots/fonts/gpos_context2_classes_f2.otf   | Bin 0 -> 5564 bytes
 .../data/aots/fonts/gpos_context2_expansion_f1.otf | Bin 0 -> 5524 bytes
 .../aots/fonts/gpos_context2_lookupflag_f1.otf     | Bin 0 -> 5540 bytes
 .../aots/fonts/gpos_context2_lookupflag_f2.otf     | Bin 0 -> 5532 bytes
 .../fonts/gpos_context2_multiple_subrules_f1.otf   | Bin 0 -> 5600 bytes
 .../fonts/gpos_context2_multiple_subrules_f2.otf   | Bin 0 -> 5600 bytes
 .../aots/fonts/gpos_context2_next_glyph_f1.otf     | Bin 0 -> 5512 bytes
 .../data/aots/fonts/gpos_context2_simple_f1.otf    | Bin 0 -> 5508 bytes
 .../data/aots/fonts/gpos_context2_simple_f2.otf    | Bin 0 -> 5484 bytes
 .../aots/fonts/gpos_context2_successive_f1.otf     | Bin 0 -> 5544 bytes
 .../data/aots/fonts/gpos_context3_boundary_f1.otf  | Bin 0 -> 5476 bytes
 .../data/aots/fonts/gpos_context3_boundary_f2.otf  | Bin 0 -> 5472 bytes
 .../aots/fonts/gpos_context3_lookupflag_f1.otf     | Bin 0 -> 5512 bytes
 .../aots/fonts/gpos_context3_lookupflag_f2.otf     | Bin 0 -> 5504 bytes
 .../aots/fonts/gpos_context3_next_glyph_f1.otf     | Bin 0 -> 5496 bytes
 .../data/aots/fonts/gpos_context3_simple_f1.otf    | Bin 0 -> 5480 bytes
 .../aots/fonts/gpos_context3_successive_f1.otf     | Bin 0 -> 5516 bytes
 .../data/aots/fonts/gsub1_1_lookupflag_f1.otf      | Bin 0 -> 5208 bytes
 test/shaping/data/aots/fonts/gsub1_1_modulo_f1.otf | Bin 0 -> 5216 bytes
 test/shaping/data/aots/fonts/gsub1_1_simple_f1.otf | Bin 0 -> 5136 bytes
 .../data/aots/fonts/gsub1_2_lookupflag_f1.otf      | Bin 0 -> 5212 bytes
 test/shaping/data/aots/fonts/gsub1_2_simple_f1.otf | Bin 0 -> 5140 bytes
 .../data/aots/fonts/gsub2_1_lookupflag_f1.otf      | Bin 0 -> 5224 bytes
 .../aots/fonts/gsub2_1_multiple_sequences_f1.otf   | Bin 0 -> 5248 bytes
 test/shaping/data/aots/fonts/gsub2_1_simple_f1.otf | Bin 0 -> 5144 bytes
 .../data/aots/fonts/gsub3_1_lookupflag_f1.otf      | Bin 0 -> 5224 bytes
 .../data/aots/fonts/gsub3_1_multiple_f1.otf        | Bin 0 -> 5168 bytes
 test/shaping/data/aots/fonts/gsub3_1_simple_f1.otf | Bin 0 -> 5144 bytes
 .../data/aots/fonts/gsub4_1_lookupflag_f1.otf      | Bin 0 -> 5220 bytes
 .../aots/fonts/gsub4_1_multiple_ligatures_f1.otf   | Bin 0 -> 5252 bytes
 .../aots/fonts/gsub4_1_multiple_ligatures_f2.otf   | Bin 0 -> 5252 bytes
 .../aots/fonts/gsub4_1_multiple_ligsets_f1.otf     | Bin 0 -> 5240 bytes
 test/shaping/data/aots/fonts/gsub4_1_simple_f1.otf | Bin 0 -> 5148 bytes
 test/shaping/data/aots/fonts/gsub7_font1.otf       | Bin 0 -> 5096 bytes
 test/shaping/data/aots/fonts/gsub7_font2.otf       | Bin 0 -> 5116 bytes
 .../data/aots/fonts/gsub_chaining1_boundary_f1.otf | Bin 0 -> 5516 bytes
 .../data/aots/fonts/gsub_chaining1_boundary_f2.otf | Bin 0 -> 5520 bytes
 .../data/aots/fonts/gsub_chaining1_boundary_f3.otf | Bin 0 -> 5520 bytes
 .../data/aots/fonts/gsub_chaining1_boundary_f4.otf | Bin 0 -> 5520 bytes
 .../aots/fonts/gsub_chaining1_lookupflag_f1.otf    | Bin 0 -> 5544 bytes
 .../fonts/gsub_chaining1_multiple_subrules_f1.otf  | Bin 0 -> 5616 bytes
 .../fonts/gsub_chaining1_multiple_subrules_f2.otf  | Bin 0 -> 5616 bytes
 .../aots/fonts/gsub_chaining1_next_glyph_f1.otf    | Bin 0 -> 5560 bytes
 .../data/aots/fonts/gsub_chaining1_simple_f1.otf   | Bin 0 -> 5508 bytes
 .../data/aots/fonts/gsub_chaining1_simple_f2.otf   | Bin 0 -> 5512 bytes
 .../aots/fonts/gsub_chaining1_successive_f1.otf    | Bin 0 -> 5544 bytes
 .../data/aots/fonts/gsub_chaining2_boundary_f1.otf | Bin 0 -> 5724 bytes
 .../data/aots/fonts/gsub_chaining2_boundary_f2.otf | Bin 0 -> 5728 bytes
 .../data/aots/fonts/gsub_chaining2_boundary_f3.otf | Bin 0 -> 5728 bytes
 .../data/aots/fonts/gsub_chaining2_boundary_f4.otf | Bin 0 -> 5728 bytes
 .../aots/fonts/gsub_chaining2_lookupflag_f1.otf    | Bin 0 -> 5752 bytes
 .../fonts/gsub_chaining2_multiple_subrules_f1.otf  | Bin 0 -> 5824 bytes
 .../fonts/gsub_chaining2_multiple_subrules_f2.otf  | Bin 0 -> 5824 bytes
 .../aots/fonts/gsub_chaining2_next_glyph_f1.otf    | Bin 0 -> 5764 bytes
 .../data/aots/fonts/gsub_chaining2_simple_f1.otf   | Bin 0 -> 5716 bytes
 .../data/aots/fonts/gsub_chaining2_simple_f2.otf   | Bin 0 -> 5720 bytes
 .../aots/fonts/gsub_chaining2_successive_f1.otf    | Bin 0 -> 5752 bytes
 .../data/aots/fonts/gsub_chaining3_boundary_f1.otf | Bin 0 -> 5528 bytes
 .../data/aots/fonts/gsub_chaining3_boundary_f2.otf | Bin 0 -> 5532 bytes
 .../data/aots/fonts/gsub_chaining3_boundary_f3.otf | Bin 0 -> 5524 bytes
 .../data/aots/fonts/gsub_chaining3_boundary_f4.otf | Bin 0 -> 5524 bytes
 .../aots/fonts/gsub_chaining3_lookupflag_f1.otf    | Bin 0 -> 5572 bytes
 .../aots/fonts/gsub_chaining3_next_glyph_f1.otf    | Bin 0 -> 5548 bytes
 .../data/aots/fonts/gsub_chaining3_simple_f1.otf   | Bin 0 -> 5520 bytes
 .../data/aots/fonts/gsub_chaining3_simple_f2.otf   | Bin 0 -> 5540 bytes
 .../aots/fonts/gsub_chaining3_successive_f1.otf    | Bin 0 -> 5568 bytes
 .../data/aots/fonts/gsub_context1_boundary_f1.otf  | Bin 0 -> 5500 bytes
 .../data/aots/fonts/gsub_context1_boundary_f2.otf  | Bin 0 -> 5504 bytes
 .../data/aots/fonts/gsub_context1_expansion_f1.otf | Bin 0 -> 5516 bytes
 .../aots/fonts/gsub_context1_lookupflag_f1.otf     | Bin 0 -> 5532 bytes
 .../aots/fonts/gsub_context1_lookupflag_f2.otf     | Bin 0 -> 5524 bytes
 .../fonts/gsub_context1_multiple_subrules_f1.otf   | Bin 0 -> 5592 bytes
 .../fonts/gsub_context1_multiple_subrules_f2.otf   | Bin 0 -> 5592 bytes
 .../aots/fonts/gsub_context1_next_glyph_f1.otf     | Bin 0 -> 5520 bytes
 .../data/aots/fonts/gsub_context1_simple_f1.otf    | Bin 0 -> 5500 bytes
 .../data/aots/fonts/gsub_context1_simple_f2.otf    | Bin 0 -> 5492 bytes
 .../aots/fonts/gsub_context1_successive_f1.otf     | Bin 0 -> 5528 bytes
 .../data/aots/fonts/gsub_context2_boundary_f1.otf  | Bin 0 -> 5516 bytes
 .../data/aots/fonts/gsub_context2_boundary_f2.otf  | Bin 0 -> 5516 bytes
 .../data/aots/fonts/gsub_context2_classes_f1.otf   | Bin 0 -> 5564 bytes
 .../data/aots/fonts/gsub_context2_classes_f2.otf   | Bin 0 -> 5584 bytes
 .../data/aots/fonts/gsub_context2_expansion_f1.otf | Bin 0 -> 5544 bytes
 .../aots/fonts/gsub_context2_lookupflag_f1.otf     | Bin 0 -> 5560 bytes
 .../aots/fonts/gsub_context2_lookupflag_f2.otf     | Bin 0 -> 5552 bytes
 .../fonts/gsub_context2_multiple_subrules_f1.otf   | Bin 0 -> 5620 bytes
 .../fonts/gsub_context2_multiple_subrules_f2.otf   | Bin 0 -> 5620 bytes
 .../aots/fonts/gsub_context2_next_glyph_f1.otf     | Bin 0 -> 5536 bytes
 .../data/aots/fonts/gsub_context2_simple_f1.otf    | Bin 0 -> 5528 bytes
 .../data/aots/fonts/gsub_context2_simple_f2.otf    | Bin 0 -> 5504 bytes
 .../aots/fonts/gsub_context2_successive_f1.otf     | Bin 0 -> 5568 bytes
 .../data/aots/fonts/gsub_context3_boundary_f1.otf  | Bin 0 -> 5500 bytes
 .../data/aots/fonts/gsub_context3_boundary_f2.otf  | Bin 0 -> 5496 bytes
 .../aots/fonts/gsub_context3_lookupflag_f1.otf     | Bin 0 -> 5536 bytes
 .../aots/fonts/gsub_context3_lookupflag_f2.otf     | Bin 0 -> 5528 bytes
 .../aots/fonts/gsub_context3_next_glyph_f1.otf     | Bin 0 -> 5520 bytes
 .../data/aots/fonts/gsub_context3_simple_f1.otf    | Bin 0 -> 5504 bytes
 .../aots/fonts/gsub_context3_successive_f1.otf     | Bin 0 -> 5540 bytes
 .../aots/fonts/lookupflag_ignore_attach_f1.otf     | Bin 0 -> 5416 bytes
 .../data/aots/fonts/lookupflag_ignore_base_f1.otf  | Bin 0 -> 5256 bytes
 .../fonts/lookupflag_ignore_combination_f1.otf     | Bin 0 -> 5408 bytes
 .../aots/fonts/lookupflag_ignore_ligatures_f1.otf  | Bin 0 -> 5320 bytes
 .../data/aots/fonts/lookupflag_ignore_marks_f1.otf | Bin 0 -> 5288 bytes
 test/shaping/data/aots/hb-aots-tester.cpp          | 343
 +++++++++++++++++++++
 test/shaping/data/aots/tests/classdef1.tests       |   1 +
 test/shaping/data/aots/tests/classdef1_empty.tests |   1 +
 .../data/aots/tests/classdef1_multiple.tests       |   1 +
 .../shaping/data/aots/tests/classdef1_single.tests |   1 +
 test/shaping/data/aots/tests/classdef2.tests       |   1 +
 test/shaping/data/aots/tests/classdef2_empty.tests |   1 +
 .../data/aots/tests/classdef2_multiple.tests       |   1 +
 .../shaping/data/aots/tests/classdef2_single.tests |   1 +
 .../data/aots/tests/gpos1_1_lookupflag.tests       |   1 +
 test/shaping/data/aots/tests/gpos1_1_simple.tests  |   4 +
 test/shaping/data/aots/tests/gpos1_2.tests         |   1 +
 .../data/aots/tests/gpos1_2_lookupflag.tests       |   1 +
 test/shaping/data/aots/tests/gpos2_1.tests         |   2 +
 .../data/aots/tests/gpos2_1_lookupflag.tests       |   2 +
 .../data/aots/tests/gpos2_1_next_glyph.tests       |   2 +
 test/shaping/data/aots/tests/gpos2_1_simple.tests  |   2 +
 test/shaping/data/aots/tests/gpos2_2.tests         |   5 +
 test/shaping/data/aots/tests/gpos3.tests           |  11 +
 .../shaping/data/aots/tests/gpos3_lookupflag.tests |   2 +
 .../shaping/data/aots/tests/gpos4_lookupflag.tests |   2 +
 .../data/aots/tests/gpos4_multiple_anchors.tests   |   1 +
 test/shaping/data/aots/tests/gpos4_simple.tests    |   5 +
 test/shaping/data/aots/tests/gpos5.tests           |   2 +
 test/shaping/data/aots/tests/gpos6.tests           |   3 +
 test/shaping/data/aots/tests/gpos7_1.tests         |   2 +
 test/shaping/data/aots/tests/gpos9.tests           |   2 +
 .../data/aots/tests/gpos_chaining1_boundary.tests  |   4 +
 .../aots/tests/gpos_chaining1_lookupflag.tests     |   1 +
 .../tests/gpos_chaining1_multiple_subrules.tests   |   2 +
 .../aots/tests/gpos_chaining1_next_glyph.tests     |   1 +
 .../data/aots/tests/gpos_chaining1_simple.tests    |  11 +
 .../aots/tests/gpos_chaining1_successive.tests     |   1 +
 .../data/aots/tests/gpos_chaining2_boundary.tests  |   4 +
 .../aots/tests/gpos_chaining2_lookupflag.tests     |   1 +
 .../tests/gpos_chaining2_multiple_subrules.tests   |   2 +
 .../aots/tests/gpos_chaining2_next_glyph.tests     |   1 +
 .../data/aots/tests/gpos_chaining2_simple.tests    |  11 +
 .../aots/tests/gpos_chaining2_successive.tests     |   1 +
 .../data/aots/tests/gpos_chaining3_boundary.tests  |   4 +
 .../aots/tests/gpos_chaining3_lookupflag.tests     |   1 +
 .../aots/tests/gpos_chaining3_next_glyph.tests     |   1 +
 .../data/aots/tests/gpos_chaining3_simple.tests    |  11 +
 .../aots/tests/gpos_chaining3_successive.tests     |   1 +
 .../data/aots/tests/gpos_context1_boundary.tests   |   2 +
 .../data/aots/tests/gpos_context1_expansion.tests  |   1 +
 .../data/aots/tests/gpos_context1_lookupflag.tests |   2 +
 .../tests/gpos_context1_multiple_subrules.tests    |   2 +
 .../data/aots/tests/gpos_context1_next_glyph.tests |   1 +
 .../data/aots/tests/gpos_context1_simple.tests     |   3 +
 .../data/aots/tests/gpos_context1_successive.tests |   1 +
 .../data/aots/tests/gpos_context2_boundary.tests   |   2 +
 .../data/aots/tests/gpos_context2_classes.tests    |   2 +
 .../data/aots/tests/gpos_context2_expansion.tests  |   1 +
 .../data/aots/tests/gpos_context2_lookupflag.tests |   2 +
 .../tests/gpos_context2_multiple_subrules.tests    |   2 +
 .../data/aots/tests/gpos_context2_next_glyph.tests |   1 +
 .../data/aots/tests/gpos_context2_simple.tests     |   3 +
 .../data/aots/tests/gpos_context2_successive.tests |   1 +
 .../data/aots/tests/gpos_context3_boundary.tests   |   2 +
 .../data/aots/tests/gpos_context3_lookupflag.tests |   2 +
 .../data/aots/tests/gpos_context3_next_glyph.tests |   1 +
 .../data/aots/tests/gpos_context3_simple.tests     |   2 +
 .../data/aots/tests/gpos_context3_successive.tests |   1 +
 .../data/aots/tests/gsub1_1_lookupflag.tests       |   1 +
 test/shaping/data/aots/tests/gsub1_1_modulo.tests  |   1 +
 test/shaping/data/aots/tests/gsub1_1_simple.tests  |   1 +
 .../data/aots/tests/gsub1_2_lookupflag.tests       |   1 +
 test/shaping/data/aots/tests/gsub1_2_simple.tests  |   1 +
 .../data/aots/tests/gsub2_1_lookupflag.tests       |   1 +
 .../aots/tests/gsub2_1_multiple_sequences.tests    |   1 +
 test/shaping/data/aots/tests/gsub2_1_simple.tests  |   2 +
 .../data/aots/tests/gsub3_1_lookupflag.tests       |   1 +
 .../shaping/data/aots/tests/gsub3_1_multiple.tests |   1 +
 test/shaping/data/aots/tests/gsub3_1_simple.tests  |   1 +
 .../data/aots/tests/gsub4_1_lookupflag.tests       |   1 +
 .../aots/tests/gsub4_1_multiple_ligatures.tests    |   2 +
 .../data/aots/tests/gsub4_1_multiple_ligsets.tests |   1 +
 test/shaping/data/aots/tests/gsub4_1_simple.tests  |   1 +
 test/shaping/data/aots/tests/gsub7.tests           |   2 +
 .../data/aots/tests/gsub_chaining1_boundary.tests  |   4 +
 .../aots/tests/gsub_chaining1_lookupflag.tests     |   1 +
 .../tests/gsub_chaining1_multiple_subrules.tests   |   2 +
 .../aots/tests/gsub_chaining1_next_glyph.tests     |   1 +
 .../data/aots/tests/gsub_chaining1_simple.tests    |  11 +
 .../aots/tests/gsub_chaining1_successive.tests     |   1 +
 .../data/aots/tests/gsub_chaining2_boundary.tests  |   4 +
 .../aots/tests/gsub_chaining2_lookupflag.tests     |   1 +
 .../tests/gsub_chaining2_multiple_subrules.tests   |   2 +
 .../aots/tests/gsub_chaining2_next_glyph.tests     |   1 +
 .../data/aots/tests/gsub_chaining2_simple.tests    |  11 +
 .../aots/tests/gsub_chaining2_successive.tests     |   1 +
 .../data/aots/tests/gsub_chaining3_boundary.tests  |   4 +
 .../aots/tests/gsub_chaining3_lookupflag.tests     |   1 +
 .../aots/tests/gsub_chaining3_next_glyph.tests     |   1 +
 .../data/aots/tests/gsub_chaining3_simple.tests    |  11 +
 .../aots/tests/gsub_chaining3_successive.tests     |   1 +
 .../data/aots/tests/gsub_context1_boundary.tests   |   2 +
 .../data/aots/tests/gsub_context1_expansion.tests  |   1 +
 .../data/aots/tests/gsub_context1_lookupflag.tests |   2 +
 .../tests/gsub_context1_multiple_subrules.tests    |   2 +
 .../data/aots/tests/gsub_context1_next_glyph.tests |   1 +
 .../data/aots/tests/gsub_context1_simple.tests     |   3 +
 .../data/aots/tests/gsub_context1_successive.tests |   1 +
 .../data/aots/tests/gsub_context2_boundary.tests   |   2 +
 .../data/aots/tests/gsub_context2_classes.tests    |   2 +
 .../data/aots/tests/gsub_context2_expansion.tests  |   1 +
 .../data/aots/tests/gsub_context2_lookupflag.tests |   2 +
 .../tests/gsub_context2_multiple_subrules.tests    |   2 +
 .../data/aots/tests/gsub_context2_next_glyph.tests |   1 +
 .../data/aots/tests/gsub_context2_simple.tests     |   3 +
 .../data/aots/tests/gsub_context2_successive.tests |   1 +
 .../data/aots/tests/gsub_context3_boundary.tests   |   2 +
 .../data/aots/tests/gsub_context3_lookupflag.tests |   2 +
 .../data/aots/tests/gsub_context3_next_glyph.tests |   1 +
 .../data/aots/tests/gsub_context3_simple.tests     |   2 +
 .../data/aots/tests/gsub_context3_successive.tests |   1 +
 .../data/aots/tests/lookupflag_ignore_attach.tests |   5 +
 .../data/aots/tests/lookupflag_ignore_base.tests   |   2 +
 .../aots/tests/lookupflag_ignore_combination.tests |   3 +
 .../aots/tests/lookupflag_ignore_ligatures.tests   |   3 +
 .../data/aots/tests/lookupflag_ignore_marks.tests  |   1 +
 test/shaping/run-tests.py                          |   9 +-
 332 files changed, 815 insertions(+), 3 deletions(-)

commit ae96c98dfaef3a789227ffecd40b92518dface8a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 10:25:10 2018 -0500

    [color] Use SortedUnsizedArrayOf<>

 src/hb-ot-color-colr-table.hh | 16 ++--------------
 1 file changed, 2 insertions(+), 14 deletions(-)

commit 4a3b20738fca3231e5d9a36adba333b5bce05f4a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 10:17:59 2018 -0500

    [trak] Coment

 src/hb-aat-layout-trak-table.hh | 1 -
 1 file changed, 1 deletion(-)

commit 918b1ee54d43eb493c9226bff7677ed8ec07934b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 10:09:17 2018 -0500

    [arrays] Add not_found to reference bsearch as well

 src/hb-open-type.hh | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit d77a098b735cf14aa601feab5bdb9f4e474c794f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 10:06:13 2018 -0500

    [arrays] Improve bfind() interface

    Much more useful now. :)

 src/hb-dsalgs.hh           | 29 +++++++++++++++++++++++++----
 src/hb-open-file.hh        |  9 +--------
 src/hb-open-type.hh        | 12 ++++++++----
 src/hb-ot-layout-common.hh | 10 ++--------
 src/hb-set.hh              |  6 +++---
 src/hb-vector.hh           |  6 ++++--
 6 files changed, 43 insertions(+), 29 deletions(-)

commit 1204a247a5d9a4da39675d3da85d4fd3268a5b66
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 09:49:21 2018 -0500

    [fuzzing] Add tests for previous commit

    Fixes https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=11526
    Fixes https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=11522

 ...zz-testcase-minimized-hb-shape-fuzzer-5634620935110656 | Bin 0 ->
 41 bytes
 ...zz-testcase-minimized-hb-shape-fuzzer-5716208469409792 | Bin 0 ->
 243 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 8dcc1913a1670ede7b124f7b5b775d7ab8791386
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 09:47:45 2018 -0500

    [kerx/morx] Make sure object length is sanitized before accessing it

 src/hb-aat-layout-kerx-table.hh | 5 +++++
 src/hb-aat-layout-morx-table.hh | 5 +++++
 2 files changed, 10 insertions(+)

commit 70d80c90fe2f4eca66bec3e1d313bbf7e4d0ab65
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:59:50 2018 -0500

    [arrays] Port ArrayOf.qsort() and hb_vector_t.qsort() to hb_array_t

 src/hb-dsalgs.hh    | 14 ++++++++++++--
 src/hb-open-type.hh | 14 ++++++++++++--
 2 files changed, 24 insertions(+), 4 deletions(-)

commit 073d837aa2394d29dda72679802d583c559c3c5b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:48:48 2018 -0500

    [arrays] Port ArrayOf.qsort() to hb_array_t's

 src/hb-open-type.hh | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit ad5c871d801b481f95dd32c8b65ecc70def597be
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:47:49 2018 -0500

    [arrays] Add copy-constructor to hb_array_t and hb_sorted_array_t

 src/hb-dsalgs.hh | 2 ++
 1 file changed, 2 insertions(+)

commit 61de55bf496c1edb120e4d096140eb1125552bbe
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:45:58 2018 -0500

    [arrays] Port hb_vector_t.qsort() to hb_array_t's

 src/hb-dsalgs.hh | 16 +++++++++++++---
 src/hb-vector.hh | 10 ++--------
 2 files changed, 15 insertions(+), 11 deletions(-)

commit e3face8e791d677f94154e8a7f3d787d0d69a02f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:42:17 2018 -0500

    [arrays] Remove one flavor of hb_vector_t.qsort()

 src/hb-vector.hh | 8 ++------
 1 file changed, 2 insertions(+), 6 deletions(-)

commit 7c1600dcd9813ca560ecccc5c54877a5750caf4e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:37:11 2018 -0500

    [arrays] Add (unused) SortedUnsizedArrayOf<>

 src/hb-open-type.hh | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit e700392f5cbf366f1e03dc7e7b1a2eb6c3027b92
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:31:00 2018 -0500

    [arrays] Port SortedArrayOf.bsearch/bfind to hb_sorted_array_t's

 src/hb-dsalgs.hh    |  9 +++------
 src/hb-open-type.hh | 50
 ++++++++++----------------------------------------
 src/hb-vector.hh    | 35 ++++++++++-------------------------
 3 files changed, 23 insertions(+), 71 deletions(-)

commit e604306f2829804e9016966c1378166253b19d29
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:24:48 2018 -0500

    [arrays] Port hb_vector_t.bsearch/bfind to (new) hb_sorted_array_t's

 src/hb-dsalgs.hh    | 63
 +++++++++++++++++++++++++++++++++++++++++++++++++----
 src/hb-open-type.hh | 12 ++++++----
 src/hb-vector.hh    | 57 +++++++++++++++++++-----------------------------
 3 files changed, 89 insertions(+), 43 deletions(-)

commit 268eca24921e85eda98f4f0cce05d40c7235ba62
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:11:12 2018 -0500

    [arrays] Port (unused) ArrayOf.lsearch() to hb_array_t's

 src/hb-open-type.hh | 12 ++----------
 1 file changed, 2 insertions(+), 10 deletions(-)

commit 830856ba6b9454bf507e00416f9d45e9975fb7dc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:09:28 2018 -0500

    [arrays] Port hb_vector_t.lsearch() to hb_array_t's

 src/hb-dsalgs.hh | 26 +++++++++++++++++++++++---
 src/hb-vector.hh | 16 ++++------------
 2 files changed, 27 insertions(+), 15 deletions(-)

commit 96cf0889804b7d72a96274b25641bb18f7dd2e1e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 01:07:15 2018 -0500

    [arrays] More

 src/hb-face.cc   | 6 +++---
 src/hb-vector.hh | 4 ++--
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 3e26c8d2b10fc08642c25c7f13aef68b0b1008f6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:58:44 2018 -0500

    [arrays] Update ArrayOf.lsearch()

    Currently unused apparently

 src/hb-open-type.hh | 17 +++++++++++++----
 1 file changed, 13 insertions(+), 4 deletions(-)

commit 22e1857b01c71714245ddca05cb3fa0127bf7da2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:53:19 2018 -0500

    [arrays] Change argument type of cmp called by hb_vector_t.bsearch()

    Towards consolidating all array bsearch/...

 src/hb-aat-map.hh | 4 ++--
 src/hb-ot-map.hh  | 4 ++--
 src/hb-set.hh     | 2 +-
 src/hb-vector.hh  | 4 ++--
 4 files changed, 7 insertions(+), 7 deletions(-)

commit 5fdf7b724eb3cb5ac60cd7f90d3250877ad7ca06
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Thu Nov 15 17:40:21 2018 -0600

    Usermanual: clusters chapter; add brief grapheme definition and
    clarify monotonous cluster handling.

 docs/usermanual-clusters.xml | 56
 ++++++++++++++++++++++++++++++--------------
 1 file changed, 39 insertions(+), 17 deletions(-)

commit 939220e57da613e090d247aa1af2396c28370af4
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Thu Nov 15 15:47:03 2018 -0600

    Usermanual: clusters chapter, minor updates.

 docs/usermanual-clusters.xml | 25 ++++++++++++++++---------
 1 file changed, 16 insertions(+), 9 deletions(-)

commit 53ac46e974cf0ee8720b40ef394714eb97ff53b9
Author: Nathan Willis <nwillis@glyphography.com>
Date:   Mon Nov 12 12:17:06 2018 -0600

    Usermanual: expand clusters chapter.

 docs/usermanual-clusters.xml | 743
 +++++++++++++++++++++++++++----------------
 1 file changed, 473 insertions(+), 270 deletions(-)

commit 30cb45b3eaacda15cc45435815cae3fd50e87557
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:35:31 2018 -0500

    Change ArrayOf.bsearch() return semantics

    Towards consolidating all array bsearch/...

 src/hb-aat-layout-kerx-table.hh | 16 +++-------------
 src/hb-open-file.hh             | 12 ++++++++----
 src/hb-open-type.hh             | 42
 ++++++++++++++++++++++++++++++++---------
 src/hb-ot-cmap-table.hh         | 30 ++++++++++++-----------------
 src/hb-ot-color-svg-table.hh    |  3 +--
 src/hb-ot-layout-common.hh      | 29 +++++++++++-----------------
 src/hb-ot-vorg-table.hh         |  9 ++++-----
 src/hb-vector.hh                | 14 +++++++++-----
 8 files changed, 81 insertions(+), 74 deletions(-)

commit 5cd9546ba73d9f8c8b7b8db0960d657c50b70f64
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:38:36 2018 -0500

    Minor

 src/hb-ot-layout-common.hh | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit fd94e729cb50f2b6bd83b80cbf400e10ac633a1c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:45:55 2018 -0500

    Whitespace

 src/hb-ot-layout-common.hh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit bb2a2065080a3099eb0dc82d1df0891ad2601316
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:31:40 2018 -0500

    Assert that item-type of arrays have static size

 src/hb-dsalgs.hh    | 2 ++
 src/hb-open-type.hh | 4 ++++
 src/hb-vector.hh    | 2 ++
 3 files changed, 8 insertions(+)

commit 690d9eb83d3421b397b0cb824cd768d6d73cbf12
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:29:22 2018 -0500

    [vector] Rename

 src/hb-vector.hh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit ba38378fd4374f3d44bdc9aa0de902401b60b13d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:27:57 2018 -0500

    [aat] Minor

 src/hb-aat-layout-common.hh | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 39b9d63b014380d421cc9b94a49dd411c7a5aabf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:25:40 2018 -0500

    Add hb_static_size(T)

 src/hb-null.hh | 19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

commit f99abcc37990a478189dda691d1fdac7b9d51386
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Nov 24 00:22:21 2018 -0500

    Add template-function convenience macros

 src/hb-atomic.hh |  2 +-
 src/hb-blob.hh   |  4 ++--
 src/hb-common.cc |  2 +-
 src/hb-ft.cc     |  2 +-
 src/hb-null.hh   | 11 ++++++-----
 src/hb.hh        |  3 +++
 6 files changed, 14 insertions(+), 10 deletions(-)

commit ec83b2228e0bbb6df7e7b94dad49db32b041af4a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 19:58:49 2018 -0500

    Add null bytes for CmapSubtableLongGroup

 src/hb-ot-cmap-table.hh | 1 +
 src/hb-static.cc        | 4 +++-
 2 files changed, 4 insertions(+), 1 deletion(-)

commit e2ffb33a534a427c760dae53d0469eeced4343ba
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 16:24:28 2018 -0500

    Remove lsearch for small TableDirectorys

 src/hb-open-file.hh | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 04f7e5536924e7f277d72b8cb9d878239877c331
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 16:07:43 2018 -0500

    [arrays] Add as_array() to hb_vector_t<>

 src/hb-vector.hh | 3 +++
 1 file changed, 3 insertions(+)

commit c514f65181390ab98b0f738632f71cda31e46b68
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 16:04:56 2018 -0500

    [arrays] Add as_array() to ArrayOf<>

 src/hb-open-type.hh | 3 +++
 1 file changed, 3 insertions(+)

commit 9552f4ef0da0b7e1fb28cb2738b865888e7941d9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 15:24:17 2018 -0500

    [kern] Don't enforce length of last subtable

 src/hb-aat-layout-kerx-table.hh | 19 +++++++++++++++++--
 1 file changed, 17 insertions(+), 2 deletions(-)

commit 992b7128656e72f935089dc2e12c2d2a25511886
Merge: c9cc96c0 018ba46e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 13:49:34 2018 -0500

    Merge pull request #1407 from harfbuzz/at-sign

    Don't canonicalize '@' to '-' in language tags

commit 018ba46e4d003a5dd0f6d2d899226129c4ef0c60
Author: David Corbett <corbett.dav@husky.neu.edu>
Date:   Fri Nov 23 13:21:22 2018 -0500

    Don't canonicalize '@' to '-' in language tags

    Fixes #1406.

 src/hb-common.cc       | 2 +-
 test/api/test-ot-tag.c | 3 +++
 2 files changed, 4 insertions(+), 1 deletion(-)

commit c9cc96c0cfbbb87b9292e413d500a454182be9f4
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Nov 23 19:58:56 2018 +0330

    [aat] Update expectation

 test/shaping/data/in-house/tests/macos-10.12.tests | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 748962264a9f098b32b9cb3fe4d18c786907a184
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 11:10:17 2018 -0500

    [aat] Disable mark advance zeroing if kern table has state-machines

    Geeza Pro for example, relies on that for fancy mark positioning.

    Fixes https://github.com/harfbuzz/harfbuzz/issues/1405

 src/hb-aat-layout-kerx-table.hh | 15 +++++++++++++++
 src/hb-ot-kern-table.hh         |  9 +++++++++
 src/hb-ot-layout.cc             |  6 ++++++
 src/hb-ot-layout.hh             |  3 +++
 src/hb-ot-shape.cc              |  4 +++-
 5 files changed, 36 insertions(+), 1 deletion(-)

commit 3d2b98ef14af29acd74f01647bef60cd410825fb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Nov 23 10:45:44 2018 -0500

    Minor

 src/hb.hh | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 341851efe158599a34d241a97593058a4333852e
Author: Ebrahim Byagowi <ebrahim@gnu.org>
Date:   Fri Nov 23 15:40:05 2018 +0330

    [aat] Add macOS specific tests (#1404)

 .circleci/config.yml                               | 46
 ++++++++++++++--------
 test/shaping/CMakeLists.txt                        |  2 +
 test/shaping/data/in-house/Makefile.sources        |  1 +
 test/shaping/data/in-house/tests/macos-10.12.tests | 10 +++++
 test/shaping/run-tests.py                          | 38
 ++++++++++++++----
 5 files changed, 73 insertions(+), 24 deletions(-)

commit 22798e93c414a2655c757a6e41b300f67e04a9a3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 22:47:51 2018 -0500

    [use] Minor clarification

 src/hb-ot-shape-complex-use.cc | 34 +++++++++++++++++-----------------
 1 file changed, 17 insertions(+), 17 deletions(-)

commit a2d6c1075a5595a08ef09357293919d9df8eb64a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 22:40:57 2018 -0500

    Minor tweak to FLAG64

 src/hb.hh | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 8280459e74cff2dec3de012abd309cda9578b759
Merge: e4a4555d 3c7792ca
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 22:39:12 2018 -0500

    Merge pull request #1291 from harfbuzz/use-reordering

    [use] Fix reordering

commit e4a4555d1e40dacdf72452805e9e6b6109627d63
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 22:17:49 2018 -0500

    [cmap] Move code around

 src/hb-ot-cmap-table.hh | 18 ++++++++++--------
 1 file changed, 10 insertions(+), 8 deletions(-)

commit 758c9d68e2143493978d8ac8391f4af2a2abc26a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 22:16:12 2018 -0500

    [morx/kerx] Limit range to subtable when sanitizing

 src/hb-aat-layout-kerx-table.hh | 2 ++
 src/hb-aat-layout-morx-table.hh | 2 ++
 2 files changed, 4 insertions(+)

commit a9fe787a11fc391d9a43a4ea19e6eb1c474199bd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 22:12:36 2018 -0500

    [sanitizer] Add reset_object(), make set_object() do bounds-check

    Affects morx/kerx run-time only currently.  Will adjust their
    sanitize next.

 src/hb-aat-layout-kerx-table.hh |  1 +
 src/hb-aat-layout-morx-table.hh |  1 +
 src/hb-machinery.hh             | 30 +++++++++++++++++++-----------
 3 files changed, 21 insertions(+), 11 deletions(-)

commit 2c8188bf599e351a4e0804d74612f9643b3d2443
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 22:02:19 2018 -0500

    [kerx] Make sure subtables are non-zero-length

    Fixes https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=11400

 src/hb-aat-layout-kerx-table.hh                          |   1 +
 src/hb-aat-layout-morx-table.hh                          |   2 +-
 ...z-testcase-minimized-hb-shape-fuzzer-5722888989048832 | Bin 0 ->
 3608 bytes
 3 files changed, 2 insertions(+), 1 deletion(-)

commit a9e0bdc35dfcbead7d4b6fa249d60ebedd7d43ca
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 21:30:04 2018 -0500

    [GSUB] Don't flush glyphset during recursion in closure()

    See comment.

    Supercedes https://github.com/harfbuzz/harfbuzz/pull/1401
    Fixes https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=11366

 src/hb-ot-layout-gsub-table.hh | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 8982830d3ec54f50cc951de9569520fafc735e75
Author: Garret Rieger <grieger@google.com>
Date:   Mon Nov 19 13:00:24 2018 -0800

    [subset] add fuzzer testcase.

 ...z-testcase-minimized-hb-subset-fuzzer-5067936541179904 | Bin 0 ->
 172 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit d0e81b2cc85d09d01905c5fc5b3382c25eaa3bb3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 21:20:39 2018 -0500

    [set] Rename

 src/hb-set.hh | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit e866910579e9cdc5b1ffa2e401fd0c056d44ca6a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 18:07:59 2018 -0500

    Enforce requiring null_size even if min_size is 0

    This concludes null-size enforcement changes

 src/hb-null.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4d4fd64ff47da04a7008d410c92e8fb4ad970781
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Nov 22 18:07:36 2018 -0500

